﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
'Class module

Sub Class_Globals
	Private ws As WebSocket 'ignore
	' will hold our page information
	Public page As ABMPage
	' page theme
	Private theme As ABMTheme
	' to access the constants
	Private ABM As ABMaterial 'ignore
	' name of the page, must be the same as the class name (case sensitive!)
	Public Name As String = "frmCarousel"  '<-------------------------------------------------------- IMPORTANT
	Private ABMPageId As String = ""
	' your own variables
	Dim Origin As String = "http://localhost:51049" '<--- IMPORTANT for youtube videos.  Set here your website address
	' the download folder
	Public DownloadFolder As String = "/www/" & ABMShared.AppName & "/uploads/"
	Public DownloadMaxSize As String = 1000000*1024
	Private myToastId As Int
	Private dbAction As Map
	Private ActiveID As Int
	Private IsNew As Boolean
	Private Filter As String
	Private LastSort As String
	Private FilterCount As String
	Private OldValue As String
	Public MaxRows As Int
'	Public mashc1 As MashCarousel
'	Public mashc2 As MashCarousel
'	Public mashc3 As MashCarousel
'	Public chips1 As MashChips
'	Public chips2 As MashChips
'	Public chips3 As MashChips
'	Public alert As MashAlert
'	Public alert1 As MashAlert
'	Public alert2 As MashAlert
'	Public alert3 As MashAlert
'	Public alert4 As MashAlert
'	Public profile As MashCard
'	Public blog As MashCard
'	Public blog1 As MashCard
'	Public price As MashCard
'	Public stats As MashStats
'	Public tasks As MashTasks
'	Public projects As MashProjects
'	Public issues As MashIssues
'	Public pricingTable As MashPricingTable
'	Public email As MashEmail
'	Public mashtable As MashTable
'	Public jqPlot As MashJQPlot
'	Public flip As MashSplitFlap
'	Public rs1 As MashRangeSlider
'	Public rs2 As MashRangeSlider
'	Public rs3 As MashRangeSlider
'	Public rs4 As MashRangeSlider
'	Public rs5 As MashRangeSlider
'	Public rs6 As MashRangeSlider
'	Public rs7 As MashRangeSlider
'	Public rs8 As MashRangeSlider
'	Public rs9 As MashRangeSlider
'	Public rs10 As MashRangeSlider
'	Public txtValue As ABMInput
'	Public rs11 As MashRangeSlider
'	'Dim CTCard As MashCTStats
'	'Dim CTCard1 As MashCTStats
'	'Dim CTCard2 As MashCTStats
'	'Dim CTCard3 As MashCTStats
'	Public mashgallery As MashGallery
'	Public mashalbum As MashGallery
'	Public mashcc As MashCreditCard
'	'Public design As MashDesigner
'	Public dbButton As MashDashboardButton
'	Public dbButton1 As MashDashboardButton
'	Public dbButton2 As MashDashboardButton
'	Public dbButton3 As MashDashboardButton
'	Public pillB1 As MashPillButton
'	Public pillB2 As MashPillButton
'	Public pillB3 As MashPillButton
'	Public pillB4 As MashPillButton
'	Public bg As MashButtonGroup
'	Public bgv As MashButtonGroup
'	Public bgc As MashButtonGroup
'	Public bgf As MashButtonGroup
'	Public bghc As MashButtonGroup
'	Public bgcu As MashButtonGroup
'	Public bgcl As MashButtonGroup
'	Public bgcr As MashButtonGroup
'	Public bgcd As MashButtonGroup
'	Public bgvf As MashButtonGroup
'	Public mashp As MashProgress
'	Public badge As MashBadgeOn
'	'Public pnl As MashPanel
'	Public knob As MashDial
'	Public knob1 As MashDial
'	Public knob2 As MashDial
'	Public knob3 As MashDial
'	Public knob4 As MashDial
'	Public knob5 As MashDial
'	Private totRows As Int
	Public img As MashImage
'	Public img1 As MashImage
'	Public imgs As MashUserStatus
'	Public imgd As MashUserStatus
'	Public imga As MashUserStatus
'	Public ribbon As MashRibbon
'	Public mlistView As MashListView
'	'Public mcp3 As MashColorPicker
'	Public msd As MashSimpleDiagram
'	Dim myTableGrid As ABMTableGrid
	' fake database
	Dim database As Map
'	Dim mgb As MashGlowingBirds
'	Dim mms As MashMultiSelect
	Dim mll As MashLeafLet
End Sub
'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize()
	' build the local structure IMPORTANT!
	BuildPage
End Sub

Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
	Log("Connected")
	ws = WebSocket1
	'SetMaxTextMessage(2048000)
	ABMPageId = ABM.GetPageID(page, Name,ws)
	Dim session As HttpSession = ABM.GetSession(ws, ABMShared.SessionMaxInactiveIntervalSeconds)
	If session.IsNew Then
		session.Invalidate
		ABMShared.NavigateToPage(ws, "", "./")
		Return
	End If
	If ABMShared.NeedsAuthorization Then
		If session.GetAttribute2("IsAuthorized", "") = "" Then
			ABMShared.NavigateToPage(ws, ABMPageId, "../")
			Return
		End If
	End If
	ABM.UpdateFromCache(Me, ABMShared.CachedPages, ABMPageId, ws)
	If page.ComesFromPageCache Then
		' when we have a page that is cached it doesn't matter if it comes or not from a new connection we serve the cached version.
		Log("Comes from cache")
		page.Refresh
		page.FinishedLoading
	Else
		If page.WebsocketReconnected Then
			Log("Websocket reconnected")
			ABMShared.NavigateToPage (ws, ABMPageId, "./" & page.PageHTMLName)
		Else
			' when the client did not reconnected it doesn't matter if the session was new or not because this is the websockets first connection so no dynamic content in the browser ... we are going to serve the dynamic content...
			Log("Websocket first connection")
			page.Prepare
			ConnectPage
		End If
	End If
	Log(ABMPageId)
End Sub
Private Sub WebSocket_Disconnected()
	Log("Disconnected")
	Try
		ws.Session.RemoveAttribute("abmcallback")
		ws.Session.RemoveAttribute("abmdownloadfolder")
		ws.Session.RemoveAttribute("abmmaxsize")
	Catch
		Log(LastException.Message)
	End Try
End Sub
Sub Page_ParseEvent(Params As Map)
	Dim eventName As String = Params.Get("eventname")
	Dim eventParams() As String = Regex.Split(",",Params.Get("eventparams"))
	If eventName = "beforeunload" Then
		Log("preparing for url refresh")
		ABM.RemoveMeFromCache(ABMShared.CachedPages, ABMPageId)
		Return
	End If
	Dim caller As Object = page.GetEventHandler(Me, eventName)
	If caller = Me Then
		If SubExists(Me, eventName) Then
			Params.Remove("eventname")
			Params.Remove("eventparams")
			' BEGIN NEW DRAGDROP
			If eventName = "page_dropped" Then
				page.ProcessDroppedEvent(Params)
			End If
			' END NEW DRAGDROP
			Select Case Params.Size
				Case 0
					CallSub(Me, eventName)
				Case 1
					CallSub2(Me, eventName, Params.Get(eventParams(0)))
				Case 2
					If Params.get(eventParams(0)) = "abmistable" Then
						Dim PassedTables As List = ABM.ProcessTablesFromTargetName(Params.get(eventParams(1)))
						CallSub2(Me, eventName, PassedTables)
					Else
						CallSub3(Me, eventName, Params.Get(eventParams(0)), Params.Get(eventParams(1)))
					End If
				Case Else
					' cannot be called directly, to many param
					CallSub2(Me, eventName, Params)
			End Select
		End If
	Else
		CallSubDelayed2(caller, "ParseEvent", Params) 'ignore
	End If
End Sub

public Sub BuildTheme()
	' start with the base theme defined in ABMShared
	theme.Initialize("pagetheme")
	theme.AddABMTheme(ABMShared.MyTheme)
	' add additional themes specific for this page
	theme.Page.BackColor = ABM.COLOR_TRANSPARENT
	theme.Page.BackColorIntensity = ABM.INTENSITY_NORMAL
	theme.Page.ConnectedIndicatorColor = ABM.COLOR_GREEN
	theme.Page.ConnectedIndicatorColorIntensity = ABM.INTENSITY_NORMAL
	theme.Page.DisconnectedIndicatorColor = ABM.COLOR_RED
	theme.Page.DisconnectedIndicatorColorIntensity = ABM.INTENSITY_NORMAL
	theme.Page.PlaceHolderColor = ABM.COLOR_GREY
	theme.Page.PlaceHolderColorIntensity = ABM.INTENSITY_NORMAL
	
	'theme for the row
	theme.AddRowTheme("RowTheme")
	theme.Row("RowTheme").clickable = True
	theme.Row("RowTheme").backcolorintensity = ABM.INTENSITY_LIGHTEN5
	theme.Row("RowTheme").bordercolor = ABM.COLOR_BLACK
	theme.Row("RowTheme").borderwidth = 1
	theme.Row("RowTheme").backcolor = ABM.COLOR_GREY
	theme.Row("RowTheme").borderstyle = ABM.BORDER_DASHED
	
	'theme for the cell
	theme.AddCellTheme("celltheme")
	theme.Cell("celltheme").clickable = True
	theme.Cell("celltheme").borderradiuspx = 2
	theme.Cell("celltheme").zdepth = ABM.ZDEPTH_DEFAULT
	theme.Cell("celltheme").backcolorintensity = ABM.INTENSITY_LIGHTEN5
	theme.Cell("celltheme").bordercolor = ABM.COLOR_BLACK
	theme.Cell("celltheme").borderwidth = 1
	theme.Cell("celltheme").backcolor = ABM.COLOR_LIGHTBLUE
	theme.Cell("celltheme").borderstyle = ABM.BORDER_DASHED
	
	theme.AddCellTheme("black")
	theme.Cell("black").BackColor = ABM.color_black
End Sub
public Sub BuildPage()
	' initialize the theme
	BuildTheme
	
	'page.DebugConsoleEnable(True, 300)
	'page.DebugConsoleB4JStart
	
	' initialize this page using our theme
	page.InitializeWithTheme(Name, "/ws/" & ABMShared.AppName & "/" & Name, False, ABMShared.SessionMaxInactiveIntervalSeconds, theme)
	page.ShowLoader=True
	page.ShowLoaderType=ABM.LOADER_TYPE_MANUAL
	page.SetLoaderHEARTBEAT(ABM.INTENSITY_NORMAL,ABM.INTENSITY_NORMAL,ABM.COLOR_WHITE,ABM.COLOR_RED,ABM.COLOR_GREY,ABM.COLOR_GREY,ABM.INTENSITY_NORMAL,ABM.INTENSITY_NORMAL)
	page.PageHTMLName = "frmCarousel.html"
	page.PageTitle = "Ask TeenCoach"
	page.PageDescription = ""
	page.PageKeywords = ""
	page.PageSiteMapPriority = "0.50"
	page.PageSiteMapFrequency = ABM.SITEMAP_FREQ_MONTHLY
	'page.UseFontAwesome = False
	page.DisableBackButton = False
	'page.UseGoogleAnalytics(ABMShared.TrackingID, Null) ' IMPORTANT Change this to your own TrackingID !!!!!!!
	'page.GoogleMapsAPIExtras = ABMShared.GoogleMapsAPIExtras
	page.IsFixedFooter = False
	page.DisablePageReloadOnSwipeDown = True
	page.ShowConnectedIndicator = True
	page.PageLanguage = "en"
	page.AlwaysShowVerticalScrollBar = False
	
	'MashPlugIns.NeedsSimpleDiagram(page)
	'MashPlugIns.NeedsJSGrid(page)
	'MashPlugIns.NeedsPushJS(page)
	'MashPlugIns.NeedsJCircle(page)
	'MashPlugIns.NeedsText2UML(page)
	'MashPlugIns.NeedsFlowChart(page)
	
	'MashPlugIns.NeedsJSGantt(page)
	'page.AddExtraJavaScriptFile("http://ajax.googleapis.com/ajax/libs/jquery/1.8.2/jquery.min.js")
	'page.AddExtraJavaScriptFile("https://cdnjs.cloudflare.com/ajax/libs/jquery/3.3.1/jquery.slim.js")
	'MashPlugIns.NeedsSliceBox(page)
	
	'page.AddExtraJavaScriptFile("http://cdnjs.cloudflare.com/ajax/libs/raphael/2.2.0/raphael-min.js")
	'page.AddExtraJavaScriptFile("http://cdnjs.cloudflare.com/ajax/libs/jquery/1.11.0/jquery.min.js")
	'page.AddExtraJavaScriptFile("http://flowchart.js.org/flowchart-latest.js")
	
	
	'page.NeedsCanvas = True
	'page.NeedsSVGSurface = True
	'MashPlugIns.NeedsIntro(page)
	'MashPlugIns.NeedsAnimation(page)
	'MashPlugIns.NeedsSparkLine(page)
	'MashPlugIns.NeedsMaterialize(page)
	'MashPlugIns.NeedsDataTable(page)
	'MashPlugIns.NeedsDateDropper(page)
	'MashPlugIns.NeedsTimeDropper(page)
	'MashPlugIns.NeedsJQPlot(page)
	'MashPlugIns.NeedSplitFlap(page)
	'MashPlugIns.NeedsFlowChart(page)
	'MashPlugIns.NeedsRangeSlider(page)
	'MashPlugIns.NeedsCreativeTim(page)
	'MashPlugIns.NeedsJGallery(page)
	'MashPlugIns.NeedsCreditCard(page)
	'MashPlugIns.NeedsProgress(page)
	'MashPlugIns.NeedsDial(page)
	'MashPlugIns.NeedsInfoBox(page)
	'MashPlugIns.NeedsColorPicker(page)
	'MashPlugIns.NeedsMashPlugIns(page)

	'page.AddExtraJavaScriptFile("http://cdnjs.cloudflare.com/ajax/libs/jquery/2.0.3/jquery.min.js")
	'page.AddExtraJavaScriptFile("http://cdnjs.cloudflare.com/ajax/libs/raphael/2.1.2/raphael-min.js")
	 'page.AddExtraCSSFile("http://cdnjs.cloudflare.com/ajax/libs/morris.js/0.5.1/morris.css")
	'page.AddExtraJavaScriptFile("http://cdnjs.cloudflare.com/ajax/libs/morris.js/0.5.1/morris.min.js")
	
	'MashPlugIns.NeedsMorrisChart(page)
	'MashPlugIns.NeedsMashFrappeChart(page)
	'MashPlugIns.NeedsFrappeGantt(page)
	'MashPlugIns.NeedsMashMultiSelect(page)
	MashPlugIns.NeedsLeafLet(page)
	
	
	
	' adding a navigation bar
	Dim sbtopimg As ABMImage
	sbtopimg.Initialize(page, "sbtopimg", "../images/logo.png?" & DateTime.Now, 1)
	sbtopimg.IsCircular = False
	sbtopimg.SetFixedSize(236, 49)
	page.NavigationBar.Initialize(page, "navBar", ABM.SIDEBAR_MANUAL_ALWAYSHIDE, "Ask {C:#000000}Teen{/C}{C:#993333}Coach{/C}", True, True, 330, 48, sbtopimg, ABM.COLLAPSE_ACCORDION, "")
	page.NavigationBar.SideBarSubItemsArrowUnicodeChar = ""
	page.NavigationBar.SideBarLogoHeight = 49
	page.NavigationBar.TopBarDropDownConstrainWidth = True
	' you must add at least ONE dummy item if you want to add items to the topbar in ConnectNaviagationBar
	page.NavigationBar.AddTopItem("DUMMY", "{NBSP}", "", "", False)
	' you must add at least ONE dummy item if you want to add items to the sidebar
	'ABMShared.AddSideBarItem(page,"DUMMY", "{NBSP}", "", "", "0", "0")
	page.ShowGridInfo = False
	' create the page grid
	'page.AddRowsM(3, True,0,0,"").AddCellsOSMP(12,0,0,0,12,12,12,0,0,0,0,"")
	'page.AddRows(20, True, "").AddCellsOSMP(3,0,0,0,6,6,6,0,0,0,0,"")
	
	page.AddRowsM2(2,False,10,0,10,10,"").AddCells12MP(1,0,0,0,0,"")
	page.AddRowsM2(20,False,10,0,10,10,"").AddCellsOSMP(2,0,0,0,6,6,6,0,0,0,0,"")
	
	page.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
	' add a error box template if the name is not entered
	'page.AddModalSheetTemplate(ABMShared.BuildWrongInputModalSheet(page))
	' add a modal sheet template for a yes no msgbox
	'page.AddModalSheetTemplate(ABMShared.BuildMsgBoxYesNo(page))
	' add a modal sheet template for a  msgbox
	'page.AddModalSheetTemplate(ABMShared.BuildMsgBox(page))
	
	
End Sub







'a row toolbar is clicked


'a row toolbar is clicked


Sub msgyes_Clicked(Target As String)
	Dim msg As ABMModalSheet = page.ModalSheet("confirm")
	Dim msgyes As ABMButton = msg.Footer.Component("msgyes")
	Dim strTag As String
	strTag = msgyes.Tag
	page.CloseModalSheet("confirm")
End Sub
Sub msgok_Clicked(Target As String)
	page.CloseModalSheet("msgbox")
End Sub
Sub msgno_Clicked(Target As String)
	page.CloseModalSheet("confirm")
End Sub
' clicked on the navigation bar
Sub Page_NavigationbarClicked(Action As String, Value As String)
	page.SaveNavigationBarPosition
	If Action = "LogOff" Then
		ABMShared.LogOff(page)
		Return
	End If
	Select Case Action.ToLowerCase
End Select
ABMShared.NavigateToPage(ws, ABMPageId, Value)
End Sub
Sub Page_FileUploaded(FileName As String, success As Boolean)
	myToastId = myToastId + 1
	If success Then
		page.ShowToast("toast" & myToastId, "toastgreen", "File " & FileName & " uploaded!", 3000, False)
	Else
		page.ShowToast("toast" & myToastId, "toastred", "File " & FileName & " not uploaded!", 3000, False)
	End If
	Dim actualFile As String = File.combine(File.DirApp, DownloadFolder & FileName)
	page.ws.Flush ' IMPORTANT
End Sub
Sub Page_ToastDismissed(ToastId As String)
End Sub
Sub Page_ToastClicked(ToastId As String, Action As String)
	page.DismissToast(ToastId)
End Sub
Sub page_NavigationbarSearch(search As String)
End Sub

Sub chips1_chipdelete(value As Map)
	Dim valuex As String = value.Get("value")
	page.Msgbox("",valuex,"","OK",False,"","")
End Sub

Sub mashc1_click(value As Map)
	Dim valuex As String = value.Get("value")
	page.Msgbox("",valuex,"","OK",False,"","")
End Sub

Sub chips1_chipadd(value As Map)
	Dim valuex As String = value.Get("value")
	page.Msgbox("",valuex,"","OK",False,"","")
End Sub

Sub chips1_chipselect(value As Map)
	Dim valuex As String = value.Get("value")
	page.Msgbox("",valuex,"","OK",False,"","")
End Sub

'Sub alert_click(value As Map)
'	Dim valuex As String = value.Getdefault("value","")
'	'page.Msgbox("",valuex,"","OK",False,"","")
'	Select Case valuex
'	Case "ok"
'			alert.Animate(MashPlugIns.Anime.Specials_hinge,False,alert.hidescript)
'	Case "cancel"
'		page.Msgbox("",valuex,"","OK",False,"","")
'	Case "close"
'		'page.Msgbox("",valuex,"","OK",False,"","")
'	End Select
'End Sub

'Sub alert1_click(value As Map)
'	Dim valuex As String = value.Getdefault("value","")
'	Select Case valuex
'		Case "ok"
'			alert1.Animate(MashPlugIns.Anime.Fading_Exits_fadeOut,False,alert1.hidescript)
'		Case "cancel"
'			page.Msgbox("",valuex,"","OK",False,"","")
'		Case "close"
'			'page.Msgbox("",valuex,"","OK",False,"","")
'	End Select
'End Sub

'Sub alert2_click(value As Map)
'	Dim valuex As String = value.Getdefault("value","")
'	Select Case valuex
'		Case "ok"
'			alert2.Animate(MashPlugIns.Anime.Attention_Seekers_swing,False,"")
'		Case "cancel"
'			page.Msgbox("",valuex,"","OK",False,"","")
'		Case "close"
'			'page.Msgbox("",valuex,"","OK",False,"","")
'	End Select
'End Sub


'Sub alert3_click(value As Map)
'	Dim valuex As String = value.Getdefault("value","")
'	'page.Msgbox("",valuex,"","OK",False,"","")
'	Select Case valuex
'		Case "ok"
'			alert3.Animate(MashPlugIns.Anime.Zoom_Exits_zoomOutLeft,False,alert3.hidescript)
'		Case "cancel"
'			page.Msgbox("",valuex,"","OK",False,"","")
'		Case "close"
'	End Select
'End Sub


'Sub alert4_click(value As Map)
'	Dim valuex As String = value.Getdefault("value","")
'	Select Case valuex
'		Case "ok"
'			alert4.Animate(MashPlugIns.Anime.Bouncing_Exits_bounceOutUp,False, alert4.hidescript)
'		Case "cancel"
'			page.Msgbox("",valuex,"","OK",False,"","")
'		Case "close"
'	End Select
'End Sub

Sub blog_click(value As Map)
	Dim valuex As String = value.Getdefault("value","")
	page.Msgbox("",valuex,"","OK",False,"","")
End Sub

Sub blog1_click(value As Map)
	Dim valuex As String = value.Getdefault("value","")
	page.Msgbox("",valuex,"","OK",False,"","")
End Sub

Sub price1_click(value As Map)
	Dim valuex As String = value.Getdefault("value","")
	page.Msgbox("",valuex,"","OK",False,"","")
End Sub

Sub stats_click(value As Map)
	Dim valuex As String = value.Getdefault("value","")
	page.Msgbox("",valuex,"","OK",False,"","")
End Sub

Sub tasks_click(value As Map)
	Dim valuex As String = value.GetDefault("value","")
	page.Msgbox("",valuex,"","OK",False,"","")
End Sub

Sub tasks_change(value As Map)
	Dim valuex As String = value.GetDefault("value","")
	page.Msgbox("",valuex,"","OK",False,"","")
End Sub

'Sub projects_click(value As Map)
'	Dim valuex As String = value.GetDefault("value","")
'	page.Msgbox("",valuex,"","OK",False,"","")
'	Select Case valuex
'	Case "add"	
'	Case Else
'		'clear the issues
'		tasks.clear
'		issues.Clear
'	End Select
'End Sub

Sub issues_click(value As Map)
	Dim valuex As String = value.GetDefault("value","")
	page.Msgbox("",valuex,"","OK",False,"","")
End Sub

Sub pricetable_click(value As Map)
	Dim valuex As String = value.GetDefault("value","")
	page.Msgbox("",valuex,"","OK",False,"","")
End Sub

'Sub emails_click(value As Map)
'	Dim valuex As String = value.GetDefault("value","")
'	'clean the returned item from the component
'	Dim emailID As String = email.GetEmailID(valuex)
'	Dim emailAction As String = email.GetEmailAction(valuex)
'	Select Case emailAction
'	Case "replytoall"
'			page.Msgbox("","Your 'reply to all' code comes here.",emailID,"OK",False,"","")
'	Case "reply"
'			page.Msgbox("","Your 'reply to' code comes here.",emailID,"OK",False,"","")
'	Case "emailmenu"
'			page.Msgbox("","Your 'email menu' code comes here.",emailID,"OK",False,"","")
'	Case "forward"
'			page.Msgbox("","Your forwarding code comes here.",emailID,"OK",False,"","")
'	Case "menu"
'			page.Msgbox("",emailAction,"","OK",False,"","")
'		Case "search"
'			page.Msgbox("",emailAction,"","OK",False,"","")
'		Case "attach"
'			page.Msgbox("",emailAction,"","OK",False,"","")
'	Case "type"
'			page.Msgbox("",emailAction,"","OK",False,"","")
'		Case "archive"
'			page.Msgbox("",emailAction,"","OK",False,"","")
'		Case "delete"
'			page.Msgbox("",emailAction,"","OK",False,"","")
'		Case "content"
'			'page.Msgbox("",valuex,"","OK",False,"","")
'			email.clear
'			AddThemEmails
'			email.refresh
'		Case "navigate"
'			page.Msgbox("",emailAction,"","OK",False,"","")
'		Case "archives"
'			'update the navbar and update active item
'			email.clear
'			AddThemEmails
'			email.refresh
'			email.SetSideBarItem(emailAction)
'		Case "socialgroup"
'			'update the navbar and update active item
'			email.clear
'			email.SetSideBarItem(emailAction)
'		Case "mapslocaloffer"
'			'update the navbar and update active item
'			email.clear
'			email.SetSideBarItem(emailAction)
'		Case "alerterror"
'			'update the navbar and update active item
'			email.clear
'			email.SetSideBarItem(emailAction)
'		Case Else
'			email.View(emailID)
'	End Select
'End Sub

'Sub AddThemEmails
'	email.AddSocial("anele@mbangas.com","Someone likes you on FaceBook","Hi{BR}{BR}Anele Mashy Mbanga has liked your profile picture.","4",True)
'	email.AddPromotion("anele@mbangas.com","Anywhere Software has released B4J 6 Beta, you should try it out.", _
'	"Good day{BR}{BR}An amazing new beta update to the free B4J app from Anywhere Software has been released.", "1",True)
'	email.AddUpdates("anele@mbangas.com","Windows 10 Update","Mashy{BR}{BR}We have noticed that you are still running Windows 7, don't you want to update to Windows 10?.", "7",False)
'	
'	email.AddEmail("1","Anele Mbanga","xolani@mbangas.com", _
'	"This is a test email","Content: This is a test email","12:03 am",False,"../images/sponge.png",True,"",False,"")
'	email.AddEmail("2","Usibabale Mbanga","anele@mbangas.com", _
'	"Daddy, I have finished my exams for the year.","Content: Daddy, I have finished by exams for the year.","12:03 am",True,"",False,"",False,"")
'	email.AddEmail("3","Olothando Mbanga","anele@mbangas.com", _
'	"It has been a lovely day today.","Content: It has been a lovely day today.","13:05 am",False,"",False,"",False,"")
'	email.AddEmail("4","Esona Mbanga","anele@mbangas.com", _
'	"Daddy, when can we watch movies, you need to take a break", _
'	"Content: Daddy, when can we watch movies, you need To take a break","09:03 am",False,"",False,"",False,"")
'End Sub

'Sub mashtable_delete(value As Map)
'	Dim valuex As String = value.GetDefault("value","")
'	Dim valuem As Map = mashtable.RowToMap(valuex)
'	page.Msgbox("",valuem,"Delete","OK",True,"","")
'End Sub

'Sub mashtable_insert(value As Map)
'	Dim valuex As String = value.GetDefault("value","")
'	Dim valuem As Map = mashtable.RowToMap(valuex)
'	page.Msgbox("",valuem,"Insert","OK",True,"","")
'End Sub

'Sub mashtable_update(value As Map)
'	Dim valuex As String = value.GetDefault("value","")
'	Dim valuem As Map = mashtable.RowToMap(valuex)
'	page.Msgbox("",valuem,"Update","OK",True,"","")
'End Sub

'Sub rs1_change(value As Map)
'	Dim valuex As String = value.GetDefault("value","")
'	txtValue.Text = valuex
'	txtValue.refresh
'End Sub

Sub mashgallery_click(value As Map)
	Dim valuex As String = value.GetDefault("value","")
	page.Msgbox("",valuex,"Update","OK",True,"","")
End Sub

Sub bg_click(value As Map)
	Dim valuex As String = value.GetDefault("value","")
	page.Msgbox("",valuex,"Button Group","OK",True,"","")
End Sub

Sub bgv_click(value As Map)
	Dim valuex As String = value.GetDefault("value","")
	page.Msgbox("",valuex,"Button Group","OK",True,"","")
End Sub

Sub bgc_click(value As Map)
	Dim valuex As String = value.GetDefault("value","")
	page.Msgbox("",valuex,"Button Group","OK",True,"","")
End Sub

Sub pillB1_click(value As Map)
	Dim valuex As String = value.GetDefault("value","")
	page.Msgbox("",valuex,"Button","OK",True,"","")
End Sub

Sub pillB2_click(value As Map)
	Dim valuex As String = value.GetDefault("value","")
	page.Msgbox("",valuex,"Button","OK",True,"","")
End Sub

Sub pillB3_click(value As Map)
	Dim valuex As String = value.GetDefault("value","")
	page.Msgbox("",valuex,"Button","OK",True,"","")
End Sub

Sub dbButton1_click(value As Map)
	Dim valuex As String = value.GetDefault("value","")
	page.Msgbox("",valuex,"Button","OK",True,"","")
End Sub

Sub dbButton_click(value As Map)
	Dim valuex As String = value.GetDefault("value","")
	page.Msgbox("",valuex,"Button","OK",True,"","")
End Sub

Sub dbButton2_click(value As Map)
	Dim valuex As String = value.GetDefault("value","")
	page.Msgbox("",valuex,"Button","OK",True,"","")
End Sub

Sub bghc_click(value As Map)
	Dim valuex As String = value.GetDefault("value","")
	page.Msgbox("",valuex,"Button Group","OK",True,"","")
End Sub

Sub bgcu_click(value As Map)
	Dim valuex As String = value.GetDefault("value","")
	page.Msgbox("",valuex,"Button Group","OK",True,"","")
End Sub

Sub pnl_click(value As Map)
	Dim valux As String = value.getdefault("value","")
	Select Case valux
	Case "collapse"
	Case "settings"
	Case "close"
		'pnl.Animate(MashPlugIns.Anime.Bouncing_Exits_bounceOutLeft,False,pnl.Hide) 
	End Select
End Sub


'multi select events
'Sub mms_select(value As Map)
'	'get the selected values
'	Dim valuex As String = value.GetDefault("value","")
'	'ensure that our selection is updated, the second parameter should be true
'	mms.UpdateSelection(valuex,True)
'	Log(mms.GetSelection)
'	'page.Msgbox("",valuex,"Select","OK",False,"","")
'End Sub


'Sub mms_deselect(value As Map)
'	'get the selected values
'	Dim valuex As String = value.GetDefault("value","")
'	'ensure that our selection is updated, this time remove the de-selection
'	mms.UpdateSelection(valuex,False)
'	Log(mms.GetSelection)
'	'page.Msgbox("",valuex,"DeSelect","OK",False,"","")
'End Sub

Sub knob_change(value As Map)
	Dim valuex As String = value.GetDefault("value","")
	'page.Msgbox("",valuex,"","OK",False,"","")
End Sub

Sub knob1_change(value As Map)
	'Dim knobv As String = knob.GetValue
	'page.Msgbox("",knobv,"","OK",False,"","")
End Sub

Sub images_click(value As Map)
	Dim valuex As String = value.GetDefault("value","")
	page.Msgbox("",valuex,"","OK",False,"","")
End Sub

Sub statusimage_click(value As Map)
	Dim valuex As String = value.GetDefault("value","")
	page.Msgbox("",valuex,"","OK",False,"","")
End Sub

Sub ribbon_click(value As Map)
	Dim valuex As String = value.GetDefault("value","")
	page.Msgbox("",valuex,"","OK",False,"","")
End Sub

Sub mlistView_click(value As Map)
	Dim valuex As String = value.Get("value")
	page.Msgbox("",valuex,"","OK",False,"","")
End Sub

Sub mp_click(value As Map)
	Dim valuex As String = value.Get("value")
	page.Msgbox("",valuex,"","OK",False,"","")
End Sub

Sub infobox_click(value As Map)
	Dim valuex As String = value.Get("value")
	page.Msgbox("",valuex,"","OK",False,"","")
End Sub

Sub apple_click(value As Map)
	Dim valuex As String = value.Get("value")
	page.Msgbox("",valuex,"","OK",False,"","")
End Sub

Sub mib1_click(value As Map)
	Dim valuex As String = value.Get("value")
	page.Msgbox("",valuex,"","OK",False,"","")
End Sub

Sub applepanel_click(value As Map)
	Dim valuex As String = value.Get("value")
	page.Msgbox("",valuex,"","OK",False,"","")
End Sub

Sub ma_click(value As Map)
	Dim valuex As String = value.Get("value")
	page.Msgbox("",valuex,"","OK",False,"","")
End Sub

Sub ma1_click(value As Map)
	Dim valuex As String = value.Get("value")
	Select Case valuex
	Case "warning"
	Case Else
		page.Msgbox("",valuex,"","OK",False,"","")
	End Select
End Sub

Sub ma2_click(value As Map)
	Dim valuex As String = value.Get("value")
	page.Msgbox("",valuex,"","OK",False,"","")
End Sub

Sub mcp3_change(value As Map)
	Dim valuex As String = value.Get("value")
	'Dim val As String = mcp3.GetColor
	'Log(val)
End Sub

Sub SmallGrid
	'intro
	
	'small 62
	'large 97
	'medium 81
	Dim small As MashSimpleDiagram
	small.Initialize(page,"small",12,12,62,True)
	'row 1
	small.AddBox(1,1,12,1)
	small.AddLabel1(1,1,$".AddCells12(1,"")"$)
	
	'row 2
	small.AddBox(2,1,6,1)
	small.AddBox(2,7,6,1)
	small.AddLabel1(2,1,$".AddCellOS(2,0,0,0,6,6,6,"")"$)
	small.AddLabel1(2,7,$" [OR] .AddCellOS(1,0,0,0,6,6,6,"") X 2"$)
	
	'row 3
	small.AddBox(3,1,5,1)
	small.AddBox(3,6,7,1)
	small.AddLabel1(3,1,$".AddCellOS(1,0,0,0,5,5,5,"")"$)
	small.AddLabel1(3,6,$".AddCellOS(1,0,0,0,7,7,7,"")"$)
	'row 4
	small.AddBox(4,1,4,1)
	small.AddBox(4,5,8,1)
	'row 5
	small.AddBox(5,1,3,1)
	small.AddBox(5,4,9,1)
	
	'row 6
	small.AddCellRCOS(6,1,0,2)
	small.AddCellRCOS(6,3,0,10)
	small.AddLabel1(6,3,$".AddCellOS(1,0,0,0,2,2,2,"").AddCellOS(1,0,0,0,10,10,10,"")"$)
	
	'row 7
	small.AddCellRCOS(7,1,0,1)
	small.AddCellRCOS(7,2,0,9)
	small.AddCellRCOS(7,11,0,2)
	small.AddLabel1(7,2,$".AddCellOS(1,0,0,0,1,1,1,"").AddCellOS(1,0,0,0,9,9,9,"").AddCellOS(1,0,0,0,2,2,2,"")"$)
	
	'row 8
	small.AddCellRCOS(8,1,0,11)
	small.AddCellRCOS(8,12,0,1)
	
	'row 9
	small.AddCellRCOS(9,1,0,10)
	small.AddCellRCOS(9,11,0,2)
	
	'row 10
	small.AddCellRCOS(10,1,0,9)
	small.AddCellRCOS(10,10,0,3)
	
	'row 11
	small.AddCellRCOS(11,1,0,8)
	small.AddCellRCOS(11,9,0,4)
	small.AddLabel1(11,1,$".AddCellOS(1,0,0,0,8,8,8,"").AddCellOS(1,0,0,0,4,4,4,"")"$)
	
	
	'row 12
	small.AddCellRCOS(12,1,0,7)
	small.AddCellRCOS(12,8,0,5)
	
	page.Cell(2,1).AddComponent(small.ABMComp)
End Sub

Sub Offsets
	Dim offset As MashSimpleDiagram
	offset.Initialize(page,"offset",12,12,62,True)
	
	offset.AddBox(1,1,12,1)
	offset.AddLabel1(1,1,$".AddCells12(1,"") i.e. 1R=12C"$)
	
	offset.AddCellRCOS(2,1,1,11)
	offset.AddLabel1(2,2,$".AddCellOS(1,1,1,1,11,11,11,"") i.e. 1+11=12"$)

	offset.AddCellRCOS(3,1,2,10)
	offset.AddLabel1(3,3,$".AddCellOS(1,2,2,2,10,10,10,"") i.e. 2+10=12"$)

	offset.AddCellRCOS(4,1,0,2)
	offset.AddCellRCOS(4,3,8,2)
	offset.AddLabel1(4,3,$".AddCellOS(1,0,0,0,2,2,2,"").AddCellOS(1,8,8,8,2,2,2,"")"$)
	
	offset.AddLabel1(5,4,$"i.e. 2+8+2=12"$)
	
	page.Cell(2,1).AddComponent(offset.ABMComp)
	
End Sub

'check to see if speech command is available
Sub MashSpeechAvailable(pg As ABMPage) As Boolean
	Dim script As String = $"try {
  var SpeechRecognition = window.SpeechRecognition || window.webkitSpeechRecognition;
  var recognition = new SpeechRecognition();
  recognition.onstart = function() { 
  	b4j_raiseEvent('speech_start', {'value':'true'});
	}
recognition.onspeechend = function() {
  b4j_raiseEvent('speech_end', {'value':'true'});
}
recognition.onerror = function(event) {
  if(event.error == 'no-speech') {
    b4j_raiseEvent('speech_error', {'value':'true'}); 
  }
  }
  recognition.onresult = function(event) {
  // event is a SpeechRecognitionEvent object.
  // It holds all the lines we have captured so far. 
  // We only need the current one.
  var current = event.resultIndex;
  // Get a transcript of what was said.
  var transcript = event.results[current][0].transcript;
  var mobileRepeatBug = (current == 1 && transcript == event.results[0][0].transcript);
if(!mobileRepeatBug) {
	b4j_raiseEvent('speech_transcript', {'value':transcript}); 
}
}
  return true;
}
catch(e) {
 return false;
}"$
	Dim qe As Future = pg.ws.EvalWithResult(script,Null)
	Return qe.Value
End Sub

Sub MashSpeechStart(pg As ABMPage)
	Dim script As String = $"try {
    var SpeechRecognition = window.SpeechRecognition || window.webkitSpeechRecognition;
    var recognition = new SpeechRecognition();
    recognition.start();"$
	pg.ws.Eval(script,Null)
End Sub

Sub speech_start(value As Map)
	page.Msgbox("","Speech Start","","OK",False,"","")
End Sub

Sub speech_end(value As Map)
	page.Msgbox("","Speech End","","OK",False,"","")
End Sub

Sub speech_error(value As Map)
	page.Msgbox("","Speech Error","","OK",False,"","")
End Sub

Sub speech_transcript(value As Map)
	Dim ts As String = value.GetDefault("value","")
	page.Msgbox("","Speech Transcript","","OK",False,"","")
End Sub


Sub pushit_Clicked(Target As String)
	Dim bVoice As Boolean = MashSpeechAvailable(page)
	If bVoice = True Then
		MashPlugIns.MashSpeak(page,"Voice recognition activated. Try speaking into the microphone.",0.7)
	Else
		MashPlugIns.MashSpeak(page,"Voice recognition could not be activated.",0.7)
	End If
	'MashPlugIns.MashSpeak(page,"I have been developing A.B.M. web apps for a while now. It's an enjoyable experience.",0.7)
	'MashPlugIns.PushIt(page,"Mashy","This is a test!","../images/32.png","","mashy1")
	MashSpeechStart(page)
	
End Sub

Sub push_click(value As Map)
	Dim valuex As String = value.Get("value")
	page.Msgbox("",valuex,"","OK",False,"","")
End Sub

Sub push_error(value As Map)
	Dim valuex As String = value.Get("value")
	page.Msgbox("",valuex,"","OK",False,"","")
End Sub

'frappe gantt chart
Sub mgcx_click(value As Map)
	Dim valuex As String = value.Get("value")
	page.Msgbox("",valuex,"Click","OK",False,"","")
End Sub

Sub mgcx_datechange(value As Map)
	Dim valuex As String = value.Get("value")
	page.Msgbox("",valuex,"Date Change","OK",False,"","")
End Sub

Sub mgcx_progresschange(value As Map)
	Dim valuex As String = value.Get("value")
	page.Msgbox("",valuex,"Progress Change","OK",False,"","")
End Sub

Sub mgcx_viewchange(value As Map)
	Dim valuex As String = value.Get("value")
	page.Msgbox("",valuex,"View Change","OK",False,"","")
End Sub

Sub mll_geolocate(value As Map)
	Dim valuex As String = value.Get("value")
	page.Msgbox("",valuex,"Geolocate","OK",False,"","")
End Sub

Sub mll_error(value As Map)
	Dim valuex As String = value.Get("value")
	page.Msgbox("",valuex,"Error","OK",False,"","")
End Sub

Sub mll_clicked(value As Map)
	Dim valuex As String = value.Get("value")
	Dim latlng As LatLng = mll.Parse(valuex)
	mll.AddMarker(DateTime.Now,DateTime.Now,latlng.lat,latlng.lng)
	mll.refresh 
End Sub

Public Sub ConnectPage()
	'connect navigation bar
	ConnectNavigationBar
	
	'Dim msb As MashSliceBox
	'msb.Initialize(page,"msb")
	'msb.AddSlide("1","Image 1 test","../images/1.jpg","image1","#",True)
	'msb.AddSlide("2","Image 2 text","../images/2.jpg","image2","#",False)
	'msb.AddSlide("3","Image 2 text","../images/3.jpg","image3","#",False)
	'msb.AddSlide("4","Image 2 text","../images/4.jpg","image4","#",False)
	'msb.AddSlide("5","Image 2 text","../images/5.jpg","image5","#",False)
	'msb.AddSlide("6","Image 2 text","../images/6.jpg","image6","#",False)
	'msb.AddSlide("7","Image 2 text","../images/7.jpg","image7","#",False)
	'File.WriteString(File.dirapp,"slicebox.txt",msb.HTML)
	
	
	mll.Initialize(page,"mll", 30.289, -97.74, 12)
	mll.ZDepth = ABM.ZDEPTH_1
	mll.Height = "500px"
	mll.MapBoxAccessToken = "xxx"
	'mll.MapBoxType = mll.EnumMapBoxType.MapBoxSatellite
	'add a marker
	'mll.AddMarker("m1","Anele Mashy Mbanga", 51.5, -0.09)
	'mll.AddMarker1("m1", "Anele Mashy Mbanga", 51.5, -0.09, "zoo", MashPlugIns.EnumColors.red, mll.EnumMarkerIconSize.large)
	'mll.AddMarker2("m2", "Green Marker", 51.4, -0.09,MashPlugIns.EnumColors.green)
	
	mll.AddMarker1("m1","<strong>Medium Rocket</strong>", 30.287, -97.72, mll.EnumMakiIcons.rocket,MashPlugIns.EnumColors.blue,mll.EnumMarkerIconSize.medium)
	mll.AddMarker1("m2","<strong>Large Beer</strong>", 30.31096, -97.74277, mll.EnumMakiIcons.beer,MashPlugIns.EnumColors.green,mll.EnumMarkerIconSize.large)
	mll.AddMarker1("m3","<strong>Small Warehouse</strong>", 30.31096, -97.74277, mll.EnumMakiIcons.warehouse,MashPlugIns.EnumColors.yellow,mll.EnumMarkerIconSize.small)
	mll.AddMarker1("m4","<strong>No Icon!</strong>", 30.308064585977814, -97.79387256712653, "",MashPlugIns.EnumColors.amber,"")
	mll.AddMarker("m5","<strong>No Color</strong>", 30.25173261265964, -97.69636890501715)
	 
	mll.OpenPopUp("m1")
	  
	'add a circle
	'mll.AddCircle("c1","<b>Hello world!</b><br />I am a popup.", 51.508, -0.11,ABM.COLOR_RED,1,ABM.COLOR_BLUE,0.5,200)
	'add a polygon
	'mll.AddPolygon("p1", "A nice polygon", False, ABM.COLOR_BROWN,3,1.0,ABM.COLOR_BROWN,0.2)
	'mll.AddPolygonMarker("p1", 51.509, -0.08)
	'mll.AddPolygonMarker("p1", 51.503, -0.06)
	'mll.AddPolygonMarker("p1", 51.51, -0.047)
	'add a popup
	'mll.AddPopUp("pop1","I am a standalone popup.", 51.7, -0.09)
	''mll.GeoLocate = True
	
	'add a polyline
	'mll.AddPolyLine("pl1","My poly line",False,ABM.COLOR_CYAN,3,1.0,ABM.COLOR_INDIGO,0.2)
	'mll.AddPolyLineMarker("pl1", 45.51, -122.68)
	'mll.AddPolyLineMarker("pl1", 37.77, -122.43)
	'mll.AddPolyLineMarker("pl1", 34.04, -118.2)
		
	Log(mll.GetScript)
	page.Cell(1,1).AddComponent(mll.ABMComp)
	
	
'	Dim mgcx As MashFrappeGantt
'	mgcx.Initialize(page,"mgcx")
'	mgcx.ViewMode = mgcx.EnumView.Week
'	mgcx.AddTask("Task 0","Redesign website","2018-10-01", "2018-10-08",20,"")
'	mgcx.AddTask("Task 1", "Write new content","2018-10-03", "2018-10-06",5, "Task 0")
'	mgcx.AddTask("Task 2", "Apply new styles","2018-10-04","2018-10-08",10,"Task 1")
'	mgcx.AddTask("Task 3", "Review", "2018-10-08", "2018-10-09", 5, "Task 2")
'	mgcx.AddTask("Task 4", "Deploy", "2018-10-08", "2018-10-10",0, "Task 2")
'	mgcx.AddTask("Task 5", "Go Live!", "2018-10-11", "2018-10-11",0, "Task 4")
'	'Log(mgcx.GetScript)
'	'page.cell(1,1).AddComponent(mgcx.ABMComp)
'	
'	mms.Initialize(page,"mms","500px")
'	mms.selectableHeader = "Items"
'	mms.selectionHeader = "Selection"
'	mms.keepOrder = True
'	mms.dblClick = False
'	mms.AddItem("elem_1","Element 1",True)
'	mms.AddItem("elem_2","Element 2",False)
'	mms.AddItem("elem_3","Element 3",False)
'	mms.AddItem("elem_4","Element 4",False)
'	mms.AddItem("elem_5","Element 5",False)
'	mms.AddItem("elem_6","Element 6",False)
'	'page.Cell(1,1).AddComponent(mms.ABMComp)
	
'	
'	'you can get this with DbUtils.ExecuteMaps
'	Dim records As List
'	records.Initialize
'	'records.Add(CreateMap("x": "2010 Q4", "y": 3, "z": 7))
'	records.Add(CreateMap("x": "2011 Q1", "y": 3, "z": 4))
'	records.Add(CreateMap("x": "2011 Q2", "y": 5, "z": 1))
'	records.Add(CreateMap("x": "2011 Q3", "y": 2, "z": 5))
'	records.Add(CreateMap("x": "2011 Q4", "y": 8, "z": 2))
'	 'records.Add(CreateMap("x": "2012 Q1", "y": 4, "z": 4))
'	 
'	 
'	Dim mfc As MashFrappeChart
'	mfc.Initialize(page,"mfc","1. Bar", 200)
'	mfc.ChartType = mfc.EnumFrappeChartType.Bar
'	mfc.SetXAxis("x",0)
'	mfc.AddSeries("a","Some data",mfc.EnumColor.red)
'	'mfc.DifferentColors = True
'	'add data
'	mfc.AddXY("Sun",18).AddXY("Mon",40).AddXY("Tue",30)
'	mfc.AddXY("Wed",35).AddXY("Thu",8).AddXY("Fri",52)
'	mfc.AddXY("Sat",17).AddXY("Sun",-4)
'	mfc.ZDepth = ABM.ZDEPTH_1
'	'page.cell(3,1).AddComponent(mfc.ABMComp)
'	 
'	Dim mfc1 As MashFrappeChart
'	mfc1.Initialize(page,"mfc1","2. Line", 200)
'	mfc1.ChartType = mfc1.EnumFrappeChartType.Line
'	mfc1.SetXAxis("x",0)
'	mfc1.AddSeries("a","Some data",mfc1.EnumColor.red)
'	'add data
'	mfc1.AddXY("Sun",18).AddXY("Mon",40).AddXY("Tue",30)
'	mfc1.AddXY("Wed",35).AddXY("Thu",8).AddXY("Fri",52)
'	mfc1.AddXY("Sat",17).AddXY("Sun",-4)
'	mfc1.ZDepth = ABM.ZDEPTH_1
'	'Log(mfc1.GetScript)
'	'page.cell(3,2).AddComponent(mfc1.ABMComp)
'	 
'	 
'	'more data sets
'	Dim mfc2 As MashFrappeChart
'	mfc2.Initialize(page,"mfc2","3. Line Multiple", 200)
'	mfc2.ChartType = mfc2.EnumFrappeChartType.Line
'	mfc2.SetXAxis("x",0)
'	mfc2.AddSeries("a","DS 1",mfc2.EnumColor.violet)
'	mfc2.AddSeries("b","DS 2",mfc2.EnumColor.lightgreen)
'	'add data
'	mfc2.AddXY2("Sun",18,30).AddXY2("Mon",40,50).AddXY2("Tue",30,-10)
'	mfc2.AddXY2("Wed",35,15).AddXY2("Thu",8,18).AddXY2("Fri",52,32)
'	mfc2.AddXY2("Sat",17,27).AddXY2("Sun",-4,14)	
'	mfc2.ZDepth = ABM.ZDEPTH_1
'	'change the dot size
'	mfc2.lineOptionsdotSize = 8
'	  'Log(mfc2.GetScript)
'	'page.cell(3,1).AddComponent(mfc2.ABMComp)
'	 
'	Dim mfc3 As MashFrappeChart
'	mfc3.Initialize(page,"mfc3","4. Bar - Values on Points", 200)
'	mfc3.ChartType = mfc2.EnumFrappeChartType.bar
'	mfc3.SetXAxis("x",0)
'	mfc3.AddSeries("a","DS 1",mfc3.EnumColor.lightgrey)
'	mfc3.AddSeries("b","DS 2",mfc3.EnumColor.darkgrey)
'	'add data
'	mfc3.AddXY2("Sun",18,30).AddXY2("Mon",40,50).AddXY2("Tue",30,-10)
'	mfc3.AddXY2("Wed",35,15).AddXY2("Thu",8,18).AddXY2("Fri",52,32)
'	mfc3.AddXY2("Sat",17,27).AddXY2("Sun",-4,14)	
'	mfc3.ZDepth = ABM.ZDEPTH_1
'	mfc3.valuesOverPoints = True
'	'Log(mfc3.GetScript)
'	'page.cell(3,2).AddComponent(mfc3.ABMComp)
'	
'	Dim mfc4 As MashFrappeChart
'	mfc4.Initialize(page,"mfc4","5. Area", 200)
'	mfc4.ChartType = mfc4.EnumFrappeChartType.area
'	mfc4.SetXAxis("x",0)
'	mfc4.AddSeries("a","DS 1",mfc4.EnumColor.brown)
'	mfc4.AddSeries("b","DS 2",mfc4.EnumColor.green)
'	'add data
'	mfc4.AddXY2("Sun",18,30).AddXY2("Mon",40,50).AddXY2("Tue",30,-10)
'	mfc4.AddXY2("Wed",35,15).AddXY2("Thu",8,18).AddXY2("Fri",52,32)
'	mfc4.AddXY2("Sat",17,27).AddXY2("Sun",-4,14)
'	mfc4.ZDepth = ABM.ZDEPTH_1
'	mfc4.lineOptionsheatline = True
'	 'Log(mfc4.GetScript)
'	'page.cell(3,1).AddComponent(mfc4.ABMComp)
'	 
'	Dim mfc5 As MashFrappeChart
'	mfc5.Initialize(page,"mfc5","6. Line - Hide Line", 200)
'	mfc5.ChartType = mfc5.EnumFrappeChartType.line
'	mfc5.SetXAxis("x",0)
'	mfc5.AddSeries("a","DS 1",mfc5.EnumColor.brown)
'	mfc5.AddSeries("b","DS 2",mfc5.EnumColor.green)
'	'add data
'	mfc5.AddXY2("Sun",18,30).AddXY2("Mon",40,50).AddXY2("Tue",30,-10)
'	mfc5.AddXY2("Wed",35,15).AddXY2("Thu",8,18).AddXY2("Fri",52,32)
'	mfc5.AddXY2("Sat",17,27).AddXY2("Sun",-4,14)
'	mfc5.ZDepth = ABM.ZDEPTH_1
'	mfc5.lineOptionshideLine = True
'	'Log(mfc5.GetScript)
'	'page.cell(3,2).AddComponent(mfc5.ABMComp)
'	
'	Dim mfc6 As MashFrappeChart
'	mfc6.Initialize(page,"mfc6","7. Line - Hide Dots", 200)
'	mfc6.ChartType = mfc6.EnumFrappeChartType.line
'	mfc6.SetXAxis("x",0)
'	mfc6.AddSeries("a","DS 1",mfc6.EnumColor.black)
'	mfc6.AddSeries("b","DS 2",mfc6.EnumColor.cyan)
'	'add data
'	mfc6.AddXY2("Sun",18,30).AddXY2("Mon",40,50).AddXY2("Tue",30,-10)
'	mfc6.AddXY2("Wed",35,15).AddXY2("Thu",8,18).AddXY2("Fri",52,32)
'	mfc6.AddXY2("Sat",17,27).AddXY2("Sun",-4,14)
'	mfc6.ZDepth = ABM.ZDEPTH_1
'	mfc6.lineOptionshideDots = True
'	 'Log(mfc6.GetScript)
'	'page.cell(3,1).AddComponent(mfc6.ABMComp)
'	
'	Dim mfc7 As MashFrappeChart
'	mfc7.Initialize(page,"mfc7","8. Bar + Line", 200)
'	mfc7.ChartType = mfc7.EnumFrappeChartType.AxisMixed 
'	mfc7.SetXAxis("x",0)
'	mfc7.AddSeries("a","DS 1",mfc6.EnumColor.deeppurple)
'	mfc7.AddSeries("b","DS 2",mfc6.EnumColor.pink)
'	'by default the series are lines, change series a to a bar
'	'add bar series first before lines
'	mfc7.SetSeriesChartType("a",mfc7.EnumFrappeChartType.Bar)
'	mfc7.SetSeriesChartType("b",mfc7.EnumFrappeChartType.line)  'IMPORTANT
'	'add data
'	mfc7.AddXY2("Sun",18,30).AddXY2("Mon",40,50).AddXY2("Tue",30,-10)
'	mfc7.AddXY2("Wed",35,15).AddXY2("Thu",8,18).AddXY2("Fri",52,32)
'	mfc7.AddXY2("Sat",17,27).AddXY2("Sun",-4,14)
'	mfc7.ZDepth = ABM.ZDEPTH_1
''	Log(mfc7.GetScript)
'	'page.cell(3,2).AddComponent(mfc7.ABMComp)
'	
'	
'	Dim mfc8 As MashFrappeChart
'	mfc8.Initialize(page,"mfc8","9. Bar - Stacked", 200)
'	mfc8.ChartType = mfc8.EnumFrappeChartType.bar
'	mfc8.SetXAxis("x",0)
'	mfc8.AddSeries("a","DS 1",mfc8.EnumColor.yellow)
'	mfc8.AddSeries("b","DS 2",mfc8.EnumColor.violet)
'	'add data
'	mfc8.AddXY2("Sun",18,30).AddXY2("Mon",40,50).AddXY2("Tue",30,-10)
'	mfc8.AddXY2("Wed",35,15).AddXY2("Thu",8,18).AddXY2("Fri",52,32)
'	mfc8.AddXY2("Sat",17,27).AddXY2("Sun",-4,14)
'	mfc8.ZDepth = ABM.ZDEPTH_1
'	mfc8.barOptionsStacked = True
'	mfc8.xAxisMode = "tick"
'	mfc8.LogSC = True
''	Log(mfc8.GetScript)
'	'page.cell(3,1).AddComponent(mfc8.ABMComp)
'	
'	Dim mfc9 As MashFrappeChart
'	mfc9.Initialize(page,"mfc9","10. Pie", 200)
'	mfc9.ChartType = mfc1.EnumFrappeChartType.Pie
'	mfc9.SetXAxis("x",0)
'	mfc9.AddSeries("a","Some data",mfc9.EnumColor.red)
'	'add data
'	mfc9.AddXY("Sun",18).AddXY("Mon",40).AddXY("Tue",30)
'	mfc9.AddXY("Wed",35).AddXY("Thu",8).AddXY("Fri",52)
'	mfc9.AddXY("Sat",17).AddXY("Sun",-4)
'	'page.cell(3,2).AddComponent(mfc9.ABMComp)
'
'	Dim mfc10 As MashFrappeChart
'	mfc10.Initialize(page,"mfc10","11. Percentage", 200)
'	mfc10.ChartType = mfc10.EnumFrappeChartType.Percentage
'	mfc10.SetXAxis("x",0)
'	mfc10.AddSeries("a","Some data",mfc10.EnumColor.red)
'	'add data
'	mfc10.AddXY("Sun",18).AddXY("Mon",40).AddXY("Tue",30)
'	mfc10.AddXY("Wed",35).AddXY("Thu",8).AddXY("Fri",52)
'	mfc10.AddXY("Sat",17).AddXY("Sun",-4)
''	Log(mfc10.GetScript)
'	'page.cell(3,1).AddComponent(mfc10.ABMComp)
'	
'	Dim mfc11 As MashFrappeChart
'	mfc11.Initialize(page,"mfc11", "12. AddData Demo", 250)
'	mfc11.SetXAxis("elapsed",0)
'	mfc11.AddSeries("value","Value",mfc11.EnumColor.lightblue)
'	mfc11.AddData(CreateMap("elapsed": "I", "value": 34))
'	mfc11.AddData(CreateMap("elapsed": "II", "value": 24))
'	mfc11.AddData(CreateMap("elapsed": "III", "value": 3))
'	mfc11.AddData(CreateMap("elapsed": "IV", "value": 12))
'	mfc11.AddData(CreateMap("elapsed": "V", "value": 13))
'	mfc11.AddData(CreateMap("elapsed": "VI", "value": 22))
'	mfc11.AddData(CreateMap("elapsed": "VII", "value": 5))
'	mfc11.AddData(CreateMap("elapsed": "VIII", "value": 26))
'	mfc11.AddData(CreateMap("elapsed": "IX", "value": 12))
'	mfc11.AddData(CreateMap("elapsed": "X", "value": 19))
'	'page.cell(3,2).AddComponent(mfc11.ABMComp)
'	
'	'records could be derived from DBUtils.ExecuteMaps
'	Dim recs As List: recs.initialize
'	recs.add(CreateMap("period": "2012-10-01", "licensed": 3407, "sorned": 660))
'	recs.add(CreateMap("period": "2012-09-30", "licensed": 3351, "sorned": 629))
'	recs.add(CreateMap("period": "2012-09-29", "licensed": 3269, "sorned": 618))
'	recs.add(CreateMap("period": "2012-09-20", "licensed": 3246, "sorned": 661))
'	recs.add(CreateMap("period": "2012-09-19", "licensed": 3257, "sorned": 667))
'	recs.add(CreateMap("period": "2012-09-18", "licensed": 3248, "sorned": 627))
'	recs.add(CreateMap("period": "2012-09-17", "licensed": 3171, "sorned": 660))
'	recs.add(CreateMap("period": "2012-09-16", "licensed": 3171, "sorned": 676))
'	recs.add(CreateMap("period": "2012-09-15", "licensed": 3201, "sorned": 656))
'	recs.add(CreateMap("period": "2012-09-10", "licensed": 3215, "sorned": 622))
'	
'	'formatting dates
'	Dim mfc12 As MashFrappeChart
'	mfc12.Initialize(page,"mfc12", "13. SetData Demo", 250)
'	'define the x axis, the column to read x values, the angle of the x values and whether the x values are numberic/not
'	mfc12.SetXAxis("period",0)
'	mfc12.AddSeries("licensed","Licensed",mfc12.EnumColor.brown)
'	mfc12.AddSeries("sorned","SORN",mfc12.EnumColor.indigo)
'	mfc12.SetData(recs)
'	'page.cell(3,1).AddComponent(mfc12.ABMComp)
'	 
'	'define the morrischart
'	Dim mmc As MashMorrisChart
'	mmc.Initialize(page,"mmc","250px")
'	'define the chart type
'	mmc.ChartType = mmc.EnumMorrisChartType.Area
'	'define the x axis, the column to read x values, the angle of the x values and whether the x values are numberic/not
'	mmc.SetXAxis("x",0)
'	'add a series, we want to plot y and z values
'	mmc.AddSeries("y","Y",mmc.EnumColor.amber)
'	mmc.AddSeries("z","Z",mmc.EnumColor.blue)
'	'add the values to plot to the chart
'	mmc.SetData(records)
'	mmc.ZDepth = ABM.ZDEPTH_1
'	'page.cell(3,1).AddComponent(mmc.ABMComp)
'	
'	
'	Dim mmc1 As MashMorrisChart
'	mmc1.Initialize(page,"mmc1", "250px")
'	'define the chart type
'	mmc1.ChartType = mmc.EnumMorrisChartType.Area
'	'define the x axis, the column to read x values, the angle of the x values and whether the x values are numberic/not
'	mmc1.SetXAxis("x",0)
'	'add a series, we want to plot y and z values
'	mmc1.AddSeries("y","Y",mmc1.EnumColor.cyan)
'	mmc1.AddSeries("z","Z",mmc1.EnumColor.deeporange)
'	'add the values to plot to the chart
'	mmc1.SetData(records)
'	'chart behave like a line chart
'	mmc1.behaveLikeLine = True
'	'page.cell(3,2).AddComponent(mmc1.ABMComp)
'
'	'bar chart
'	Dim mmc2 As MashMorrisChart
'	mmc2.Initialize(page,"mmc2", "250px")
'	'define the chart type
'	mmc2.ChartType = mmc.EnumMorrisChartType.Bar
'	'define the x axis, the column to read x values, the angle of the x values and whether the x values are numberic/not
'	mmc2.SetXAxis("x",0)
'	'add a series, we want to plot y and z values
'	mmc2.AddSeries("y","Y",mmc2.EnumColor.green)
'	mmc2.AddSeries("z","Z",mmc2.EnumColor.purple)
'	'add the values to plot to the chart
'	mmc2.SetData(records)
'	'page.cell(4,1).AddComponent(mmc2.ABMComp)
'	
'	'bar chart
'	Dim mmc3 As MashMorrisChart
'	mmc3.Initialize(page,"mmc3", "250px")
'	'define the chart type
'	mmc3.ChartType = mmc.EnumMorrisChartType.Bar
'	'define the x axis, the column to read x values, the angle of the x values and whether the x values are numberic/not
'	mmc3.SetXAxis("x",0)
'	'add a series, we want to plot y and z values
'	mmc3.AddSeries("y","Y",mmc3.EnumColor.amber)
'	mmc3.AddSeries("z","Z",mmc3.EnumColor.blue)
'	'add the values to plot to the chart
'	mmc3.SetData(records)
'	mmc3.axes = False
'	'page.cell(4,2).AddComponent(mmc3.ABMComp)
'	
'	'formatting dates
'	Dim mmc4 As MashMorrisChart
'	mmc4.Initialize(page,"mmc4", "250px")
'	'define the x axis, the column to read x values, the angle of the x values and whether the x values are numberic/not
'	mmc4.SetXAxis("period",0)
'	mmc4.AddSeries("licensed","Licensed",mmc4.EnumColor.brown)
'	mmc4.AddSeries("sorned","SORN",mmc4.EnumColor.indigo)
'	mmc4.AddData(CreateMap("period": "2012-10-01", "licensed": 3407, "sorned": 660))
'	mmc4.AddData(CreateMap("period": "2012-09-30", "licensed": 3351, "sorned": 629))
'	mmc4.AddData(CreateMap("period": "2012-09-29", "licensed": 3269, "sorned": 618))
'	mmc4.AddData(CreateMap("period": "2012-09-20", "licensed": 3246, "sorned": 661))
'	mmc4.AddData(CreateMap("period": "2012-09-19", "licensed": 3257, "sorned": 667))
'	mmc4.AddData(CreateMap("period": "2012-09-18", "licensed": 3248, "sorned": 627))
'	mmc4.AddData(CreateMap("period": "2012-09-17", "licensed": 3171, "sorned": 660))
'	mmc4.AddData(CreateMap("period": "2012-09-16", "licensed": 3171, "sorned": 676))
'	mmc4.AddData(CreateMap("period": "2012-09-15", "licensed": 3201, "sorned": 656))
'	mmc4.AddData(CreateMap("period": "2012-09-10", "licensed": 3215, "sorned": 622))
'	'page.cell(5,1).AddComponent(mmc4.ABMComp)
'	
'	'formatting dates
'	Dim mmc5 As MashMorrisChart
'	mmc5.Initialize(page,"mmc5", "250px")
'	'define the x axis, the column to read x values, the angle of the x values and whether the x values are numberic/not
'	mmc5.SetXAxis("period",60)
'	mmc5.AddSeries("licensed","Licensed",mmc5.EnumColor.yellow)
'	mmc5.AddSeries("sorned","SORN",mmc5.EnumColor.purple)
'	mmc5.AddData(CreateMap("period": "2012-10-01", "licensed": 3407, "sorned": 660))
'	mmc5.AddData(CreateMap("period": "2012-09-30", "licensed": 3351, "sorned": 629))
'	mmc5.AddData(CreateMap("period": "2012-09-29", "licensed": 3269, "sorned": 618))
'	mmc5.AddData(CreateMap("period": "2012-09-20", "licensed": 3246, "sorned": 661))
'	mmc5.AddData(CreateMap("period": "2012-09-19", "licensed": 3257, "sorned": 667))
'	mmc5.AddData(CreateMap("period": "2012-09-18", "licensed": 3248, "sorned": 627))
'	mmc5.AddData(CreateMap("period": "2012-09-17", "licensed": 3171, "sorned": 660))
'	mmc5.AddData(CreateMap("period": "2012-09-16", "licensed": 3171, "sorned": 676))
'	mmc5.AddData(CreateMap("period": "2012-09-15", "licensed": 3201, "sorned": 656))
'	mmc5.AddData(CreateMap("period": "2012-09-10", "licensed": 3215, "sorned": 622))
'	'page.cell(5,2).AddComponent(mmc5.ABMComp)
'	
'	
'	
'	'bar chart
'	Dim mmc6 As MashMorrisChart
'	mmc6.Initialize(page,"mmc6", "250px")
'	'define the chart type
'	mmc6.ChartType = mmc6.EnumMorrisChartType.Bar
'	'define the x axis, the column to read x values, the angle of the x values and whether the x values are numberic/not
'	mmc6.SetXAxis("x",90)
'	'add a series, we want to plot y and z values
'	mmc6.AddSeries("y","Y",mmc6.EnumColor.amber)
'	mmc6.AddSeries("z","Z",mmc6.EnumColor.blue)
'	'add the values to plot to the chart
'	mmc6.SetData(records)
'	mmc6.stacked = True
'	'page.cell(6,1).AddComponent(mmc6.ABMComp)
'	
'	'bar chart
'	Dim mmc7 As MashMorrisChart
'	mmc7.Initialize(page,"mmc7", "250px")
'	mmc7.ChartType = mmc7.EnumMorrisChartType.Area
'	mmc7.SetXAxis("x",0)
'	mmc7.AddSeries("y","Y",mmc7.EnumColor.amber)
'	mmc7.AddSeries("z","Z",mmc7.EnumColor.blue)
'	mmc7.AddData(CreateMap("x": "2013-03-30 22:00:00", "y": 3, "z": 3))
'	mmc7.AddData(CreateMap("x": "2013-03-31 00:00:00", "y": 2, "z": 0))
'	mmc7.AddData(CreateMap("x": "2013-03-31 02:00:00", "y": 0, "z": 2))
'	mmc7.AddData(CreateMap("x": "2013-03-31 04:00:00", "y": 4, "z": 4))
'	'page.cell(6,2).AddComponent(mmc7.ABMComp)
'	
'	'bar chart
'	Dim mmc8 As MashMorrisChart
'	mmc8.Initialize(page,"mmc8", "250px")
'	mmc8.SetXAxis("elapsed",0)
'	mmc8.AddSeries("value","Value",mmc8.EnumColor.lightblue)
'	mmc8.AddData(CreateMap("elapsed": "I", "value": 34))
'	mmc8.AddData(CreateMap("elapsed": "II", "value": 24))
'	mmc8.AddData(CreateMap("elapsed": "III", "value": 3))
'	mmc8.AddData(CreateMap("elapsed": "IV", "value": 12))
'	mmc8.AddData(CreateMap("elapsed": "V", "value": 13))
'	mmc8.AddData(CreateMap("elapsed": "VI", "value": 22))
'	mmc8.AddData(CreateMap("elapsed": "VII", "value": 5))
'	mmc8.AddData(CreateMap("elapsed": "VIII", "value": 26))
'	mmc8.AddData(CreateMap("elapsed": "IX", "value": 12))
'	mmc8.AddData(CreateMap("elapsed": "X", "value": 19))
'	mmc8.parseTime = False 
'	mmc8.postunits = "%"
'	'page.cell(7,1).AddComponent(mmc8.ABMComp)
'	
'	Dim mmc9 As MashMorrisChart
'	mmc9.Initialize(page,"mmc9", "250px")
'	mmc9.ChartType = mmc7.EnumMorrisChartType.Donut
'	mmc9.AddSlice("foo",70,mmc9.EnumColor.red)
'	mmc9.AddSlice("bar", 15, mmc9.EnumColor.green)
'	mmc9.AddSlice("baz", 10, mmc9.EnumColor.blue)
'	mmc9.AddSlice("A really really long labe", 5, mmc9.EnumColor.cyan)
'	mmc9.OutputPercentage = True
'	mmc9.labelColor = mmc9.EnumColor.black
'	'' mmc9.backgroundColor = mmc9.EnumColor.white
'	'page.cell(7,2).AddComponent(mmc9.ABMComp)
'	
'	Dim g As MashJSGantt
'	g.Initialize(page,"g")
'	g.GanttFormat = g.JSGanttFormat.day
'	g.RowHeight = 32
'	g.DateTaskTableDisplayFormat = g.JSGanttDateOutputFormat.yyyy_mm_dd
'	g.DateTaskDisplayFormat = g.JSGanttDateOutputFormat.dd_mon_yyyy_day
'	g.CaptionType = g.JSGanttCaptionType.Resource
'	g.ShowResource = False 'default true
'	g.AddProject("Gantt Charts")
'	g.AddTask(1,2,"Research Gantt Charts","2018-05-05","2018-05-05",80,"Mashy","")
'	g.AddTask(2,3,"Google Charts","2018-05-06","2018-05-06",100,"Mashy","").SetGreen(3)
'	g.AddTask(2,4,"jsGantt Improved","2018-05-07","2018-05-07",100,"Mashy","")
'	
'	g.AddTask(1,5,"Build ABM Components","2018-05-05","2018-05-05",80,"Mashy","2")
'	g.AddTask(5,6,"Google Charts","2018-05-06","2018-05-06",100,"Mashy","").SetYellow(6)
'	g.AddTask(5,7,"jsGantt Improved","2018-05-07","2018-05-07",100,"Mashy","")
'	
'	g.AddTask(1,8,"Blog on B4X Website","2018-05-05","2018-05-05",100,"Mashy","5")
'	g.AddTask(8,9,"Google Charts","2018-05-07","2018-05-07",20,"Mashy","").SetPurple(9) 
'	g.AddTask(8,10,"jsGantt Improved","2018-05-07","2018-05-07",50,"Mashy","").SetMileStone(10,True)
'	
'	
'	
'	
'	
''	g.AddTask1(1,  "Define Chart API",     "",           "",          "ggroupblack",  "",       False, "Brian",    0,  g.JSGanttTaskType.StandardGroupTask, 0,  True, "",      "",      "Some Notes text")
''	g.AddTask1(11,  "Chart Object",         "2016-02-20","2016-02-20", "gmilestone",   "",       False, "Shlomy",   100,  g.JSGanttTaskType.normaltask, 1,  True, "",      "",      "")
''	g.AddTask1(12,  "Task Objects",         "",           "",          "ggroupblack",  "",       False, "Shlomy",   40,  g.JSGanttTaskType.StandardGroupTask, 1,  True, "",      "",      "")
''	g.AddTask1(121, "Constructor Proc",     "2016-02-21","2016-03-09", "gtaskblue",    "",       False, "Brian T.", 60,  g.JSGanttTaskType.normaltask, 12, True, "",      "",      "")
''	g.AddTask1(122, "Task Variables",       "2016-03-06","2016-03-11", "gtaskred",     "",       False, "Brian",    60,  g.JSGanttTaskType.normaltask, 12, True, 121,     "",      "")
''	g.AddTask1(123, "Task by Minute/Hour",  "2016-03-09","2016-03-14 12:00", "gtaskyellow", "",  False, "Ilan",     60,  g.JSGanttTaskType.normaltask, 12, True, "",      "",      "")
''	g.AddTask1(124, "Task Functions",       "2016-03-09","2016-03-29", "gtaskred",     "",       False, "Anyone",   60,  g.JSGanttTaskType.normaltask, 12, True, "123SS", "This is a caption", "")
''	g.AddTask1(2,   "Create HTML Shell",    "2016-03-24","2016-03-24", "gtaskyellow",  "",       False, "Brian",    20,  g.JSGanttTaskType.normaltask, 0,  True, "122",     "",      "")
''	g.AddTask1(3,   "Code Javascript",      "",           "",          "ggroupblack",  "",       False, "Brian",    0,   g.JSGanttTaskType.StandardGroupTask, 0,  True, "",      "",      "")
''	g.AddTask1(31,  "Define Variables",     "2016-02-25","2016-03-17", "gtaskpurple",  "",       False, "Brian",    30,  g.JSGanttTaskType.normaltask, 3,  True, "",      "Caption 1","")
''	g.AddTask1(32,  "Calculate Chart Size", "2016-03-15","2016-03-24", "gtaskgreen",   "",       False, "Shlomy",   40,  g.JSGanttTaskType.normaltask, 3,  True, "",      "",      "")
''	g.AddTask1(33,  "Draw Task Items",      "",           "",          "ggroupblack",  "",       False, "Someone",  40,  g.JSGanttTaskType.CombinedGroupTask, 3,  True, "",      "",      "")
''	g.AddTask1(332, "Task Label Table",     "2016-03-06","2016-03-09", "gtaskblue",    "",       False, "Brian",    60,  g.JSGanttTaskType.normaltask, 33, True, "",      "",      "")
''	g.AddTask1(333, "Task Scrolling Grid",  "2016-03-11","2016-03-20", "gtaskblue",    "",       False, "Brian",    0,   g.JSGanttTaskType.normaltask, 33, True, "332",   "",      "")
''	g.AddTask1(34,  "Draw Task Bars",       "",           "",          "ggroupblack",  "",       False, "Anybody",  60,  g.JSGanttTaskType.StandardGroupTask, 3,  False, "",      "",     "")
''	g.AddTask1(341, "Loop each Task",       "2016-03-26","2016-04-11", "gtaskred",     "",       False, "Brian",    60,  g.JSGanttTaskType.normaltask, 34, True, "",      "",      "")
''	g.AddTask1(342, "Calculate Start/Stop", "2016-04-12","2016-05-18", "gtaskpink",    "",       False, "Brian",    60,  g.JSGanttTaskType.normaltask, 34, True, "",      "",      "")
''	g.AddTask1(343, "Draw Task Div",        "2016-05-13","2016-05-17", "gtaskred",     "",       False, "Brian",    60,  g.JSGanttTaskType.normaltask, 34, True, "",      "",      "")
''	g.AddTask1(344, "Draw Completion Div",  "2016-05-17","2016-06-04", "gtaskred",     "",       False, "Brian",    60,  g.JSGanttTaskType.normaltask, 34, True, "342,343","",     "")
''	g.AddTask1(35,  "Make Updates",         "2016-07-17","2017-09-04", "gtaskpurple",  "",       False, "Brian",    30,  g.JSGanttTaskType.normaltask, 3,  True, "333",   "",      "")
'	'page.Cell(2,1).AddComponent(g.ABMComp)
'	
'	Dim ms As MashSelect
'	ms.Initialize(page,"ms","","Combo Box Test","Select names",True,"")
'	ms.AddItem("a","Item A")
'	ms.AddItem("b","Item B")
'	'page.Cell(3,1).AddComponent(ms.ABMComp)
'	
'	
'	Dim cbo As ABMCombo
'	cbo.Initialize(page,"ms1","Combo Box Test",650,"")
'	'' page.Cell(2,1).AddComponent(cbo)
'	
'	
'		
'	Dim mgantt As MashGGhatt
'	mgantt.Initialize(page,"mgantt")
'	mgantt.criticalPathEnabled = True
'	mgantt.AddTask("Research", "Find sources", "", "2015-01-01", "2015-01-05", "", "100", "")
'	mgantt.addtask("Write", "Write paper", "write", "", "2015-01-09", "3", "25", "Research,Outline")
'	mgantt.addtask("Cite", "Create bibliography", "write", "", "2015-01-07", "1", "20", "Research")
'	mgantt.addtask("Complete", "Hand on paper", "complete", "", "2015-01-10", "1", "0", "Cite,Write")
'	mgantt.addtask("Outline", "Outline paper", "write", "", "2015-01-06", "1", "100", "Research")
'	'page.cell(3,1).AddComponent(mgantt.abmcomp)
'	
'	Dim mgantt1 As MashGGhatt
'	mgantt1.Initialize(page,"mgantt1")
'	mgantt1.IsTime = True
'	mgantt1.DefaultStartDate = "2015-03-28"
'	mgantt1.AddMinutes("toTrain", "Walk to train stop", "walk", 5, 100, "")
'	mgantt1.AddMinutes("music", "Listen to music", "music", 70, 100, "")
'	mgantt1.AddMinutes("wait", "Wait for train", "wait", 10, 100, "toTrain")
'	mgantt1.AddMinutes("train", "Train ride", "train", 45, 75, "wait")
'	mgantt1.AddMinutes("toWork", "Walk to work", "walk", 10, 0, "train")
'	mgantt1.AddMinutes("work", "Sit down at desk", "", 2, 0, "toWork")
'	
'	'page.cell(3,1).AddComponent(mgantt1.abmcomp)
'		
'	
'	Dim mg As MashGGhatt
'	mg.Initialize(page,"mg")
'	'set the start date
'	mg.DefaultStartDate = "2015-03-28"
'	mg.criticalPathEnabled = True
'	Dim gt As GanttTask
'	gt = mg.CreateTask
'	gt.TaskID = "2014Spring"
'	gt.TaskName = "Spring 2014"
'	gt.Resource = "spring"
'	gt.StartDate = "2014-02-22"
'	gt.EndDate = "2014-05-20"
'	gt.PercentComplete = "100"
'	mg.AddTask1(gt)
'	
'	mg.AddTask("2014Summer", "Summer 2014", "summer",	"2014-05-21", "2014-08-20", "", "100", "")
'	mg.AddTask("2014Autumn", "Autumn 2014", "autumn",	"2014, 8, 21", "2014, 11, 20", "", "100", "")
'	mg.AddTask("2014Winter", "Winter 2014", "winter",	"2014, 11, 21", "2015, 2, 21", "", 100, "")
'	mg.AddTask("2015Spring", "Spring 2015", "spring",	"2015, 2, 22", "2015, 5, 20", "", 50, "")
'	'['2015Summer', 'Summer 2015', 'summer',	new Date(2015, 5, 21), new Date(2015, 8, 20), Null, 0, null],
'	'['2015Autumn', 'Autumn 2015', 'autumn',	new Date(2015, 8, 21), new Date(2015, 11, 20), Null, 0, null],
'	'['2015Winter', 'Winter 2015', 'winter',	new Date(2015, 11, 21), new Date(2016, 2, 21), Null, 0, null],
'	'['Football', 'Football Season', 'sports', new Date(2014, 8, 4), new Date(2015, 1, 1), Null, 100, null],
'	'['Baseball', 'Baseball Season', 'sports', new Date(2015, 2, 31), new Date(2015, 9, 20), Null, 14, null],
'	'['Basketball', 'Basketball Season', 'sports', new Date(2014, 9, 28), new Date(2015, 5, 20), Null, 86, null],
'	'['Hockey', 'Hockey Season', 'sports', new Date(2014, 9, 8), new Date(2015, 5, 21), Null, 89, null]
'	'page.cell(3,1).AddComponent(mg.ABMComp)
'	
'	Dim anele As MashFlowChart
'	anele.Initialize(page,"anele")
'	anele.AddStart1.AddEnd1
'	anele.AddOperation1("welcome","Welcome")
'	'.ConnectStart("welcome")
'	anele.AddOperation1("green","Green")
'	anele.AddOperation1("yellow","Yellow")
'	anele.AddOperation1("blue","Blue")
'	anele.AddCondition1("color","What is your favourate color?").Connect("welcome","color")
'	anele.IfYesConnect("color","green").IfYesConnect("color","yellow")
'	
'	'page.Cell(2,1).AddComponent(anele.ABMComp)
'	
'	Dim fc As MashFlowChart
'	fc.Initialize(page,"fc1")
'	fc.AddStart1.AddEnd1.AddSubroutine1("sub1","My SubRoutine").AddCondition1("cond","Yes or\nNo")
'	fc.AddOperation("op1","My Operation","current","",False).AddFlowState("current","red","yellow","red","bold","","","")
'	fc.AddInputOutput1("io","Catch something")
'	fc.Connect("st","op1").Connect("op1","cond")
'	fc.IfYesConnect("cond","io").IfNoConnect("cond","sub1").ConnectRight("sub1","op1")
'	fc.Connect("io","e")
'	'page.Cell(2,1).AddComponent(fc.ABMComp)
'	
'	
'	
'	
''	Dim mfc As MashFlowChart
''	mfc.Initialize(page,"mfc")
''	mfc.AddStart("st: Start","past","http://www.google.com",True)
''	mfc.AddEnd("e: End","","http://www.google.com",False)
''	mfc.AddOperation("op1","op1: My Operation","past","",False).ConnectStart("op1").ConnectRight("op1","cond").ColorStart("op1","red")
''	mfc.AddOperation("op2","op2: Stuff","current","",False).ConnectEnd("op2")
''	mfc.AddSubroutine("sub1","sub1: My subroutine","invalid","",False).ConnectLeft("sub1","op1")
''	mfc.AddCondition("cond","cond: Yes or No?","approved","http://www.google.com",False).IfYesConnectRight("cond","c2").IfNoConnect("cond","para").Color("cond","c2","red")
''	mfc.AddCondition("c2","c2: Good idea","rejected","",False).IfYesConnect("c2","io").IfNoConnectEnd("c2")
''	mfc.AddInputOutput("io","io: catch something...","request","",False).ConnectEnd("io").ColorEnd("io","cyan")
''	mfc.AddParallel("para","para: parallel tasks","","",False).Path1Bottom("para","sub1").Path2Right("para","op2")
''	
''	'set flow states, this applies a theme to the flowchart
''	mfc.AddFlowStateFill("future","#FFFF99").AddFlowStateFill("invalid","#444444").AddFlowStateFill("request","blue")
''	mfc.AddFlowState("past","","#CCCCCC","","12","","","")
''	mfc.AddFlowState("current","","yellow","red","bold","","","")
''	mfc.AddFlowState("approved","","#58C4A3","","","12","APPROVED","n/a")
''	mfc.AddFlowState("rejected","","#C45879","","","12","n/a","REJECTED")
'		
'	'page.Cell(2,1).AddComponent(mfc.ABMComp)
'	
'	Dim ex1 As MashText2UML
'	ex1.Initialize(page,"ex1")
'	ex1.AddConnection("Andrew","China","Says Hello")
'	ex1.AddNote("China",ex1.EnumNotePos.right,"China thinks\nabout it")
'	ex1.AddDottedConnection("China","Andrew","How are you?")
'	ex1.AddConnectionOpen("Andrew","China","I am good thanks!")
'	'page.Cell(2,1).addcomponent(ex1.ABMComp)
'	
'	
'	Dim ex2 As MashText2UML
'	ex2.Initialize(page,"ex2")
'	ex2.Title = "Here is a title"
'	ex2.AddNormalLine("A","B","Normal line")
'	ex2.AddDashedLine("B","C","Dashed line")
'	ex2.AddOpenArrow("C","D","Open arrow")
'	ex2.AddDashedOpenArrow("D","A","Dashed open arrow")
'	'page.Cell(2,1).addcomponent(ex2.ABMComp)
'	
'	
'	Dim ex5 As MashText2UML
'	ex5.Initialize(page,"ex5")
'	ex5.Theme = ex5.EnumTheme.simple
'	ex5.AddNote("A",ex5.EnumNotePos.left,"Note to the\n left of A")
'	ex5.AddNote("A",ex5.EnumNotePos.right,"Note to the\n right of A")
'	ex5.AddNote("A",ex5.EnumNotePos.over,"Note over A")
'	ex5.AddNoteOver("A","B","Note over both A and B")
'	'page.Cell(2,1).addcomponent(ex5.ABMComp)
'	
'	Dim ex4 As MashText2UML
'	ex4.Initialize(page,"ex4")
'	ex4.AddParticipant("C").AddParticipant("B").AddParticipant("A")
'	ex4.AddNote("A",ex4.EnumNotePos.right,"You can change the order of the\n participants")
'	'page.Cell(2,1).addcomponent(ex4.ABMComp)
'	
'	
'	Dim diag As MashText2UML
'	diag.Initialize(page,"diag")
'	diag.Theme = diag.EnumTheme.hand
'	diag.Title = "Creating ABM WebApps: 1"
'	diag.AddParticipant("Developer")
'	diag.AddParticipant("Alain")
'	diag.AddParticipant("Feedback App")
'	diag.AddParticipant("ABM")
'	
'	diag.AddConnection("Developer","Alain","Request ABM")
'	diag.AddConnection("Alain","Feedback App","Create Developer Profile")
'	
'	diag.AddDottedConnection("Alain","Developer","Sends Login details to user")
'	diag.AddConnection("Developer","Feedback App","Signs in and downloads ABM")
'	diag.AddDottedConnection("Developer","ABM","Unzips ABM")	
'	'page.Cell(3,1).AddComponent(diag.ABMComp)
'	
'	'part 2
'	Dim diag1 As MashText2UML
'	diag1.Initialize(page,"diag1")
'	diag1.Theme = diag1.EnumTheme.hand
'	diag1.Title = "Creating ABM WebApps: 2"
'	diag1.AddParticipant("Developer")
'	diag1.AddParticipant("Template")
'	diag1.AddParticipant("Contacts")
'	
'	diag1.AddParticipant("Contacts.b4j")
'	
'	diag1.AddConnection("Developer","Template","Extract Template folder from ABM")
'	diag1.AddConnection("Template","Contacts","Rename folder to 'Contacts'")
'	diag1.AddConnection("Contacts","Contacts.b4j","Rename .b4j project to 'Contacts.b4j'")
'	diag1.AddNote("Developer",diag1.EnumNotePos.left,"Thinks about new app")
'	diag1.AddNote("Template",diag1.EnumNotePos.right,"Names App Contacts")
'	
'	'page.Cell(3,2).AddComponent(diag1.ABMComp)
'	
'	
'	Dim mjc As MashJCircle
'	mjc.Initialize(page,"mjc")
'	mjc.speed = 5
'	mjc.animateType = mjc.EnumRotateType.rotateAround
'	mjc.minCirclesEffectOver = mjc.EnumminCirclesEffectOver.pulse
'	mjc.AddCircle("car","../images/1.jpg","My car")
'	mjc.AddCircle("flower","../images/2.jpg","My car")
'	mjc.AddCircle("sweets","../images/3.jpg","My sweets")
'	mjc.AddCircle("sweets","../images/4.jpg","My sweets")
'	mjc.AddCircle("sweets","../images/5.jpg","My sweets")
'	mjc.AddCircle("sweets","../images/6.jpg","My sweets")
'	'page.cell(3,1).AddComponent(mjc.ABMComp)
'	
'	'page.Cell(2,1).UseTheme("black")
'	'page.Cell(2,1).SetFixedHeight(400,False)
'	
'	mgb.Initialize(page,"mgb")
'	mgb.Width = "500"
'	mgb.Height = "400"
'	mgb.number = 40
'	'page.Cell(2,1).AddComponent(mgb.ABMComp)
'	
'	Dim rt As String = MashPlugIns.TimeAgo("2018-04-25 09:30:00")
'	
'	'page.Msgbox("",rt,"Time Ago","OK",False,"","")
'	
'	LoadFakeData
'	
'	'page.Cell(2,1).SetFixedHeight(500, False)
'	
'	' for our combo, we add a Json string counting the countries
'	myTableGrid.Initialize(page, "myTableGrid", $"[
'        { Name: "", Id: 0 },
'        { Name: "United States", Id: 1 },
'        { Name: "Canada", Id: 2 },
'        { Name: "United Kingdom", Id: 3 },
'        { Name: "France", Id: 4 },
'        { Name: "Brazil", Id: 5 },
'        { Name: "China", Id: 6 },
'        { Name: "Russia", Id: 7 }
'    ]"$, LoadData)
'	
'	myTableGrid.InitializeMash(page,"mashgrid")
'	'lets add the columns
'	myTableGrid.MashAddText("Name","Full Name",150)
'	myTableGrid.MashAddNumber("Age","Age",50)
'	myTableGrid.MashAddSelect("Country","Country of Birth",100)
'	myTableGrid.MashAddText("Address","Residential Address",200)
'	myTableGrid.MashAddCheckBox("Married","Married?",60)
'	
'	'myTableGrid.MashAddDate("HireDate","Hire Date",60)
'	'myTableGrid.MashAddSelect("Gender","Gender",60)
'	'myTableGrid.MashAddRating("Rating","Rating",50)
'	myTableGrid.MashAddControl
'	
'	'the ids should be added as string
'	Dim countries As Map
'	countries.Initialize
'	countries.put("0","")
'	countries.put("1","United States")
'	countries.put("2","Canada")
'	countries.put("3","United Kingdom")
'	countries.put("4","France")
'	countries.put("5","Brazil")
'	countries.put("6","China")
'	countries.put("7","Russia")
'	countries.Put("8", "South Africa")
'	'myTableGrid.MashSetSelect("Country","Id","Name", countries)
'	
'	'ids should be added as string
'	Dim gender As Map
'	gender.Initialize
'	gender.Put("0","")
'	gender.Put("1","Male")
'	gender.Put("2","Female")
'	'myTableGrid.MashSetSelect("Gender","Id","Name", gender)
'	'myTableGrid.Heading = False
'	'myTableGrid.Filtering = True
'	'myTableGrid.SetDBData(LoadData)
'	
'	'myTableGrid.MashSetRequired("name",True)
'	'myTableGrid.MashSetRequired("age", True)
'	'myTableGrid.MashSetRequired("country", True)
'	'myTableGrid.MashSetNumericValueType("country")
'	'myTableGrid.MashSetSelectedIndex("Country","8")
'	
'	'page.Cell(2,1).AddComponent(myTableGrid.ABMComp)
'	
'	Dim btn As ABMButton
'	btn.InitializeRaised(page,"pushit",MashPlugIns.MaterialIcons.mdi_access_time,"","Speak","")
'	'page.cell(2,1).AddComponent(btn)
'	
'	'SmallGrid
'	'Offsets
'	'add some classes
'	'page.InsertCSSRule(".red","color:red;",True)
'	
'	'mash simple diagram
'	Dim msd As MashSimpleDiagram
'	msd.Initialize(page,"msd",35,70,30,False)
'	msd.Clear
'	'msd.AddNumbers
'	msd.AddNode2(7,15,6,14,"ABMaterial")
''	msd.AddNode2(5,41,5,42, "ABMApplication")
''	msd.AddNode2(7,41,7,42, "ABMCacheControl")
''	msd.AddNode2(9,41,9,42, "ABMCacheScavenger")
''	msd.AddNode2(11,41,11,42, "ABMErrorHandler")
''	msd.AddNode2(13,41,13,42, "ABMRootFilter")
''	msd.AddNode2(15,41,15,42, "ABMShared")
''	msd.AddNode2(17,41,17,42, "ABMUploadHandler")
''	msd.AddNode2(19,41,19,42, "DBM")
''	msd.AddNode2(21,41,21,42, "ABMPageTemplate")
''	msd.AddNode(10,30,"Template")
'	'msd.AddNode2(4,25,3,24,"WebApp")
'	'msd.AddNode2(3,33,3,34,"VPS")
'	'msd.AddNode2(6,25,7,24,"Pages")
'	'msd.AddNode2(6,31,7,29,"ABMPageTemplate1..N")
'	
'	'add connections
''	msd.AddConnection("Template","ABMaterial")
''	msd.AddConnection("ABMApplication","Template")
''	msd.AddConnection("ABMCacheControl","Template")
''	msd.AddConnection("ABMCacheScavenger","Template")
''	msd.AddConnection("ABMErrorHandler","Template")
''	msd.AddConnection("ABMRootFilter","Template")
''	msd.AddConnection("ABMShared","Template")
''	msd.AddConnection("ABMUploadHandler","Template")
''	msd.AddConnection("DBM","Template")
''	msd.AddConnection("ABMPageTemplate","Template")
'	'msd.AddConnection("ABMaterial","WebApp")
'	'msd.AddConnection("WebApp","VPS")
'	'msd.AddConnection("Pages","WebApp")
'	'msd.AddConnection("ABMPageTemplate1..N","Pages")
'	
'	'change shape to square
''	Dim lst As List
''	lst.Initialize
''	lst.Add("ABMApplication")
''	lst.Add("ABMCacheControl")
''	lst.Add("ABMCacheScavenger")
''	lst.Add("ABMErrorHandler")
''	lst.Add("ABMShared")
''	lst.Add("DBM")
''	lst.Add("ABMPageTemplate")
''	msd.MakeSquare(lst)
'	
'	'msd.AddBox(11,1, 14,7)
'	'msd.AddBox(11,18,13,7)
'	
'	'form controls
'	msd.AddNode2(12,3,12,4,"Input Controls")
'	msd.AddLabel1(13,4,"ABMCheckBox")
'	msd.AddLabel1(14,4,"ABMCombo")
'	msd.AddLabel1(15,4,"ABMDateTimePicker")
'	msd.AddLabel1(16,4,"ABMDateTimeScroller")
'	msd.AddLabel1(17,4,"ABMFileInput")
'	msd.AddLabel1(18,4,"ABMEditor")
'	msd.AddLabel1(19,4,"ABMInput")
'	msd.AddLabel1(20,4,"ABMPatternLock")
'	msd.AddLabel1(21,4,"ABMRadioGroup")
'	msd.AddLabel1(22,4,"ABMRange")
'	msd.AddLabel1(23,4,"ABMSignaturePad")
'	msd.AddLabel1(24,4,"ABMSlider")
'	msd.AddLabel1(25,4,"ABMSwitch")
'	msd.AddLabel1(26,4,"ABMUpload")
'	msd.AddLabel1(27,4,"ABMInputBox")
'	msd.AddLabel1(28,4,"ABMPercentSlider")
'	msd.AddLabel1(29,4,"ABMStarRating")
'	
'	'buttons
'	msd.AddNode2(12,9,12,10,"Buttons")
'	msd.AddLabel1(13,10,"ABMActionButton")
'	msd.AddLabel1(14,10,"ABMButton")
'	
'	'media
'	msd.AddNode2(12,16,12,17,"Media")
'	msd.AddLabel1(13,17,"ABMAudioPlayer")
'	msd.AddLabel1(14,17,"ABMImage")
'	msd.AddLabel1(15,17,"ABMImageSlider")
'	msd.AddLabel1(16,17,"ABMVideo")
'	msd.AddLabel1(17,17,"ABMFlexWall")
'	msd.AddLabel1(18,17,"ABMParallax")
'	msd.AddLabel1(19,17,"ABMCard")
'	msd.AddLabel1(20,17,"ABMList")
'	msd.AddLabel1(21,17,"ABMCanvas")
'	msd.AddLabel1(22,17,"ABMPDFViewer")
'	msd.AddLabel1(23,17,"ABMBadge")
'	msd.AddLabel1(24,17,"ABMChip")
'	msd.AddLabel1(25,17,"ABMLabel")
'	msd.AddLabel1(26,17,"ABMDivider")
'	msd.AddLabel1(27,17,"ABMSVGSurface")
'	msd.AddLabel1(28,17,"ABMCodeLabel")
'	msd.AddLabel1(29,17,"ABMMessageBox")
'	msd.AddLabel1(30,17,"ABMFileManager")
'	msd.AddLabel1(31,17,"ABMSocialShare")
'	
'	'layouts
'	msd.AddNode2(12,22,12,23,"Layouts")
'	msd.AddLabel1(13,23,"ABMContainer")
'	msd.AddLabel1(14,23,"ABMCustomComponent")
'	msd.AddLabel1(15,23,"ABMSmartWizard")
'	msd.AddLabel1(16,23,"ABMTabs")
'	msd.AddLabel1(17,23,"ABMModalSheet")
'	msd.AddLabel1(18,23,"ABMPage")
'	msd.AddLabel1(19,23,"ABMTable")
'	msd.AddLabel1(20,23,"ABMTableMutable")
'	msd.AddLabel1(21,23,"ABMCustomCard")
'	
'	
'	'navigation
'	msd.AddNode2(12,31,12,32,"Navigation")
'	msd.AddLabel1(13,32,"ABMNavigationBar")
'	msd.AddLabel1(14,32,"ABMPagination")
'	
'	
'	'security
'	msd.AddNode2(6,53,6,54,"Security")
'	msd.AddLabel1(7,54,"ABMSocialOAuth")
'	msd.AddLabel1(8,54,"ABMCaptcha")
'	msd.AddLabel1(9,54,"ABMFirebaseAuth")
'	
'	
'	'events
'	msd.AddNode2(12,40,12,41,"Events")
'	msd.AddLabel1(13,41,"ABMCalendar")
'	msd.AddLabel1(14,41,"ABMChronologyList")
'	msd.AddLabel1(15,41,"ABMPlanner")
'		
'	'tools
'	msd.AddNode2(9,45,9,46,"Reporting & Other")
'	msd.AddLabel1(10,46,"ABMReport")
'	msd.AddLabel1(11,46,"ABMChart")
'	msd.AddLabel1(12,46,"ABMFrappeChart")
'	msd.AddLabel1(13,46,"ABMPivotTable")
'	msd.AddLabel1(14,46,"ABMGoogleMap")
'	msd.AddLabel1(15,46,"ABMChat")
'	msd.AddLabel1(16,46,"ABMGenerator")
'	msd.AddLabel1(17,46,"ABMGridBuilder")
'	msd.AddLabel1(18,46,"ABMConzole")
'	msd.AddLabel1(19,46,"ABMXTR")
'	msd.AddLabel1(20,46,"ABMFirebaseStorage")
'	msd.AddLabel1(21,46,"ABMJustGauge")
'	msd.AddLabel1(22,46,"ABMDragDrop")
'	msd.AddLabel1(23,46,"ABMAnimation")
'	msd.AddLabel1(24,46,"ABMTheme")
'	msd.AddLabel1(25,46,"ABMTreeTable")
'	msd.AddLabel1(26,46,"ABMWebAppViewer")
'	
'	
'	'connections
'	msd.AddConnection("Security","ABMaterial")
'	msd.AddConnection("Tools","ABMaterial")
'	msd.AddConnection("Events","ABMaterial")
'	msd.AddConnection("Navigation","ABMaterial")
'	msd.AddConnection("Layouts","ABMaterial")
'	msd.AddConnection("Media","ABMaterial")
'	msd.AddConnection("Input Controls","ABMaterial")
'	msd.AddConnection("Buttons","ABMaterial")
'	msd.AddConnection("Reporting & Other","ABMaterial")
'	
'	'add a connection style
'	'msd.AddLineStyle("Security","color:red;")
'	'msd.AddLineClass("Security","red")
'	'page.Cell(2,1).AddComponent(msd.ABMComp)
'	
''	MashPlugIns.AddTheme("redgreen",ABM.COLOR_RED,"",ABM.COLOR_GREEN,ABM.INTENSITY_LIGHTEN3)
''	MashPlugIns.AddTheme("whitelightblue",ABM.COLOR_WHITE,"",ABM.COLOR_LIGHTBLUE,"")
''	MashPlugIns.AddTheme("whitered",ABM.COLOR_WHITE,"",ABM.COLOR_RED,"")
''	MashPlugIns.AddTheme("alert","","",ABM.COLOR_LIGHTBLUE,"")
''	MashPlugIns.AddTheme("whiteamber","white","","amber","")
''	MashPlugIns.AddTheme("whitegreen","white","","green","")
''	MashPlugIns.AddTheme("whiteblue","white","","blue","")
''	MashPlugIns.AddTheme("whitered","white","","red","")
''	MashPlugIns.AddTheme("whiteblack","white","","black","")
''	MashPlugIns.AddTheme("wy","white","","yellow","")
''	MashPlugIns.AddTheme("whiteorange","white","","orange","")
''	MashPlugIns.AddTheme("redorange","red","","orange","")
''	MashPlugIns.AddTheme("blacktext","black","","","")
''	MashPlugIns.AddTheme("orangetext","orange","","","")
''	MashPlugIns.AddTheme("lightblue",ABM.COLOR_LIGHTBLUE,"",ABM.COLOR_TRANSPARENT,"")
''	MashPlugIns.AddTheme("selectiontheme",ABM.COLOR_TRANSPARENT,ABM.INTENSITY_NORMAL,ABM.COLOR_BLUE,ABM.INTENSITY_LIGHTEN5)	
''	MashPlugIns.AddTheme("card1",ABM.COLOR_WHITE,ABM.INTENSITY_NORMAL,ABM.COLOR_GREEN,ABM.INTENSITY_NORMAL)
''	MashPlugIns.AddTheme("footer",ABM.COLOR_GREY, ABM.INTENSITY_NORMAL,ABM.COLOR_TRANSPARENT,ABM.INTENSITY_NORMAL)
'	
''	Dim lbl As ABMLabel
''	lbl.Initialize(page,"lbl","MashColorPicker","p",False,"")
''	page.Cell(2,1).AddComponent(lbl)
''	
'	'Dim mcp As MashColorPicker
'	'mcp.Initialize(page,"mcp","Eye Colour","","")
'	'page.Cell(3,1).AddComponent(mcp.ABMComp)
'	
'	'Dim mcp1 As MashColorPicker
'	'mcp1.Initialize(page,"mcp1","Pick from FireFox","../images/firefox.png","")
'	'page.Cell(4,1).AddComponent(mcp1.ABMComp)
'	
'	'Dim mcp2 As MashColorPicker
'	'mcp2.Initialize(page,"mcp2","Pick from Eric","../images/eric.png","")
'	'page.Cell(5,1).AddComponent(mcp2.ABMComp)
'	
'	
'	'mcp3.Initialize(page,"mcp3","Pick from Most Colors","../images/most.png","")
'	'page.Cell(6,1).AddComponent(mcp3.ABMComp)
'	
'	
'	'Dim ma As MashAccordion
'	'ma.Initialize(page,"ma","")
'	'ma.AddItem("warning","Warning",MashPlugIns.MaterialIcons.mdi_3d_rotation,"",MashPlugIns.EnumThemes.warn,"","","")
'	'ma.AddItem("danger","Danger",MashPlugIns.MaterialIcons.mdi_ac_unit,"",MashPlugIns.EnumThemes.danger,"","","")
'	'ma.AddItem("success","Success",MashPlugIns.MaterialIcons.mdi_access_alarm,"",MashPlugIns.EnumThemes.success,"","","")
'	'ma.AddItem("primary","Primary",MashPlugIns.MaterialIcons.mdi_account_balance,"",MashPlugIns.EnumThemes.primary,"","","")
'	'ma.AddItem("info","Info",MashPlugIns.MaterialIcons.mdi_access_time,"",MashPlugIns.EnumThemes.info,"","","")
'	'ma.AddItem("muted","Muted",MashPlugIns.MaterialIcons.mdi_accessible,"",MashPlugIns.EnumThemes.muted,"","","")
'	'ma.AddItemAvatar("mashy","../images/sponge.png","Mashy here","","","","","")
'	'ma.Animate(MashPlugIns.Anime.Specials_rollIn,False,"")
'	'page.Cell(3,1).AddComponent(ma.ABMComp)
'	
'	'Dim ma1 As MashAccordion
'	'ma1.Initialize(page,"ma1","")
'	'ma1.CollapsibleType = ma1.EnumType.expandable
'	'ma1.AddItem("warning","Warning",MashPlugIns.MaterialIcons.mdi_3d_rotation,"",MashPlugIns.EnumThemes.warn_transparent,"","2",MashPlugIns.EnumThemes.black_orange)
'	'ma1.AddSubItem("warning","warning1","This is warning 1",MashPlugIns.MaterialIcons.mdi_format_color_text,"",MashPlugIns.EnumThemes.warn_transparent, _
'	'MashPlugIns.EnumThemes.green_transparent,"","")
'	'ma1.AddSubItemAvatar("warning","mashy","../images/sponge.png","Mashy","Testing another...","","","100",MashPlugIns.EnumThemes.white_green)
'	'ma1.AddSubItem("warning","warning2","This is warning 2",MashPlugIns.MaterialIcons.mdi_accessibility,"",MashPlugIns.EnumThemes.warn_transparent,"","","")
'	'ma1.AddItem("danger","Danger",MashPlugIns.MaterialIcons.mdi_ac_unit,"",MashPlugIns.EnumThemes.danger_transparent,"","","")
'	'ma1.AddItem("success","Success",MashPlugIns.MaterialIcons.mdi_access_alarm,"",MashPlugIns.EnumThemes.success_transparent,"","","")
'	'ma1.AddItem("primary","Primary",MashPlugIns.MaterialIcons.mdi_account_balance,"",MashPlugIns.EnumThemes.primary_transparent,"","","")
'	'ma1.AddItem("info","Info",MashPlugIns.MaterialIcons.mdi_access_time,"",MashPlugIns.EnumThemes.info_transparent,"","","")
'	'ma1.AddItem("muted","Muted",MashPlugIns.MaterialIcons.mdi_accessible,"",MashPlugIns.EnumThemes.muted_transparent,"","","")
'	'page.Cell(3,2).AddComponent(ma1.ABMComp)
'	
'	'Dim ma2 As MashAccordion
'	'ma2.Initialize(page,"ma2","")
'	'ma2.AddItem("warning","Warning",MashPlugIns.MaterialIcons.mdi_3d_rotation,"","",MashPlugIns.EnumThemes.warn_transparent,"","")
'	'ma2.AddItem("danger","Danger",MashPlugIns.MaterialIcons.mdi_ac_unit,"","",MashPlugIns.EnumThemes.danger_transparent,"","")
'	'ma2.AddItem("success","Success",MashPlugIns.MaterialIcons.mdi_access_alarm,"","",MashPlugIns.EnumThemes.success_transparent,"","")
'	'ma2.AddItem("primary","Primary",MashPlugIns.MaterialIcons.mdi_account_balance,"","",MashPlugIns.EnumThemes.primary_transparent,"","")
'	'ma2.AddItem("info","Info",MashPlugIns.MaterialIcons.mdi_access_time,"","",MashPlugIns.EnumThemes.info_transparent,"","")
'	'ma2.AddItem("muted","Muted",MashPlugIns.MaterialIcons.mdi_accessible,"","",MashPlugIns.EnumThemes.muted_transparent,"","")
'	'page.Cell(4,1).AddComponent(ma2.ABMComp)
'		
'	
''	'create a MashCardPanel 6 size for each device
''	Dim mp As MashCardPanel
''	mp.Initialize(page,"mp","My Card Panel","Testing my card panel",6,6,6,"")
''	'set a header theme, for the attached image, this was commented out
''	mp.HeaderTheme = MashPlugIns.EnumThemes.info
''	'add the buttons
''	mp.AddMenuButton("info","mdi-info_outline",MashPlugIns.EnumThemes.warn)
''	mp.AddMenuButton("help","mdi-help_outline",MashPlugIns.EnumThemes.danger)
''	mp.AddMenuButton("refresh","mdi-loop",MashPlugIns.EnumThemes.info)
''	mp.AddMenuButton("menu","mdi-more_vert",MashPlugIns.EnumThemes.success)
'''	'define the container structure, 5 rows with 2 columns, each 6 spaces each
''	mp.Content.AddRows(5,False,"").AddCellsOSMP(2,0,0,0,6,6,6,0,0,0,0,"")
''	'add a mashappstore components
''	Dim storea As MashAppStore
''	storea.Initialize(page,"apple",MashPlugIns.EnumThemes.warn)
''	'add the component at R1C1 of the card panel, 
''	mp.content.AddComponent(1,1,storea.html)
''	
''	Dim mib1 As MashInfoBox
''	mib1.Initialize(page,"mib1",MashPlugIns.MaterialIcons.mdi_shopping_cart,"NEW ORDERS","125",12,12,12,MashPlugIns.EnumThemes.danger)
''	mib1.Animated = True
''	'mp.Content.addcomponent(1,2,mib1.HTML)
''	
''	pillB1.Initialize(page,"pillB1","ABMaterial 4.03",MashPlugIns.EnumThemes.danger)
''	mp.Content.AddComponent(3,2,pillB1.HTML)
''	
''	Dim imge As MashUserStatus
''	imge.Initialize(page,"eric","../images/eric.png",True,"whitered")
''	imge.SetSize("90","90")
''	imge.ArrayName = "statusimage"
''	imge.Warn
''	mp.Content.AddComponent(3,1,imge.HTML)
'	
''	ribbon.Initialize(page,"ribbon","Mashy","whitegreen")
''	ribbon.setsizes(12,12,12)
''	ribbon.ArrayName = "ribbon"
''	ribbon.Content.AddRows(1,False,"").AddCells12(1,"")
''	Dim p As HTMLElement
''	p = p.CreateP("").AddContent("This is a test for the Ribbon creation. Enyoy!").SetPadding("10").setmargin("10")
''	ribbon.Content.AddComponent(1,1,p.HTML)
''	mp.content.addcomponent(5,1,ribbon.HTML)
''	
''	Dim rbn2 As MashRibbon
''	rbn2.Initialize(page,"rbn2","Anelicious","whitered")
''	rbn2.setsizes(12,12,12)
''	rbn2.Content.AddRows(3,False,"").AddCellsOSMP(2,0,0,0,6,6,6,0,0,0,0,"")
''	rbn2.ArrayName = "ribbon"
''	Dim p As HTMLElement
''	p = p.CreateP("").AddContent("1").SetPadding("10").setmargin("10").CenterAlign
''	rbn2.Content.AddComponent(1,1,p.HTML)
''	p = p.CreateP("").AddContent("2").SetPadding("10").setmargin("10").CenterAlign
''	rbn2.Content.AddComponent(1,2,p.HTML)
''	p = p.CreateP("").AddContent("3").SetPadding("10").setmargin("10").CenterAlign
''	rbn2.Content.AddComponent(2,1,p.HTML)
''	p = p.CreateP("").AddContent("4").SetPadding("10").setmargin("10").CenterAlign
''	rbn2.Content.AddComponent(2,2,p.HTML)
''	p = p.CreateP("").AddContent("5").SetPadding("10").setmargin("10").CenterAlign
''	rbn2.Content.AddComponent(3,1,p.HTML)
''	p = p.CreateP("").AddContent("6").SetPadding("10").setmargin("10").CenterAlign
''	rbn2.Content.AddComponent(3,2,p.HTML)
''	
''	rbn2.onright = True
''	mp.content.addcomponent(5,2,rbn2.HTML)
''	
''page.Cell(2,1).AddComponent(mp.ABMComp)
''	
''	'panel
''	pnl.Initialize(page,"pnl","Introduction","A summary on Project Progress","")
''	pnl.SetSizes(6,6,6)
''	'pnl.Hoverable = True
''	pnl.Content.AddRows(1,False,"").AddCellsOSMP(2,0,0,0,6,6,6,0,0,0,0,"")
''	pnl.Content.addcomponent(1,2,mib1.HTML)
'	'change to your own color
'	'pnl.SetBorderColor(ABM.COLOR_BLUEGREY, ABM.INTENSITY_LIGHTEN5)
'	'page.Cell(2,1).AddComponent(pnl.ABMComp)
'	
'	'create the necessary themes, this comes up with the toolbar
'	'MashPlugIns.AddTheme("darkred",ABM.COLOR_WHITE,ABM.INTENSITY_NORMAL,ABM.COLOR_RED,ABM.INTENSITY_LIGHTEN2)
'	'MashPlugIns.AddTheme("lightgrey",ABM.COLOR_WHITE,ABM.INTENSITY_NORMAL,ABM.COLOR_GREY,ABM.INTENSITY_LIGHTEN2)
'	'MashPlugIns.AddTheme("darkred",ABM.COLOR_WHITE,ABM.INTENSITY_NORMAL,ABM.COLOR_RED,ABM.INTENSITY_LIGHTEN2)
'	'MashPlugIns.AddTheme("lightgreen",ABM.COLOR_WHITE,ABM.INTENSITY_NORMAL,ABM.COLOR_GREEN,ABM.INTENSITY_DARKEN2)
'	'create the panel
'	'Dim pnlapple As MashApplePanel
'	'pnlapple.Initialize(page,"applepanel")
'	'make the panel 6 for all devices, better to make it 12 for small devices
'	'pnlapple.SetSizes(6,6,6)
'	'add a row using the dark red theme
'	'pnlapple.Content.AddRowsM(1,False,0,0,"").AddCells12(1,"darkred")
'	'add a row with 2 cells, 2 + 9 using the different themes
'	'pnlapple.Content.AddRowsM(1,False,0,0,"").AddCellsOSMP(1,0,0,0,3,3,3,0,0,0,0,"lightgrey").AddCellsOSMP(1,0,0,0,9,9,9,0,0,0,0,"lightgreen")
'	'set the height of each of the rows
'	'pnlapple.Content.SetFixedHeight(1,"42px")
'	'pnlapple.Content.SetFixedHeight(2,"500px")
'	'add the component to the page
'	'page.Cell(2,1).AddComponent(pnlapple.ABMComp)
'		
'	
'	'container demonstration	
'	'Dim cont As MashContainer
'	'cont.Initialize(page,"cont")
'	'cont.AddRows(5,False,"").AddCellsOSMP(2,0,0,0,6,6,6,0,0,0,0,"")
'	
'	'Dim storea As MashAppStore
'	'storea.Initialize(page,"apple",MashPlugIns.EnumThemes.warn)
'	'cont.AddComponent(2,1,storea.html)
'	'page.Cell(2,1).AddComponent(cont.ABMComp)
'	
'	'Dim inlineEdit As MashEditable
'	'inlineEdit.Initialize(page,"inlineedit")
'	'inlineEdit.SetSizes(12,4,4)
'	'inlineEdit.SetBorderWidthStyleRadiusColor(1,MashPlugIns.EnumBorderStyle.bSolid,2,ABM.COLOR_BLACK,ABM.INTENSITY_LIGHTEN5)
'	'page.Cell(2,1).AddComponent(inlineEdit.ABMComp)
'	
'	'user activity
'	'Dim ua As MashUserActivity
'	'ua.Initialize(page,"ua")
'	'page.Cell(2,1).AddComponent(ua.ABMComp)
'	
'	'skype
'	'Dim call As MashSkype
'	'call.Initialize(page,"call","anele@mbangas.com","Mashy",MashPlugIns.EnumThemes.white_green)
'	'page.Cell(2,1).AddComponent(call.ABMComp)
'	
'	
'	'Dim rlbl As MashRoundLabel
'	'rlbl.Initialize(page,"rlbl","5",MashPlugIns.EnumThemes.danger)
'	'page.Cell(2,1).AddComponent(rlbl.ABMComp)
'	
'	
''	Dim store1 As MashAppStore
''	store1.Initialize(page,"apple",MashPlugIns.EnumThemes.warn)
''	page.Cell(2,1).AddComponent(store1.ABMComp)
''	
''	Dim store2 As MashAppStore
''	store2.Initialize(page,"google",MashPlugIns.EnumThemes.danger)
''	store2.MyStore = store1.EnumStore.google
''	page.Cell(2,1).AddComponent(store2.ABMComp)
''	
''	Dim mib As MashInfoBox
''	mib.Initialize(page,"mib",MashPlugIns.MaterialIcons.mdi_shopping_cart,"NEW ORDERS","125",12,3,3,MashPlugIns.EnumThemes.danger)
''	mib.Animated = True
''	File.WriteString(File.dirapp,"mib-ano.txt",mib.HTML)
''	page.cell(2,1).AddComponent(mib.ABMComp)
''	
''	Dim mib1 As MashInfoBox
''	mib1.Initialize(page,"mib1",MashPlugIns.MaterialIcons.mdi_face,"NEW MEMBERS","257",12,3,3,MashPlugIns.EnumThemes.warn)
''	mib1.Animated = True
''	page.cell(2,1).AddComponent(mib1.ABMComp)
''	
''	Dim mib2 As MashInfoBox
''	mib2.Initialize(page,"mib2",MashPlugIns.MaterialIcons.mdi_bookmark,"BOOKMARKS","117",12,3,3,MashPlugIns.EnumThemes.success)
''	mib2.Animated = True
''	page.cell(2,1).AddComponent(mib2.ABMComp)
'''	
''	Dim mib3 As MashInfoBox
''	mib3.Initialize(page,"mib3",MashPlugIns.MaterialIcons.mdi_favorite,"LIKES","1432",12,3,3,MashPlugIns.EnumThemes.info)
''	mib3.Animated = True
''	page.cell(2,1).AddComponent(mib3.ABMComp)
''	
''	'HoverZoom
''	Dim mib4 As MashInfoBox
''	mib4.Initialize(page,"mib4",MashPlugIns.MaterialIcons.mdi_email,"EMAIL","15",12,3,3,MashPlugIns.EnumThemes.danger)
''	mib4.HoverZoom = True
''	page.cell(2,1).AddComponent(mib4.ABMComp)
''	
''	Dim mib5 As MashInfoBox
''	mib5.Initialize(page,"mib5",MashPlugIns.MaterialIcons.mdi_devices,"CPU USAGE","92%",12,3,3,MashPlugIns.EnumThemes.warn)
''	mib5.HoverZoom = True
''	page.cell(2,1).AddComponent(mib5.ABMComp)
''	
''	Dim mib6 As MashInfoBox
''	mib6.Initialize(page,"mib6",MashPlugIns.MaterialIcons.mdi_access_alarm,"ALARM","2:50 PM",12,3,3,MashPlugIns.EnumThemes.success)
''	mib6.HoverZoom = True
''	page.cell(2,1).AddComponent(mib6.ABMComp)
''	
''	Dim mib7 As MashInfoBox
''	mib7.Initialize(page,"mib7",MashPlugIns.MaterialIcons.mdi_gps_fixed,"LOCATION","East London, RSA",12,3,3,MashPlugIns.EnumThemes.info)
''	mib7.HoverZoom = True
''	page.cell(2,1).AddComponent(mib7.ABMComp)
''	
''	'Hoverexpand
''	Dim mib8 As MashInfoBox
''	mib8.Initialize(page,"mib8",MashPlugIns.MaterialIcons.mdi_equalizer,"RATE","62%",12,3,3,MashPlugIns.EnumThemes.tealbc)
''	mib8.HoverExpand = True
''	page.cell(2,1).AddComponent(mib8.ABMComp)
''	
''	Dim mib9 As MashInfoBox
''	mib9.Initialize(page,"mib9",MashPlugIns.MaterialIcons.mdi_flight_takeoff,"FLIGHT","06:00 AM",12,3,3,MashPlugIns.EnumThemes.greenbc)
''	mib9.HoverExpand = True
''	page.cell(2,1).AddComponent(mib9.ABMComp)
''	
''	MashPlugIns.AddTheme("rw","red","","white","")
''	Dim mib10 As MashInfoBox
''	mib10.Initialize(page,"mib10",MashPlugIns.MaterialIcons.mdi_battery_charging_full,"BATTERY","CHARGING",12,3,3,MashPlugIns.EnumThemes.lightgreenbc)
''	mib10.HoverExpand = True
''	mib10.IconTheme = "rw"
''	page.cell(2,1).AddComponent(mib10.ABMComp)
''	
''	Dim mib11 As MashInfoBox
''	mib11.Initialize(page,"mib11",MashPlugIns.MaterialIcons.mdi_brightness_low,"BRIGHTNESS","40%",12,3,3,MashPlugIns.EnumThemes.limebc)
''	mib11.HoverExpand = True
''	mib11.ThemeContent = True
''	page.cell(2,1).AddComponent(mib11.ABMComp)
''	
''	
''	
'	Dim mlistView As MashListView
'	mlistView.Initialize(page,"mlistView")
'	mlistView.GroupItems = True
'	mlistView.AddItemIcon("icon",MashPlugIns.MaterialIcons.mdi_access_time,"AddItem","Description",True,"mutedtext","successtext","10",True,"")
'	mlistView.AddItemAvatar("mashy","../images/sponge.png","Mashy","Loving ABMaterial",False,"successtext","",False,"")
'	mlistView.AddItemAvatar("eric","../images/eric.png","Eric","A comedian",False,"successtext","South Central",False,"")
'	mlistView.AddItemAvatar("kenny","../images/kenny.png","Kenny","",False,"successtext","",False,"")
'	mlistView.AddItemAvatar("kyle","../images/kyle.png","Kyle","",False,"successtext","Hey there!",False,"")
'	mlistView.AddItemAvatar("mommy","../images/mom.jpg","Mommy","",False,"successtext","",False,"")
'	'page.Cell(2,1).AddComponent(mlistView.ABMComp)
''	
''	'tabs.Initialize(page,"mashtabs")
''	'page.Cell(3,1).AddComponent(tabs.ABMComp)
''	
''	mashp.Initialize(page,"progress","whiteblue")
''	mashp.Value = "5"
''	mashp.Small = True
''	'mashp.ShowToolTip = True
''	page.Cell(3,1).AddComponent(mashp.ABMComp)
''	
''	Dim mashp1 As MashProgress
''	mashp1.Initialize(page,"progress1","whitered")
''	mashp1.Value = "50.5"
''	'mashp1.ShowToolTip = True
''	page.Cell(4,1).AddComponent(mashp1.ABMComp)
''	
''	Dim mashp2 As MashProgress
''	mashp2.Initialize(page,"progress2","whiteorange")
''	mashp2.Value = "30"
''	'mashp2.ShowToolTip = True
''	'mashp2.Overlay = True
''	'mashp2.Striped = True
''	page.Cell(5,1).AddComponent(mashp2.ABMComp)
''	
''	Dim pstacked As MashProgress
''	pstacked.Initialize(page,"pstacked","")
''	pstacked.AddProgress("35","danger")
''	pstacked.AddProgress("20","warn")
''	pstacked.AddProgress("10","success")
''	page.Cell(6,1).AddComponent(pstacked.ABMComp)
'	
'	
''	ribbon.Initialize(page,"ribbon","Mashy","whitegreen")
''	ribbon.setsizes(6,6,6)
''	Dim p As HTMLElement
''	p = p.CreateP("").AddContent("This is a test for the Ribbon creation. Enyoy!")
''	p.SetPadding("10")
''	p.setmargin("10")
''	ribbon.ArrayName = "ribbon"
''	ribbon.SetContent(p.HTML)
''	'page.Cell(3,1).AddComponent(ribbon.ABMComp)
''	
''	Dim rbn2 As MashRibbon
''	rbn2.Initialize(page,"rbn2","Anelicious","whitered")
''	rbn2.setsizes(6,6,6)
''	rbn2.ArrayName = "ribbon"
''	Dim p As HTMLElement
''	p = p.CreateP("").AddContent("A right aligned Ribbon Enyoy!")
''	p.SetPadding("10")
''	p.setmargin("10")
''	rbn2.SetContent(p.HTML)
''	rbn2.onright = True
''	'page.Cell(3,1).AddComponent(rbn2.ABMComp)
'	
'	
''	img.Initialize(page,"mashy","../images/sponge.png",True)
''	img.Circle = True
''	img.SetSize("60","60")
''	img.SetBadge("15","whiteorange")
''	img.Bordered = True
''	img.SetBorderColor(ABM.COLOR_INDIGO,ABM.INTENSITY_DARKEN2)
''	img.SetMargins("10")
''	img.arrayname = "images"
''	img.Responsive = True
''	page.Cell(3,1).AddComponent(img.ABMComp)
''	
''	img1.Initialize(page,"teencoach","../images/152.png",True)
''	img1.SetBadge("44","whiteorange")
''	img1.Bordered = True
''	img1.SetMargins("10")
''	img1.arrayname = "images"
''	img1.Responsive = True
''	img1.RoundedCorners = True
''	img1.Circle = True
''	img1.SetSize(200,200)
''	page.Cell(3,1).AddComponent(img1.ABMComp)
''	
''	imgs.Initialize(page,"statusimage","../images/sponge.png",True,"whitegreen")
''	imgs.SetSize("90","90")
''	imgs.ArrayName = "statusimage"
''	imgs.Bordered = True
''	page.Cell(3,1).AddComponent(imgs.ABMComp)
''	
''	Dim imgMom As MashUserStatus
''	imgMom.Initialize(page,"mom","../images/mom.jpg",True,"redgreen")
''	imgMom.SetSize("90","90")
''	imgMom.ArrayName = "statusimage"
''	'imgMom.Bordered = True
''	page.Cell(3,1).AddComponent(imgMom.ABMComp)
''	
''	Dim imga As MashUserStatus
''	imga.Initialize(page,"car","../images/1.jpg",True,"whitered")
''	imga.SetSize("90","90")
''	imga.ArrayName = "statusimage"
''	'imgMom.Bordered = True
''	page.Cell(3,1).AddComponent(imga.ABMComp)
''	
''	'Dim imge As MashUserStatus
''	'imge.Initialize(page,"eric","../images/eric.png",True,"whitered")
''	'imge.SetSize("90","90")
''	'imge.ArrayName = "statusimage"
''	'imge.warn
''	'page.Cell(3,1).AddComponent(imge.ABMComp)
''	
''	
''	
''	MashPlugIns.AddTheme("wo","white","","orange","")
''	MashPlugIns.AddTheme("bd","black","","orange","")
''	
''	knob.Initialize(page,"knob","Tron", "25", "200px","200px","wo")
''	'knob.Tron = True
''	knob.ThickNess = "0.15"
''	knob.ReadOnly = True
''	page.Cell(3,1).AddComponent(knob.ABMComp)
''	
''	Dim knob6 As MashDial
''	knob6.Initialize(page,"knob6","250 x -305", "90", "200px","200px","wo")
''	knob6.SetAngleArcOffset("250","-305")
''	knob6.Suffix = "%"
''	knob6.Animated = True
''	page.Cell(3,1).AddComponent(knob6.ABMComp)
''	
''	Dim knob7 As MashDial
''	knob7.Initialize(page,"knob7","250 x -35", "25", "200px","200px","wo")
''	knob7.SetAngleArcOffset("250","-35")
''	page.Cell(3,1).AddComponent(knob7.ABMComp)
''	
''	Dim knob8 As MashDial
''	knob8.Initialize(page,"knob8","250 x 145 (ReadOnly)", "25", "200px","200px","wo")
''	knob8.SetAngleArcOffset("250","145")
''	knob8.ReadOnly = True
''	page.Cell(3,1).AddComponent(knob8.ABMComp)
''	
''	Dim knob9 As MashDial
''	knob9.Initialize(page,"knob9","270 x -0", "25", "200px","200px","wo")
''	knob9.SetAngleArcOffset("270","-0")
''	page.Cell(3,1).AddComponent(knob9.ABMComp)
''	
''	Dim knob10 As MashDial
''	knob10.Initialize(page,"knob10","270 x 90", "25", "200px","200px","wo")
''	knob10.SetAngleArcOffset("270","90")
''	page.Cell(3,1).AddComponent(knob10.ABMComp)
''	
''	Dim knob11 As MashDial
''	knob11.Initialize(page,"knob11","270 x -0", "100", "200px","200px","wo")
''	knob11.SetAngleArcOffset("270","-0")
''	knob11.Tron = True
''	knob11.thickness = "0.2"
''	page.Cell(3,1).AddComponent(knob11.ABMComp)
''	
''	Dim knob12 As MashDial
''	knob12.Initialize(page,"knob12","250 x -125", "100", "200px","200px","wo")
''	knob12.SetAngleArcOffset("250","-125")
''	knob12.Tron = True
''	knob12.thickness = "0.2"
''	page.Cell(3,1).AddComponent(knob12.ABMComp)
''	
''	
''	knob1.Initialize(page,"knob1","Cursor", "50", "200px","200px","bd")
''	knob1.Cursor = True
''	knob1.ThickNess = "0.20"
''	page.Cell(3,1).AddComponent(knob1.ABMComp)
''	
''	knob2.Initialize(page,"knob2","Display Previous", "50", "200px","200px",MashPlugIns.EnumThemes.deeppurplebc)
''	knob2.DisplayPrevious = True
''	knob2.MinValue = "-100"
''	knob2.ThickNess = "0.30"
''	page.Cell(3,1).AddComponent(knob2.ABMComp)
''	
''	knob3.Initialize(page,"knob3","Line Cap", "50", "200px","200px",MashPlugIns.EnumThemes.bluebc)
''	knob3.LineCap = knob3.EnumLineCap.lcround
''	knob3.ThickNess = "0.40"
''	page.Cell(3,1).AddComponent(knob3.ABMComp)
''	
''	knob4.Initialize(page,"knob4","Angle Arc", "50", "200px","200px",MashPlugIns.EnumThemes.brownbc)
''	knob4.angleoffset = "-125"
''	knob4.anglearc = "250"
''	page.Cell(3,1).AddComponent(knob4.ABMComp)
''	
''	knob5.Initialize(page,"knob5","Steps", "1000", "200px","200px",MashPlugIns.EnumThemes.orangebc)
''	knob5.maxvalue = "15000"
''	knob5.Stepping = "1000"
''	knob5.MinValue = "-15000"
''	knob5.Cursor = True
''	page.Cell(3,1).AddComponent(knob5.ABMComp)
''	
''		
''	'dashboard buttons
''	dbButton.Initialize(page,"dbButton",MashPlugIns.MaterialIcons.mdi_desktop_windows,"Windows",MashPlugIns.EnumThemes.danger)
''	dbButton.SetBadge(20,MashPlugIns.EnumThemes.Warn,False)
''	page.Cell(2,1).AddComponent(dbButton.ABMComp)
''	dbButton1.Initialize(page,"dbButton1",MashPlugIns.MaterialIcons.mdi_3d_rotation,"Rotation",MashPlugIns.EnumThemes.info)
''	page.Cell(2,1).AddComponent(dbButton1.ABMComp)
''	dbButton2.Initialize(page,"dbButton2",MashPlugIns.MaterialIcons.mdi_access_alarms,"Warning",MashPlugIns.EnumThemes.Warn)
''	dbButton2.SetBadge(50,MashPlugIns.EnumThemes.Warn,True)
''	page.Cell(2,1).AddComponent(dbButton2.ABMComp)
''	
''	'pill buttons
''	'pillB1.Initialize(page,"pillB1","ABMaterial 4.03",MashPlugIns.EnumThemes.danger)
''	'page.Cell(3,1).AddComponent(pillB1.ABMComp)
''	pillB2.Initialize(page,"pillB2","Rotation",MashPlugIns.EnumThemes.info)
''	page.Cell(3,1).AddComponent(pillB2.ABMComp)
''	pillB3.Initialize(page,"pillB3","Warning",MashPlugIns.EnumThemes.Warn)
''	page.Cell(3,1).AddComponent(pillB3.ABMComp)
''	
''	'normal button group
''	bg.Initialize(page,"bg")
''	bg.Margin = "10"
''	bg.AddButton("btnLeftv","Left",MashPlugIns.MaterialIcons.mdi_3d_rotation,MashPlugIns.EnumIconPosition.IconLeft,MashPlugIns.EnumThemes.danger)
''	bg.AddButton("btnMiddlev","Middle",MashPlugIns.MaterialIcons.mdi_access_alarms,MashPlugIns.EnumIconPosition.IconRight,MashPlugIns.EnumThemes.info)
''	bg.AddButton("btnRightv","Right",MashPlugIns.MaterialIcons.mdi_accessibility,MashPlugIns.EnumIconPosition.IconLeft,MashPlugIns.EnumThemes.Warn)
''	bg.AddButtonBadge("btnRightvb","Badge",MashPlugIns.MaterialIcons.mdi_accessibility,MashPlugIns.EnumIconPosition.IconLeft,MashPlugIns.EnumThemes.Warn,10,MashPlugIns.EnumThemes.danger,False)
''	bg.AddButtonCircleBadge("btnCircle",MashPlugIns.MaterialIcons.mdi_airline_seat_recline_normal,MashPlugIns.EnumButtonSize.large, _
''	MashPlugIns.EnumThemes.Warn,"30",MashPlugIns.EnumThemes.info) 
''	page.Cell(4,1).AddComponent(bg.ABMComp)
''	
''	'button group with floating buttons
''	bgc.Initialize(page,"bgc")
''	bgc.IsFloating = True
''	bgc.ButtonSize = MashPlugIns.EnumButtonSize.large
''	bgc.AddButton("btnLeftc","Left",MashPlugIns.MaterialIcons.mdi_3d_rotation,MashPlugIns.EnumIconPosition.IconLeft,MashPlugIns.EnumThemes.danger)
''	bgc.AddButton("btnMiddlec","Middle",MashPlugIns.MaterialIcons.mdi_access_alarms,MashPlugIns.EnumIconPosition.IconRight,MashPlugIns.EnumThemes.info)
''	bgc.AddButton("btnRightc","Right",MashPlugIns.MaterialIcons.mdi_accessibility,MashPlugIns.EnumIconPosition.IconLeft,MashPlugIns.EnumThemes.Warn)
''	bgc.AddButtonBadge("btnRightcb","Badge",MashPlugIns.MaterialIcons.mdi_accessibility,MashPlugIns.EnumIconPosition.IconLeft,MashPlugIns.EnumThemes.Warn,10,MashPlugIns.EnumThemes.danger,False)
''	page.Cell(5,1).AddComponent(bgc.ABMComp)
''	
''	'button group with half circle down
''	bghc.Initialize(page,"bghc")
''	bghc.HalfCircleDown = True
''	bghc.ButtonSize = MashPlugIns.EnumButtonSize.large
''	bghc.AddButton("btnLefthc","Left",MashPlugIns.MaterialIcons.mdi_3d_rotation,MashPlugIns.EnumIconPosition.IconLeft,MashPlugIns.EnumThemes.danger)
''	bghc.AddButton("btnMiddlehc","Middle",MashPlugIns.MaterialIcons.mdi_access_alarms,MashPlugIns.EnumIconPosition.IconRight,MashPlugIns.EnumThemes.info)
''	bghc.AddButton("btnRighthc","Right",MashPlugIns.MaterialIcons.mdi_accessibility,MashPlugIns.EnumIconPosition.IconLeft,MashPlugIns.EnumThemes.Warn)
''	page.Cell(6,1).AddComponent(bghc.ABMComp)
''	
''	'button group with half circle up
''	bgcu.Initialize(page,"bgcu")
''	bgcu.HalfCircleUp = True
''	bgcu.ButtonSize = MashPlugIns.EnumButtonSize.large
''	bgcu.AddButton("btnLefthcu","Left",MashPlugIns.MaterialIcons.mdi_3d_rotation,MashPlugIns.EnumIconPosition.IconLeft,MashPlugIns.EnumThemes.danger)
''	bgcu.AddButton("btnMiddlehcu","Middle",MashPlugIns.MaterialIcons.mdi_access_alarms,MashPlugIns.EnumIconPosition.IconRight,MashPlugIns.EnumThemes.info)
''	bgcu.AddButton("btnRighthcu","Right",MashPlugIns.MaterialIcons.mdi_accessibility,MashPlugIns.EnumIconPosition.IconLeft,MashPlugIns.EnumThemes.Warn)
''	page.Cell(6,1).AddComponent(bgcu.ABMComp)
''	
''	'button group with half circle to left
''	bgcl.Initialize(page,"bgcl")
''	bgcl.HalfCircleLeft = True
''	bgcl.ButtonSize = MashPlugIns.EnumButtonSize.large
''	bgcl.AddButton("btnLefthc","Left",MashPlugIns.MaterialIcons.mdi_3d_rotation,MashPlugIns.EnumIconPosition.IconLeft,MashPlugIns.EnumThemes.danger)
''	bgcl.AddButton("btnMiddlehc","Middle",MashPlugIns.MaterialIcons.mdi_access_alarms,MashPlugIns.EnumIconPosition.IconRight,MashPlugIns.EnumThemes.info)
''	bgcl.AddButton("btnRighthc","Right",MashPlugIns.MaterialIcons.mdi_accessibility,MashPlugIns.EnumIconPosition.IconLeft,MashPlugIns.EnumThemes.Warn)
''	page.Cell(6,1).AddComponent(bgcl.ABMComp)
''	
''	'button group with half cirle to right
''	bgcr.Initialize(page,"bgcr")
''	bgcr.HalfCircleRight = True
''	bgcr.ButtonSize = MashPlugIns.EnumButtonSize.large
''	bgcr.AddButton("btnLefthcr","Left",MashPlugIns.MaterialIcons.mdi_3d_rotation,MashPlugIns.EnumIconPosition.IconLeft,MashPlugIns.EnumThemes.danger)
''	bgcr.AddButton("btnMiddlehcr","Middle",MashPlugIns.MaterialIcons.mdi_access_alarms,MashPlugIns.EnumIconPosition.IconRight,MashPlugIns.EnumThemes.info)
''	bgcr.AddButton("btnRighthcr","Right",MashPlugIns.MaterialIcons.mdi_accessibility,MashPlugIns.EnumIconPosition.IconLeft,MashPlugIns.EnumThemes.Warn)
''	page.Cell(6,1).AddComponent(bgcr.ABMComp)
''	
''	
''	'vertical button group	
''	bgv.Initialize(page,"bgv")
''	bgv.IsVertical = True
''	bgv.ButtonSize = MashPlugIns.EnumButtonSize.large
''	bgv.AddButton("btnLeftv","Left",MashPlugIns.MaterialIcons.mdi_3d_rotation,MashPlugIns.EnumIconPosition.IconLeft,MashPlugIns.EnumThemes.danger)
''	bgv.AddButton("btnMiddlev","Middle",MashPlugIns.MaterialIcons.mdi_access_alarms,MashPlugIns.EnumIconPosition.IconRight,MashPlugIns.EnumThemes.info)
''	bgv.AddButton("btnRightv","Right",MashPlugIns.MaterialIcons.mdi_accessibility,MashPlugIns.EnumIconPosition.IconLeft,MashPlugIns.EnumThemes.Warn)
''	page.Cell(7,1).AddComponent(bgv.ABMComp)
''	
''	
''	'vertical button group with floating buttons
''	bgvf.Initialize(page,"bgvf")
''	bgvf.IsVertical = True
''	bgvf.IsFloating = True
''	bgvf.ButtonSize = MashPlugIns.EnumButtonSize.large
''	bgvf.AddButton("btnLeftv","Left",MashPlugIns.MaterialIcons.mdi_3d_rotation,MashPlugIns.EnumIconPosition.IconLeft,MashPlugIns.EnumThemes.danger)
''	bgvf.AddButton("btnMiddlev","Middle",MashPlugIns.MaterialIcons.mdi_access_alarms,MashPlugIns.EnumIconPosition.IconRight,MashPlugIns.EnumThemes.info)
''	bgvf.AddButton("btnRightv","Right",MashPlugIns.MaterialIcons.mdi_accessibility,MashPlugIns.EnumIconPosition.IconLeft,MashPlugIns.EnumThemes.Warn)
''	page.Cell(7,1).AddComponent(bgvf.ABMComp)
''	
''	'design.Initialize(page,"mashdesigner")
''	'page.Cell(1,1).AddComponent(design.ABMComp)
''	
''	mashcc.Initialize(page,"mashcreditcard")
''	page.Cell(2,1).AddComponent(mashcc.ABMComp) 
''	
''	
''	'a slider with images
''	MashPlugIns.AddTheme("wb",ABM.COLOR_WHITE,ABM.INTENSITY_NORMAL,ABM.COLOR_BLACK,ABM.INTENSITY_NORMAL)
''	mashgallery.Initialize(page,"mashgallery","wb")
''	mashgallery.SetMode(mashgallery.EnumMode.standard)
''	mashgallery.thumbnailsPosition = mashgallery.enumthumbnailsPosition.bottom
''	mashgallery.thumbType = mashgallery.enumthumbType.number
''	mashgallery.HeightPx = "800px"
''	mashgallery.Interval = mashgallery.EnumInterval.threeseconds
''	mashgallery.Transition = mashgallery.EnumTransition.random
''	mashgallery.TransitionBackward = mashgallery.EnumTransition.random
''	mashgallery.TransitionCols = "6"
''	mashgallery.AddAlbum("Album 1")
''	For imgc = 1 To 10
''		mashgallery.AddAlbumSlide("Album 1",$"../images/${imgc}.jpg"$,"Image " & img)
''	Next
''	mashgallery.AddAlbum("Album 2")
''	For imgc = 11 To 17
''		mashgallery.AddAlbumSlide("Album 2",$"../images/${imgc}.jpg"$,"Image " & img)
''	Next
''	For imgc = 1 To 10
''		mashgallery.AddSlide($"../images/slider${imgc}.jpg"$,"Slider " & img)
''	Next
''	page.Cell(2,1).AddComponent(mashgallery.ABMComp)
'	
'	'an album
'	'mashalbum.Initialize(page,"mashalbum","bw")
'	'mashalbum.SetMode(mashalbum.EnumMode.slider)
'	'mashalbum.AddAlbum("Album 1")
'	'page.Cell(3,1).AddComponent(mashalbum.ABMComp)
'	
'	
'	
'	
'	'**** ct stats
'	'CTCard.Initialize(page,"stats1")
'	'CTCard.SetHeader("R34,245","Revenue","mdi-store","card1")
'	'CTCard.SetFooter("mdi-date_range","Last 24 Hours","footer")
'	'page.Cell(1,1).AddComponent(CTCard.ABMComp)
'   
''   	CTCard1.Initialize(page,"stats2",ABM.COLOR_ORANGE,ABM.intensity_normal,"mdi-content_copy","Used Space","49/50<small>GB</small>")
''	CTCard1.SetFooter("mdi-warning","Get More Space",CTCard.EnumTheme.danger)
''	CTCard1.SetFooterURL("#pablo")
''	page.Cell(2,2).AddComponent(CTCard1.ABMComp)
''   
''	CTCard2.Initialize(page,"stats3", ABM.color_red,ABM.intensity_normal,"mdi-info_outline","Fixed Issues","75")
''	CTCard2.SetFooter("mdi-local_offer","Tracked from Github",CTCard.EnumTheme.none)
''	page.Cell(2,3).AddComponent(CTCard2.ABMComp)
''   
''	CTCard3.Initialize(page,"stats4",ABM.color_blue,ABM.intensity_normal,"fa-twitter","Followers","+245")
''	CTCard3.SetFooter("mdi-update","Just Updated",CTCard.EnumTheme.none)
''	page.Cell(2,4).AddComponent(CTCard3.ABMComp)
''   
''	'add a creative tim card: charts
''	CTCard4.Initialize(page,"dailySalesChart",ABM.color_green,ABM.intensity_normal,"Daily Sales","55% increase in today's sales.")
''	CTCard4.SetFooter("mdi-access_time","Updated 4 minutes ago",CTCard.EnumTheme.success)
''	CTCard4.SetCategoryIcon("fa fa-long-arrow-up")
''	
'	
''	mashtable.Initialize(page,"mashtable")
''	mashtable.ZDepth = ABM.ZDEPTH_2
''	mashtable.SetTableType(mashtable.EnumTableType.DataTable)
''	mashtable.IsResponsive = True
''	mashtable.DataTableKeys = False
''	mashtable.UseInputControls = False
''	mashtable.MaterialControls = False
''	mashtable.DataTableSaveState = False
''	mashtable.AddColumn("id","id",mashtable.EnumDataType.istext,True,True,True,False)
''	mashtable.AddColumn("Name","Name",mashtable.EnumDataType.istext,True,True,True,True)
''	mashtable.AddColumn("JobTitle","Job Title",mashtable.EnumDataType.istext,True,True,True,True)
''	mashtable.AddColumn("Location","Location",mashtable.EnumDataType.istext,True,True,True,True)
''	mashtable.AddColumn("Age","Age",mashtable.EnumDataType.isnumeric,True,True,True,False)
''	mashtable.AddColumn("StartDate","Start Date",mashtable.EnumDataType.isdate,True,True,True,False)
''	mashtable.AddColumn("StartTime","Start Time",mashtable.enumdatatype.istime,True,True,True,True)
''	mashtable.AddColumn("Gender","Gender",mashtable.EnumDataType.isselect,True,True,True,True)
''	mashtable.AddColumn("Active","Active",mashtable.EnumDataType.ischkbox,True,True,True,True)
''	'mashtable.AddColumn("Email","Email",mashtable.EnumDataType.isemail,True,True,True,True)
''	'mashtable.AddColumn("History","History",mashtable.EnumDataType.istextarea,True,True,True,True)
''	
''	'add the data
''	mashtable.AddRow(1,Array As String(1,"Anele Mashy Mbanga","Chief Software Architect","East London","44","2017-01-01","10:00","Male","1","anele@mbangas.com","A little about Mashy"))
''	mashtable.AddRow(2,Array As String(2,"Usibabale Ozzie Mbanga","Apprentice","East London","14","2017-02-01","11:00","Male","0","anele@mbangas.com","A little about Ozzie"))
''	mashtable.AddRow(3,Array As String(3,"Olothando Orio Mbanga","PA","East London","8","2017-03-02","12:00","Female","0","olothando@mbangas.com","A little about Orio"))
''	mashtable.AddRow(4,Array As String(4,"Esona Ernesto Mbanga","Assistant","East London","7","2017-04-01","13:00","Female","0","esona@mbangas.com","A little about Ernesto"))
''	'mashtable.DataTableSelect = True
''	'mashtable.DataTablePageSize = 3
''	page.Cell(1,1).AddComponent(mashtable.ABMComp)
''	
''	txtValue.Initialize(page,"txtValue",ABM.INPUT_TEXT,"Range Value",False,"")
''	'page.Cell(1,1).AddComponent(txtValue) 
''	
''	rs11.Initialize(page, "rs11","whiteamber")
''	rs11.AddValue("Fair").addvalue("Good").AddValue("Better").AddValue("Best")
''	rs11.Grid = True
''	page.Cell(2,1).AddComponent(rs11.ABMComp)
''	
''	rs1.Initialize(page,"rs1","alert")
''	page.Cell(3,1).AddComponent(rs1.ABMComp)
''	
''	rs2.Initialize(page,"rs2","whiteblue")
''	rs2.MinValue = 100
''	rs2.MaxValue = 1000
''	rs2.fromValue = 550
''	page.Cell(4,1).AddComponent(rs2.ABMComp)
''	
''	rs3.Initialize(page,"rs3","whiteblue")
''	rs3.MinValue = 0
''	rs3.MaxValue = 1000
''	rs3.FromValue = 200
''	rs3.ToValue = 800
''	rs3.Prefix = "$"
''	rs3.Grid = True
''	rs3.SlideType = rs3.EnumSlideType.isdouble
''	page.Cell(5,1).AddComponent(rs3.ABMComp)
''	
''	rs4.Initialize(page,"rs4","whiteblue")
''	rs4.MinValue = -1000
''	rs4.MaxValue = 1000
''	rs4.FromValue = -500
''	rs4.ToValue = 500
''	rs4.Prefix = "$"
''	rs4.Grid = True
''	rs4.SlideType = rs4.EnumSlideType.isdouble
''	page.Cell(6,1).AddComponent(rs4.ABMComp)
''	
''	rs5.Initialize(page,"rs5","whiteblue")
''	rs5.MinValue = -1000
''	rs5.MaxValue = 1000
''	rs5.FromValue = -500
''	rs5.ToValue = 500
''	rs5.Prefix = "$"
''	rs5.Grid = True
''	rs5.StepValue = 250
''	rs5.SlideType = rs5.EnumSlideType.isdouble
''	page.Cell(7,1).AddComponent(rs5.ABMComp)
''	
''	rs6.Initialize(page,"rs6","")
''	rs6.MinValue = "-12.8"
''	rs6.MaxValue = "12.8"
''	rs6.FromValue = "-3.2"
''	rs6.ToValue = "3.2"
''	rs6.Grid = True
''	rs6.StepValue = "0.1"
''	rs6.SlideType = rs6.EnumSlideType.isdouble
''	page.Cell(8,1).AddComponent(rs6.ABMComp)
''	
''	
''	rs7.Initialize(page,"rs7","")
''	rs7.FromValue = "1"
''	rs7.ToValue = "5"
''	rs7.Grid = True
''	rs7.SlideType = rs7.EnumSlideType.isdouble
''	rs7.AddValue("0").AddValue("10").AddValue("100").AddValue("1000").AddValue("100000").AddValue("1000000")
''	page.Cell(9,1).AddComponent(rs7.ABMComp)
''	
''	rs8.Initialize(page,"rs8","")
''	rs8.ToValue = "3"
''	rs8.Grid = True
''	rs8.SlideType = rs8.EnumSlideType.isdouble
''	rs8.AddValue("Jan").AddValue("Feb").AddValue("Mar").AddValue("Apr").AddValue("May").AddValue("Jun")
''	rs8.AddValue("Jul").AddValue("Aug").AddValue("Sep").AddValue("Oct").AddValue("Nov").AddValue("Dec")
''	page.Cell(10,1).AddComponent(rs8.ABMComp)
''	
''	rs9.Initialize(page,"rs9","")
''	rs9.MinValue = 18
''	rs9.MaxValue = 70
''	rs9.ToValue = 30
''	rs9.Prefix = "Age "
''	rs9.MaxPostfix = "+"
''	rs9.Grid = True
''	rs9.SlideType = rs9.EnumSlideType.isdouble
''	page.Cell(11,1).AddComponent(rs9.ABMComp)
''	
''	rs10.Initialize(page,"rs10","")
''	rs10.MinValue = 100
''	rs10.MaxValue = 200
''	rs10.ToValue = 155
''	rs10.Prefix = "Weight: "
''	rs10.postfix = " million pounds"
''	rs10.DecorateBoth = True
''	rs10.Grid = True
''	rs10.ValuesSeparator = " to "
''	rs10.HideMinMax = True
''	rs10.HideFromTo = False	
''	rs10.SlideType = rs10.EnumSlideType.isdouble
''	page.Cell(12,1).AddComponent(rs10.ABMComp)
''	
''	
''	flip.Initialize(page,"splitflap")
''	flip.Title = "Mashy Did 4 ABMaterial"
''	flip.Speed = "3"
''	page.Cell(1,1).AddComponent(flip.ABMComp)
''	
''	
'	'page.Cell(1,1).AddComponent(flow.ABMComp)
''	
''	jqPlot.Initialize(page, "custJQPlot")
''	'page.Cell(2,1).AddComponent(jqPlot.ABMComp)
''	jqPlot.SetTitle("Example 1: Simple Chart")
''	jqPlot.AddSeriesData9(jqPlot.s1,100,110,140,130,80,75,120,130,100)
''	jqPlot.IsAnimated(True,True,True)
''	jqPlot.AddSeries1
''	
''	Dim dd As MashDateDropper
''	dd.Initialize(page,"datedropper-3")
''	page.Cell(2,1).AddComponent(dd.ABMComp)
''	
''	Dim td As MashTimeDropper
''	td.Initialize(page,"td")
''	page.Cell(3,1).AddComponent(td.ABMComp)
''	
''	'Dim chk1 As ABMCheckbox
''	'chk1.Initialize(page,"chk","This is it",True,"")
''		
''	'Dim cbo As ABMCombo
''	'cbo.Initialize(page,"cbo","A combo","65px","")
''	
''	
''	email.Initialize(page,"emails")
''	email.ZDepth = ABM.ZDEPTH_2
''	email.HeaderTheme = "whitelightblue"
''	email.SideBarTheme = "lightblue"
''	email.SelectionTheme = "selectiontheme"
''	email.ProfileImage = "../images/sponge.png"
''	AddThemEmails
''	page.Cell(1,1).AddComponent(email.ABMComp)
''			
''	pricingTable.Initialize(page,"pricetable", "")
''	pricingTable.ZDepth = ABM.ZDEPTH_2
''	pricingTable.AddProduct("1","Standard","$","59","","Starter Pack","Buy Now","whitered")
''	pricingTable.AddProductItem("1", "Perpetual Licence")
''	pricingTable.AddProductItem("1", "2 months of free upgrades")
''	pricingTable.AddProductItem("1", "Full access to the forums")
''	
''	pricingTable.AddProduct("2","Enterprise","$","119","","Most Popular","Buy Now","whiteorange")
''	pricingTable.AddProductItem("2", "Perpetual Licence")
''	pricingTable.AddProductItem("2", "2 years of free upgrades")
''	pricingTable.AddProductItem("2", "Full access to the forums")
''	
''	pricingTable.AddProduct("3","Site License","$","599","","This is Mnca","Buy Now","whitegreen")
''	pricingTable.AddProductItem("3", "30 developer licenses (in the same organization)")
''	pricingTable.AddProductItem("3", "Perpetual Licence")
''	pricingTable.AddProductItem("3", "2 years of free upgrades")
''	pricingTable.AddProductItem("3", "Full access to the forums")
''	
''	page.Cell(1,1).AddComponent(pricingTable.ABMComp)
''	
''		
''	projects.Initialize(page,"projects","redgreen")
''	'projects.Title = "Projects"
''	'projects.SubTitle = ABMShared.LongDateToday
''	'add categories
''	projects.AddCategory("1","Feasibility Study", ABM.COLOR_ORANGE)
''	projects.AddCategory("2","Planning", ABM.COLOR_AMBER)
''	projects.addcategory("3","Initialization", ABM.COLOR_BLUE)
''	projects.AddCategory("4","Execution", ABM.COLOR_GREEN)
''	projects.AddCategory("5","Launch", ABM.COLOR_PURPLE)
''	projects.AddCategory("6","Marketing", ABM.COLOR_BROWN)
''	projects.AddCategory("7","Development", ABM.COLOR_CYAN)
''	'add projects
''	projects.AddProject("1","TGIF","2","TGIF INC.")
''	projects.AddProject("2","Ask TeenCoach","4","Mayine Foundation")
''	projects.AddProject("3","Project.Show","7","SAFIRI")
''	projects.AddProject("4", "Bible.Show", "6", "DanNora Business Solutions")
''	projects.ZDepth = ABM.ZDEPTH_2	
''	'add progress
''	'projects.AddProgress("1", ABMShared.CreateList(",","5,6,7,9,9,5,3,2,2,4,6,7"))
''	'projects.AddProgress("2", ABMShared.CreateList(",","6,7,5,6,7,9,9,5,3,2,2,4"))
''	'projects.AddProgress("3", ABMShared.CreateList(",","2,4,6,7,5,6,7,9,5,6,7,9"))
''	'projects.AddProgress("4", ABMShared.CreateList(",","9,5,3,2,2,4,6,7,5,6,7,9"))
''	projects.SparkLineChartType = projects.EnumSparkLineType.line
''	projects.SparkLineSetColor(ABM.COLOR_GREEN,ABM.INTENSITY_DARKEN2)
''	'turn off color coding sparklines to the category
''	projects.SparkLineColorCode = True
''	page.Cell(2,1).AddComponent(projects.ABMComp)
''	
''	
''	tasks.Initialize(page,"tasks","whitelightblue")
''	'first add categories
''	tasks.AddCategory("1", "Work",ABM.COLOR_TEAL)
''	tasks.AddCategory("2", "Web App", ABM.COLOR_CYAN)
''	tasks.AddCategory("3", "Web API", ABM.COLOR_PURPLE)
''	tasks.AddCategory("4", "Mock Up", ABM.COLOR_PINK)
''	tasks.AddCategory("5", "Mobile App", ABM.COLOR_GREEN)
''	
''	'tasks.AddTask("1","1","Create Project.Show User Interface",ABMShared.LongDate("2017-11-30"),True,True)
''	'tasks.AddTask("2","2","Develop a risk profile",ABMShared.LongDate("2017-11-30"),False,True)
''	'tasks.AddTask("3","4","Publish some MashPlugins for ABMaterial",ABMShared.LongDate("2017-11-25"),True,False)
''	'tasks.AddTask("4","5","Finish AskTeenCoach",ABMShared.LongDate("2019-01-01"),False,True)
''	'tasks.AddTask("5","1","Finalize TGIF",ABMShared.LongDate("2017-12-30"),False,True)
''	tasks.ZDepth = ABM.ZDEPTH_2 
''	page.Cell(2,2).AddComponent(tasks.ABMComp)
''	
''	issues.Initialize(page,"issues","whitered")
''	issues.ZDepth = ABM.ZDEPTH_2
''	issues.AddCategory("1", "Documents", ABM.COLOR_ORANGE)
''	issues.AddCategory("2", "Reporting", ABM.COLOR_AMBER)
''	issues.addcategory("3", "Dashboard", ABM.COLOR_BLUE)
''	issues.AddCategory("4", "Data Capturing", ABM.COLOR_GREEN)
''	issues.AddCategory("5", "Manual Development", ABM.COLOR_PURPLE)
''	issues.AddCategory("6", "Marketing", ABM.COLOR_BROWN)
''	issues.AddCategory("7", "Development", ABM.COLOR_CYAN)
''	
''	issues.AddIssue("1","1","eLibrary needs a treeview component","Project.Show",5)
''	issues.AddIssue("2","2","MS Excel Reporting should be implemented","Project.Show",10)
''	issues.AddIssue("3","3","Implement Charts urgently","Project.Show",50)
''	issues.AddIssue("4","4","Capturing: Risks, Issues, Challenges, Site Visits outstanding","Project.Show",90)
''	issues.ColorCodeProgress = False
''	page.Cell(2,3).AddComponent(issues.ABMComp)
''	
''	
''	stats.Initialize(page,"stats","whitered")
''	stats.SetComment("This is it").SetPercentage(10).SetTitle("Likes").SetValue("1,000").SetTitleIcon(MashPlugIns.MaterialIcons.mdi_add_shopping_cart)
''	stats.SetStatsType(stats.EnumStatsType.increase)
''	page.Cell(2,1).AddComponent(stats.ABMComp)
''	
''	'add these in sequence
''	profile.Initialize(page,"profile",150)
''	profile.AddCardImage("../images/office.jpg",True,"")
''	profile.AddUserImage("../images/sponge.png")
''	profile.AddFloatingButton("edit","mdi-editor-mode-edit",True)
''	profile.AddCardTitle("Anele 'Mashy' Mbanga",ABM.COLOR_AMBER,True,True)
''	profile.AddRole("Project Manager",True)
''	profile.AddContactNumber("+27 81 736 6739",True)
''	profile.AddEmailAddress("anele@mbangas.com",True)
''	profile.AddBirthDay("15, April 1973",True)	
''	page.Cell(2,1).AddComponent(profile.ABMComp)
''	
''	'add these in sequence
''	blog.Initialize(page,"blog","")
''	blog.AddCardImage("../images/8.jpg",True,"")
''	blog.AddShare("socialshare",ABM.COLOR_GREEN)
''	blog.AddInfo("info",ABM.COLOR_LIGHTBLUE)
''	blog.AddBlogCategoryPlusTopic("Web Design","15, April 1973","ABMaterial Experiments",ABM.COLOR_GREEN)
''	blog.AddBlogContent("Blah blah blah blah")
''	blog.AddBlogAuthor("Anele 'Mashy' Mbanga","../images/sponge.png")
''	blog.AddRevealCardTitle("ABMaterial Being Best Framework",ABM.COLOR_GREY)
''	blog.AddRevealParagraph("Here is some more information about this blog...")
''	page.Cell(2,2).AddComponent(blog.ABMComp)
''	 
''	'a blog with hashtags
''	blog1.Initialize(page,"blog1","")
''	blog1.SetCardSize(blog1.EnumCardSize.small)
''	blog1.AddCardImage("../images/1.jpg",False,"")
''	'Dim lTags As List = ABMShared.CreateList(",","Design,UX")
''	'blog1.AddTitlePlusHashTags("Apples on the Table",ABM.COLOR_DEEPORANGE,lTags)
''	blog1.SetAuthorPlusDate("Anele 'Mashy' Mbanga","15, April 1973")
''	blog1.AddBlogContent("I am a very simple full width blog post....")
''	page.Cell(2,3).AddComponent(blog1.ABMComp)
''	
''	price.Initialize(page,"price1","")
''	price.AddProductName("Pen & Paper")
''	price.AddProductDetails("This product is an impressive product to create ABMaterial UX. It uses SQLite as a backend for both development and production. Enjoy!")
''	price.AddCardImage("../images/sponge.png",True,"Anele 'Mashy' Mbanga")
''	price.AddPrice("$15M",ABM.COLOR_INDIGO,ABM.INTENSITY_ACCENT2)
''	price.AddShoppingCart("shoppingcart", ABM.COLOR_PURPLE)
''	price.AddRepeat("repeat",ABM.COLOR_GREEN)
''	price.AddFavourate("favourate",ABM.COLOR_RED)
''	price.AddInfo("info",ABM.COLOR_BLUE)
''	price.SetLogo("../images/logo.png","www.mbangas.com")
''	page.Cell(3,1).AddComponent(price.ABMComp)
''	
''	
''	
''	alert.Initialize(page,"alert")
''	alert.Normal("NEWS : You have done 5 actions.")
''	alert.UserImage = "../images/sponge.png"
''	alert.ShowOKCancel = True
''	page.Cell(2,1).addcomponent(alert.ABMcomp)
''	
''	alert1.Initialize(page,"alert1")
''	alert1.danger("DANGER : The daily report has failed.")
''	'alert1.UserImage = "../images/sponge.png"
''	'alert1.ShowOKCancel = True
''	page.Cell(2,2).addcomponent(alert1.ABMcomp)
''	
''	alert2.Initialize(page,"alert2")
''	alert2.InfoDark("INFO : You have 18 messages.")
''	alert2.UserImage = "../images/sponge.png"
''	alert2.ShowOKCancel = True
''	page.Cell(2,1).addcomponent(alert2.ABMcomp)
''	
''	alert3.Initialize(page,"alert3")
''	alert3.Success("SUCCESS : The page has been added.")
''	alert3.UserImage = "../images/sponge.png"
''	alert3.ShowOKCancel = True
''	page.Cell(2,2).addcomponent(alert3.ABMcomp)
''	
''	alert4.Initialize(page,"alert4")
''	alert4.WarnDark("WARNING : Bandwidth limit exceeded.")
''	alert4.UserImage = "../images/sponge.png"
''	'alert4.ShowOKCancel = True
''	page.Cell(2,1).addcomponent(alert4.ABMcomp)
''	
''	
''	mashc1.Initialize(page,"mashc1",False)
''	mashc1.AddSlide("img1","#one!","../images/1.jpg")
''	mashc1.AddSlide("img2","#two!","../images/2.jpg")
''	mashc1.AddSlide("img3","#three!","../images/3.jpg")
''	mashc1.AddSlide("img3","#four!","../images/4.jpg")
''	mashc1.AddSlide("img5","#five!","../images/5.jpg")
''	page.Cell(2,1).addcomponent(mashc1.ABMcomp)
''	
''	mashc2.Initialize(page,"mashc2",True)
''	mashc2.AddSlide("img1","#one!","../images/1.jpg")
''	mashc2.AddSlide("img2","#two!","../images/2.jpg")
''	mashc2.AddSlide("img3","#three!","../images/3.jpg")
''	mashc2.AddSlide("img4","#four!","../images/4.jpg")
''	mashc2.AddSlide("img5","#five!","../images/5.jpg")
''	page.Cell(3,1).addcomponent(mashc2.ABMcomp)
''	
''	
''	mashc3.Initialize(page,"mashc3",True)
''	mashc3.Center = True
''	'lets test with an image
''	mashc3.AddContainer("","#one1","Sunday","This is the description for page 1","whitered")
''	mashc3.AddContainer("","#one2","Monday","This is the description for page 2","whiteamber")
''	mashc3.AddContainer("","#one3","Tuesday","This is the description for page 3","whitegreen")
''	mashc3.AddContainer("","#one4","Wednesday","This is the description for page 4","whiteblue")
''	mashc3.AddContainer("","#one5","Thursday","This is the description for page 5","whiteorange")
''	mashc3.AddContainer("","#one6","Friday","This is the description for page 5","whitered")
''	mashc3.AddContainer("","#one7","Saturday","This is the description for page 5","whitegreen")
''	page.Cell(4,1).addcomponent(mashc3.ABMcomp)
''	
''	
''	
''	chips1.Initialize(page,"chips1","redorange")
''	chips1.AddInitialWith("Apple").AddInitialWith("Microsoft").AddInitialWith("Google")
''	'page.Cell(5,1).addcomponent(chips1.ABMcomp)
''	'
''	chips2.Initialize(page,"chips2","redorange")
''	chips2.AddAutoComplete("Xolani").AddAutoComplete("Apple").AddAutoComplete("Microsoft")
''	chips2.AddAutoComplete("Google").AddAutoComplete("Anele").AddAutoComplete("Mbanga")
''	'page.Cell(6,1).addcomponent(chips2.ABMcomp)
''	
''	chips3.Initialize(page,"mychips3","redorange")
''	chips3.PlaceHolder = "Enter a Tag"
''	chips3.secondaryplaceholder = "+Tag"
''	'page.Cell(7,1).addcomponent(chips3.ABMcomp)
'	
'	
'	
''	page.App.AddTheme("redtransparent","red","","transparent","")
''	page.App.AddTheme("bluetransparent","blue","","transparent","")
''	page.App.AddTheme("tealtransparent","teal","","transparent","")
''add components for the page
''	Dim contLogin As ABMContainer
''	contLogin.Initialize(page, "contLogin", "")
''	contLogin.AddRows(1,True,"").AddCells12(1, "")
''	contLogin.AddRows(1,True,"").AddCellsOSMPV(1, 0, 0, 0, 12, 6, 6, 0, 0, 0, 0, ABM.VISIBILITY_ALL, "").AddCellsOSMPV(1, 0, 0, 0, 12, 6, 6, 0, 0, 0, 10, ABM.VISIBILITY_ALL, "")
''	contLogin.AddRows(1,True,"").AddCellsOSMPV(1, 0, 0, 0, 12, 12, 12, 0, 0, 10, 0, ABM.VISIBILITY_ALL, "")
''	contLogin.AddRows(1,True,"").AddCellsOSMPV(1, 0, 0, 0, 12, 6, 6, 0, 0, 0, 0, ABM.VISIBILITY_ALL, "").AddCellsOSMPV(1, 0, 0, 0, 12, 6, 6, 0, 0, 0, 0, ABM.VISIBILITY_ALL, "")
''	contLogin.AddRows(1,True,"").AddCellsOSMPV(1, 0, 0, 0, 12, 6, 6, 0, 0, 10, 0, ABM.VISIBILITY_ALL, "").AddCellsOSMPV(1, 0, 3, 3, 12, 3, 3, 0, 0, 10, 10, ABM.VISIBILITY_ALL, "")
''	contLogin.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
''	contLogin.SetBorderEx(ABM.COLOR_LIGHTBLUE, ABM.INTENSITY_NORMAL, 1, ABM.CONTAINERBORDER_GROOVE, 2)
''	contLogin.PaddingRight = 10
''	Dim lbllblCreateAccount As ABMLabel
''	lbllblCreateAccount.Initialize(page, "lbllblCreateAccount", $"{C:#CC9966}{I}{B}Create Account{/B}{/I}{/C}"$, ABM.SIZE_PARAGRAPH, False, "rightlabel")
''	lbllblCreateAccount.Clickable = True
''	lbllblCreateAccount.SetCursor(ABM.CURSOR_POINTING)
''	lbllblCreateAccount.istextselectable = True
''	lbllblCreateAccount.paddingleft = ""
''	lbllblCreateAccount.paddingright = ""
''	lbllblCreateAccount.paddingtop = ""
''	lbllblCreateAccount.paddingbottom = ""
''	lbllblCreateAccount.margintop = ""
''	lbllblCreateAccount.marginbottom = ""
''	lbllblCreateAccount.marginleft = ""
''	lbllblCreateAccount.marginright = ""
''	lbllblCreateAccount.supportemoji = False
''	contLogin.Cell(2,2).AddComponent(lbllblCreateAccount)
''	Dim txtemail As ABMInput
''	txtemail.Initialize(page, "txtemail", ABM.INPUT_EMAIL, "Email Address", False, "")
''	txtemail.Tag = "txtemail"
''	contLogin.Cell(4,1).AddComponent(txtemail)
''	Dim txtpassword As ABMInput
''	txtpassword.Initialize(page, "txtpassword", ABM.INPUT_PASSWORD, "Password", False, "")
''	txtpassword.Tag = "txtpassword"
''	contLogin.Cell(4,2).AddComponent(txtpassword)
''	Dim btnNext As ABMButton
''	btnNext.InitializeRaised(page, "btnNext", "", "", "Next", "")
''	btnNext.Tag = "btnNext"
''	btnNext.UseFullCellWidth = True
''	btnNext.Size = ABM.BUTTONSIZE_NORMAL
''	btnNext.dropdownhidearrow = False
''	btnNext.dropdownshowbelow = False
''	btnNext.dropdownconstrainwidth = False
''	contLogin.Cell(5,2).AddComponent(btnNext)
''	Dim lblheader As ABMLabel
''	lblheader.Initialize(page, "lblheader", $"{B}To continue, let's verify it's you{/B}"$, ABM.SIZE_PARAGRAPH, False, "")
''	lblheader.istextselectable = True
''	lblheader.paddingleft = ""
''	lblheader.paddingright = ""
''	lblheader.paddingtop = ""
''	lblheader.paddingbottom = ""
''	lblheader.margintop = ""
''	lblheader.marginbottom = ""
''	lblheader.marginleft = ""
''	lblheader.marginright = ""
''	lblheader.supportemoji = False
''	contLogin.Cell(3,1).AddComponent(lblheader)
''	Dim lbllblForgotPassword As ABMLabel
''	lbllblForgotPassword.Initialize(page, "lbllblForgotPassword", $"{C:#CC9966}{I}Forgot Password?{/I}{/C}"$, ABM.SIZE_PARAGRAPH, False, "")
''	lbllblForgotPassword.VerticalAlign = True
''	lbllblForgotPassword.Clickable = True
''	lbllblForgotPassword.SetCursor(ABM.CURSOR_POINTING)
''	lbllblForgotPassword.istextselectable = True
''	lbllblForgotPassword.paddingleft = ""
''	lbllblForgotPassword.paddingright = ""
''	lbllblForgotPassword.paddingtop = ""
''	lbllblForgotPassword.paddingbottom = ""
''	lbllblForgotPassword.margintop = ""
''	lbllblForgotPassword.marginbottom = ""
''	lbllblForgotPassword.marginleft = ""
'	lbllblForgotPassword.marginright = ""
'	lbllblForgotPassword.supportemoji = False
'	contLogin.Cell(5,1).AddComponent(lbllblForgotPassword)
'	Dim imglogo As ABMImage
'	imglogo.Initialize(page, "imglogo", "../images/logo.png?"& DateTime.Now, 1)
'	imglogo.Tag = "imglogo"
'	imglogo.IsResponsive = False
'	imglogo.IsCircular = False
'	imglogo.IsClickable = False
'	imglogo.IsMaterialBoxed = False
'	contLogin.Cell(2,1).AddComponent(imglogo)
'	page.Cell(2,1).AddComponent(contLogin)
	
	AdminAccess
	page.SetFontStack("arial,sans-serif")
	' this page uses uploads, so needs some settings
	page.ws.session.SetAttribute("abmcallback", Me)
	page.ws.session.SetAttribute("abmdownloadfolder", DownloadFolder)
	page.ws.session.SetAttribute("abmmaxsize", DownloadMaxSize)
	page.Refresh ' IMPORTANT
	' NEW, because we use ShowLoaderType=ABM.LOADER_TYPE_MANUAL
	page.FinishedLoading 'IMPORTANT
	page.RestoreNavigationBarPosition
	'table grouping
	'mashtable.DataTableGroupByColumnIndex(2,25)
	'fix left column
	'mashtable.DataTableFixLeftColumns(1)
	
	
	'lets add 1 row with 4 columns long

	'store the number of rows
	totRows = 0
	'mcp3.SetColor("#FE4D4D")
	
	
'	mms.ClearSelection
'	mms.AddSelection("elem_6")
'	mms.AddSelection("elem_5")
'	mms.SelectItems
	
End Sub

Sub Page_SignedOffSocialNetwork(Network As String, Extra As String)
	page.ws.Session.SetAttribute("UserID", "")
	page.ws.Session.SetAttribute("UserEmail", "")
	page.ws.Session.SetAttribute("authType", "")
	page.ws.Session.SetAttribute("authName", "")
	page.ws.Session.SetAttribute("IsAuthorized", "")
	ABMShared.NavigateToPage(ws,ABMPageId, "../")
End Sub
'The label has been clicked
Sub lbllblCreateAccount_Clicked(Target As String)
	ABMShared.NavigateToPage(ws, ABMPageId,"../frmCreateAccount/frmCreateAccount.html")
End Sub
'An ABMButton has been clicked
Sub btnNext_Clicked(Target As String)
	ABMShared.NavigateToPage(ws, ABMPageId, "../frmMainMenu/frmMainMenu.html")
End Sub
'The label has been clicked
Sub lbllblForgotPassword_Clicked(Target As String)
	ABMShared.NavigateToPage(ws, ABMPageId,"../frmForgotPassword/frmForgotPassword.html")
End Sub
Sub AdminAccess()
	'Get the usertype
	Dim UserType As String = ws.Session.GetAttribute2("UserType", "0")
End Sub
Sub ConnectNavigationBar()
	' Clear the dummies we created in BuildNavigationBar
	page.NavigationBar.Clear
	'connect the items in the navigation bar
	'refresh the navigation bar
	page.NavigationBar.Refresh ' IMPORTANT
End Sub
Sub Page_MsgboxResult(returnName As String, result As String)
End Sub
Sub Page_InputboxResult(returnName As String, result As String)
End Sub
Sub Page_DebugConsole(message As String)
	Log("---> " & message)
End Sub
Sub Page_FirebaseAuthError(extra As String)
End Sub
Sub Page_FirebaseAuthStateChanged(IsLoggedIn As Boolean)
End Sub
Sub Page_FirebaseStorageError(jobID As String, extra As String)
End Sub
Sub Page_FirebaseStorageResult(jobID As String, extra As String)
End Sub
Sub Page_ModalSheetDismissed(ModalSheetName As String)
End Sub
Sub Page_NextContent(TriggerComponent As String)
End Sub
Sub page_CellClicked(Target As String, RowCell As String)
	'Log(Target)
End Sub
Sub page_RowClicked(Target As String, Row As String)
	'Log(Target)
End Sub
Sub Page_NativeResponse(jsonMessage As String)
End Sub
Sub Page_Dropped(Params As Map)
	If Params.Get("before") = "" Then
		Log("'" & Params.Get("component") & "' moved from " & Params.Get("source") & " to " & Params.Get("target"))
	Else
		Log("'" & Params.Get("component") & "' moved from " & Params.Get("source") & " to " & Params.Get("target") & " before component " & Params.Get("before"))
	End If
End Sub


Sub LoadFakeData()
	database.Initialize
	database.Put(0,$"{"ID": 0,"Name": "Otto Clay","Age": 61,"Country": 6,"Address": "Ap #897-1459 Quam Avenue","Married": false}"$)
	database.Put(1,$"{"ID": 1,"Name": "Connor Johnston","Age": 73,"Country": 7,"Address": "Ap #370-4647 Dis Av.","Married": false}"$)
	database.Put(2,$"{"ID": 2,"Name": "Lacey Hess","Age": 29,"Country": 7,"Address": "Ap #365-8835 Integer St.","Married": false}"$)
	database.Put(3,$"{"ID": 3,"Name": "Timothy Henson","Age": 78,"Country": 1,"Address": "911-5143 Luctus Ave","Married": false}"$)
	database.Put(4,$"{"ID": 4,"Name": "Ramona Benton","Age": 43,"Country": 5,"Address": "Ap #614-689 Vehicula Street","Married": true}"$)
	database.Put(5,$"{"ID": 5,"Name": "Ezra Tillman","Age": 51,"Country": 1,"Address": "P.O. Box 738, 7583 Quisque St.","Married": true}"$)
	database.Put(6,$"{"ID": 6,"Name": "Dante Carter","Age": 59,"Country": 1,"Address": "P.O. Box 976, 6316 Lorem, St.","Married": false}"$)
	database.Put(7,$"{"ID": 7,"Name": "Christopher Mcclure","Age": 58,"Country": 1,"Address": "847-4303 Dictum Av.","Married": true}"$)
	database.Put(8,$"{"ID": 8,"Name": "Ruby Rocha","Age": 62,"Country": 2,"Address": "5212 Sagittis Ave","Married": false}"$)
	database.Put(9,$"{"ID": 9,"Name": "Imelda Hardin","Age": 39,"Country": 5,"Address": "719-7009 Auctor Av.","Married": false}"$)
	database.Put(10,$"{"ID": 10,"Name": "Jonah Johns","Age": 28,"Country": 5,"Address": "P.O. Box 939, 9310 A Ave","Married": false}"$)
	database.Put(11,$"{"ID": 11,"Name": "Herman Rosa","Age": 49,"Country": 7,"Address": "718-7162 Molestie Av.","Married": true}"$)
	database.Put(12,$"{"ID": 12,"Name": "Arthur Gay","Age": 20,"Country": 7,"Address": "5497 Neque Street","Married": false}"$)
	database.Put(13,$"{"ID": 13,"Name": "Xena Wilkerson","Age": 63,"Country": 1,"Address": "Ap #303-6974 Proin Street","Married": true}"$)
	database.Put(14,$"{"ID": 14,"Name": "Lilah Atkins","Age": 33,"Country": 5,"Address": "622-8602 Gravida Ave","Married": true}"$)
	database.Put(15,$"{"ID": 15,"Name": "Malik Shepard","Age": 59,"Country": 1,"Address": "967-5176 Tincidunt Av.","Married": false}"$)
	database.Put(16,$"{"ID": 16,"Name": "Keely Silva","Age": 24,"Country": 1,"Address": "P.O. Box 153, 8995 Praesent Ave","Married": false}"$)
	database.Put(17,$"{"ID": 17,"Name": "Hunter Pate","Age": 73,"Country": 7,"Address": "P.O. Box 771, 7599 Ante, Road","Married": false}"$)
	database.Put(18,$"{"ID": 18,"Name": "Mikayla Roach","Age": 55,"Country": 5,"Address": "Ap #438-9886 Donec Rd.","Married": true}"$)
	database.Put(19,$"{"ID": 19,"Name": "Upton Joseph","Age": 48,"Country": 4,"Address": "Ap #896-7592 Habitant St.","Married": true}"$)
	database.Put(20,$"{"ID": 20,"Name": "Jeanette Pate","Age": 59,"Country": 2,"Address": "P.O. Box 177, 7584 Amet, St.","Married": false}"$)
	database.Put(21,$"{"ID": 21,"Name": "Kaden Hernandez","Age": 79,"Country": 3,"Address": "366 Ut St.","Married": true}"$)
	database.Put(22,$"{"ID": 22,"Name": "Kenyon Stevens","Age": 20,"Country": 3,"Address": "P.O. Box 704, 4580 Gravida Rd.","Married": false}"$)
	database.Put(23,$"{"ID": 23,"Name": "Jerome Harper","Age": 31,"Country": 5,"Address": "2464 Porttitor Road","Married": false}"$)
	database.Put(24,$"{"ID": 24,"Name": "Jelani Patel","Age": 36,"Country": 2,"Address": "P.O. Box 541, 5805 Nec Av.","Married": true}"$)
	database.Put(25,$"{"ID": 25,"Name": "Keaton Oconnor","Age": 21,"Country": 1,"Address": "Ap #657-1093 Nec, Street","Married": false}"$)
	database.Put(26,$"{"ID": 26,"Name": "Bree Johnston","Age": 31,"Country": 2,"Address": "372-5942 Vulputate Avenue","Married": false}"$)
	database.Put(27,$"{"ID": 27,"Name": "Maisie Hodges","Age": 70,"Country": 7,"Address": "P.O. Box 445, 3880 Odio, Rd.","Married": false}"$)
	database.Put(28,$"{"ID": 28,"Name": "Kuame Calhoun","Age": 39,"Country": 2,"Address": "P.O. Box 609, 4105 Rutrum St.","Married": true}"$)
	database.Put(29,$"{"ID": 29,"Name": "Carlos Cameron","Age": 38,"Country": 5,"Address": "Ap #215-5386 A, Avenue","Married": false}"$)
	database.Put(30,$"{"ID": 30,"Name": "Fulton Parsons","Age": 25,"Country": 7,"Address": "P.O. Box 523, 3705 Sed Rd.","Married": false}"$)
	database.Put(31,$"{"ID": 31,"Name": "Wallace Christian","Age": 43,"Country": 3,"Address": "416-8816 Mauris Avenue","Married": true}"$)
	database.Put(32,$"{"ID": 32,"Name": "Caryn Maldonado","Age": 40,"Country": 1,"Address": "108-282 Nonummy Ave","Married": false}"$)
	database.Put(33,$"{"ID": 33,"Name": "Whilemina Frank","Age": 20,"Country": 7,"Address": "P.O. Box 681, 3938 Egestas. Av.","Married": true}"$)
	database.Put(34,$"{"ID": 34,"Name": "Emery Moon","Age": 41,"Country": 4,"Address": "Ap #717-8556 Non Road","Married": true}"$)
	database.Put(35,$"{"ID": 35,"Name": "Price Watkins","Age": 35,"Country": 4,"Address": "832-7810 Nunc Rd.","Married": false}"$)
End Sub


Sub LoadData() As String
	' we have to return a Json string
	Dim data As StringBuilder
	data.Initialize
	data.Append("[")
	For i = 0 To database.size - 1
		If i > 0 Then
			data.Append(",")
		End If
		data.Append(database.get(i))
	Next
	data.Append("]")
	Return data.ToString
End Sub