﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=4.7
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Public MyTheme As ABMTheme
	Private ABM As ABMaterial 'ignore
	Public NeedsAuthorization As Boolean = False
	Public AppVersion As String = DateTime.Now
	Public AppPublishedStartURL As String = ""
	Public AssetsVersion As String = "4.0"
	Public TrackingID As String
	Public PhpPath As String = ""
	Public GoogleMapsAPIExtras As String = ""
	Public AppName As String = "askteencoach"
	Private pool As ConnectionPool
	Private SQLite As SQL
	Private DatabaseType As Int
	Public DBOK As Int = 0
	Public ffiles As List
	Public ffolders As List
	Public roots As String
	Public DBERROR As Int = -1
	Public DBNORESULTS As Int = -2
	Private UsePool As Boolean
	Public Permissions As Map
	Public PermissionsL As List
	Public HasAccessControl As String = 0
	Public CachedPages As Map
	Public CacheScavengePeriodSeconds As Int = 15*60 ' 15 minutes ' 10 minutes
	Public SessionMaxInactiveIntervalSeconds As Int = 30*60 ' 30 minutes '1*60*24 ' one hour ' -1 = immortal but beware! This means the cache is NEVER emptied!
	Private Intros As List
	Private toastCount As Int
	Private esmtp As SMTP
	Public Port As String = "51055"
	Public RemoteIP As String
End Sub
Sub ABMTextImageRight(page As ABMPage, id As String, text As String, img As String) As ABMContainer
	Dim ItemCont As ABMContainer
	ItemCont.Initialize(page, id, "")
	ItemCont.AddRowsM(1,False,0,0, "").AddCellsOSMP(1,0,0,0,10,10,10,0,0,0,10,"rightcontent").AddCellsOSMP(1,0,0,0,2,2,2,10,0,5,5,"centercontent")
	ItemCont.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
	Dim lbl As ABMLabel
	lbl.Initialize(page, id & "lbl", text, ABM.SIZE_PARAGRAPH, False, "")
	ItemCont.Cell(1,1).AddComponent(lbl)
	Dim badge As ABMImage = ABMImageBuild(page,id & "img",img,1,False,False,"","",False,False,False,32,32)
	ItemCont.Cell(1,2).AddComponent(badge)
	Return ItemCont
End Sub
Sub ABMImageTextLeft(page As ABMPage, id As String, text As String, img As String) As ABMContainer
	Dim ItemCont As ABMContainer
	ItemCont.Initialize(page, id, "")
	ItemCont.AddRowsM(1,False,0,0, "").AddCellsOSMP(1,0,0,0,2,2,2,10,0,5,5,"centercontent").AddCellsOSMP(1,0,0,0,10,10,10,0,0,0,10,"leftcontent")
	ItemCont.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
	Dim badge As ABMImage = ABMImageBuild(page,id & "img",img,1,False,False,"","",False,False,False,32,32)
	ItemCont.Cell(1,1).AddComponent(badge)
	Dim lbl As ABMLabel
	lbl.Initialize(page, id & "lbl", text, ABM.SIZE_PARAGRAPH, False, "")
	ItemCont.Cell(1,2).AddComponent(lbl)
	Return ItemCont
End Sub
public Sub ABMImageBuild(page As ABMPage,id As String,imgPath As String,opacity As Double,bResponsive As Boolean,bMaterialBoxed As Boolean,sCaption As String, sAlt As String, bCircular As Boolean, bClickable As Boolean,bFixed As String, sWidth As String, sHeight As String) As ABMImage
	Dim img As ABMImage
	img.Initialize(page, id, imgPath & "?" & DateTime.Now, opacity)
	img.IsResponsive = bResponsive
	img.IsMaterialBoxed = bMaterialBoxed
	img.Caption = sCaption
	img.Alt = sAlt
	img.IsCircular = bCircular
	img.IsClickable = bClickable
	If bFixed = "1" Or bFixed = True Then
		img.SetFixedSize(sWidth,sHeight)
	End If
	Return img
End Sub
Public Sub ProgressRAG(dVariance As Double) As String
	If dVariance < 0 Then
		Return "../images/red.png"
	else if dVariance > 0 Then
		Return "../images/green.png"
	else if dVariance = 0 Then
		Return "../images/orange.png"
	Else
		Return "../images/gray.png"
	End If
End Sub
Public Sub ExpectedRAG(dValue As Double) As String
	If dValue = 0 Then
		Return "../images/orange.png"
	else if dValue > 0 Then
		Return "../images/red.png"
	else if dValue < 0 Then
		Return "../images/green.png"
	Else
		Return "../images/red.png"
	End If
End Sub
Public Sub ExpenditureRAG(dVariance As Double) As String
	If dVariance > 0 Then
		Return "../images/green.png"
	else if dVariance < 0 Then
		Return "../images/red.png"
	else if dVariance = 0 Then
		Return "../images/orange.png"
	Else
		Return "../images/gray.png"
	End If
End Sub
Public Sub PriorityRAG(dValue As Int) As String
	Select Case dValue
		Case 0
			Return "../images/green.png"
		Case 1
			Return "../images/orange.png"
		Case 2
			Return "../images/red.png"
		Case Else
			Return "../images/gray.png"
	End Select
End Sub
Public Sub StatusRAG(dValue As Int) As String
	Select Case dValue
		Case 0
			Return "../images/red.png"
		Case 1
			Return "../images/orange.png"
		Case 2
			Return "../images/green.png"
		Case Else
			Return "../images/gray.png"
	End Select
End Sub
Sub EmailActivation(semail As String,subject As String) As ResumableSub
	'define the email to search for
	Dim jSQL As SQL = SQLGet
	Dim w As Map = CreateMap("email=":semail)
	Dim uMap As Map = SQLSelectRecordWhereMap(jSQL,"users", w)
	If uMap.IsInitialized = False Then Return False
	Dim firstname As String = uMap.GetDefault("firstname","")
	Dim sGUID As String = uMap.GetDefault("guid","")
	'get the activate.html
	Dim html As String = File.ReadString(File.dirapp,"activate.html")
	'update the details
	html = html.Replace("{{user}}",firstname)
	html = html.Replace("{{appname}}",AppName)
	Dim sLink As String = $"http://mbanga.dedicated.co.za:51055/askteencoach/frmLogin/frmLogin.html?email=${semail}&guid=${sGUID}"$
	html = html.Replace("{{link}}",sLink)
	html = html.replace("=","=3D")
	Try
		Dim es As Map = GetEmailSettings
		Dim sserver As String = es.GetDefault("server","")
		Dim sport As String = es.GetDefault("port","25")
		Dim susername As String = es.GetDefault("username","")
		Dim spassword As String = es.GetDefault("password","")
		Dim sStartTLSMode As String = es.GetDefault("starttlsmode","0")
		Dim sUseSSL As String = es.GetDefault("usessl","0")
		'start sending the email
		esmtp.Initialize(sserver, sport, susername, spassword, "smtp")
		esmtp.To.Add(semail)
		esmtp.HtmlBody = True
		esmtp.Body = html
		esmtp.Subject = subject
		If sStartTLSMode = "1" Then
			esmtp.StartTLSMode = True
		Else
			esmtp.StartTLSMode = False
		End If
		If sUseSSL = "1" Then
			esmtp.UseSSL = True
		Else
			esmtp.UseSSL = False
		End If
		Wait For (esmtp.Send) smtp_MessageSent(Success As Boolean)
		Return Success
	Catch
		Return False
	End Try
End Sub
Sub GUID As String
	Dim jo As JavaObject
	Return jo.InitializeStatic("java.util.UUID").RunMethod("randomUUID", Null)
End Sub
Sub IsPhone(pg As ABMPage) As Boolean
	Try
		Dim NowWH As String = ABM.GetBrowserWidthHeight(pg) ' returns a string "width;height"
		If NowWH <> "" And NowWH <> ";" Then ' check if we got something useful back
		Dim split() As String = Regex.Split(";", NowWH) ' split the string
		Dim NewH As Int = split(0)
		If NewH < 600 Then Return True
		If NewH > 600 And NewH <= 992 Then Return False
		If NewH > 992 Then Return False
	End If
	Return False
Catch
	Return False
End Try
End Sub
Sub GetEmailSettings() As Map
	Dim es As Map
	es.Initialize
	Dim jSQL As SQL = SQLGet
	'get first available account, there should be 1
	Dim id As String = SQLSelectSingleResult(jSQL, "select id from EmailAccounts where active = 1", Null)
	If id = "" Then Return es
	'read the email settings first
	es = SQLRecordRead(jSQL,"EmailAccounts", "id", id)
	Return es
End Sub
Sub SendEmail(toEmail As String, subject As String, msg As String) As ResumableSub
	Try
		'read the email settings first
		Dim es As Map = GetEmailSettings
		Dim sserver As String = es.GetDefault("server","")
		Dim sport As String = es.GetDefault("port","25")
		Dim susername As String = es.GetDefault("username","")
		Dim spassword As String = es.GetDefault("password","")
		Dim sStartTLSMode As String = es.GetDefault("starttlsmode","0")
		Dim sUseSSL As String = es.GetDefault("usessl","0")
		'start sending the email
		esmtp.Initialize(sserver, sport, susername, spassword, "smtp")
		esmtp.To.Add(toEmail)
		esmtp.Body = msg
		esmtp.Subject = subject
		If sStartTLSMode = "1" Then
			esmtp.StartTLSMode = True
		Else
			esmtp.StartTLSMode = False
		End If
		If sUseSSL = "1" Then
			esmtp.UseSSL = True
		Else
			esmtp.UseSSL = False
		End If
		Wait For (esmtp.Send) smtp_MessageSent(Success As Boolean)
		Return Success
	Catch
		Return False
	End Try
End Sub
Sub smtp_MessageSent(Success As Boolean)
	Log(Success)
End Sub
Sub NavigateTo(FromPage As ABMPage, ToPage As String)
	Dim ABMPageId As String = ABM.GetPageID(FromPage, FromPage.Name,FromPage.ws)
	Dim sPath As String = $"../${ToPage}/${ToPage}.html"$
	NavigateToPage(FromPage.ws, ABMPageId, sPath)
End Sub
Sub LongDateToday() As String
	DateTime.DateFormat = "yyyy-MM-dd"
	Dim dt As Long = DateTime.now
	DateTime.DateFormat = "EEEE, dd MMMM yyyy"
	Return DateTime.Date(dt)
End Sub
Sub GetHideScript(id As String) As String
	Dim script As String = $"$('#${id}').hide();"$
	Return script
End Sub
Sub Hide(page As ABMPage, id As String)
	Dim script As String = $"$('#${id}').hide("slow");"$
	page.ws.Eval(script,Null)
End Sub
Sub AddRedStar(bRequired As Boolean, Element As HTMLElement) As HTMLElement
	If bRequired = True Then
		Dim span As HTMLElement
		span.Initialize("","span").AddContent("*")
		MashPlugIns.MaterialUseTheme("redtransparent",span)
		Element.AddContent(span.HTML)
	End If
	Return Element
End Sub
' convert a list containing maps to json
Sub List2JSON(lst As List) As String
	Dim sOut As String
	Dim jsonGen As JSONGenerator
	jsonGen.Initialize2(lst)
	sOut = jsonGen.ToString
	Return sOut
End Sub
Sub StrParse(Delimiter As String, MV As String) As String()
	Delimiter = FixDelimiter(Delimiter)
	Return Regex.Split(Delimiter, MV)
End Sub
Sub CreateList(Delimiter As String, Values As String) As List
	Dim newLst As List
	newLst.Initialize
	If Values.length > 0 Then
		Dim spV() As String = StrParse(Delimiter,Values)
		newLst.AddAll(spV)
	End If
	Return newLst
End Sub
public Sub SetDateISO(page As ABMPage, id As String, value As String)
	page.ws.Eval("$('#" & id.tolowercase & "').bootstrapMaterialDatePicker('setDateISO', '" & value & "');", Null)
End Sub
public Sub GetValue(page As ABMPage, id As String) As String
	Try
		id = id.tolowercase
		Dim jqe As JQueryElement = page.ws.GetElementById(id)
		Return jqe.GetVal.Value
	Catch
		Return ""
	End Try
End Sub
public Sub SetValue(page As ABMPage, id As String, value As String)
	Try
		id = id.tolowercase
		Dim jqe As JQueryElement = page.ws.GetElementById(id)
		jqe.SetVal(value)
	Catch
	End Try
End Sub
Sub AddSubHeader(page As ABMPage, id As String, Text As String, Row As Int, Cell As Int)
	Dim lbl As ABMLabel = BuildSubHeader(page,id,Text)
	page.Cell(Row,Cell).AddComponent(lbl)
End Sub
public Sub GetText(page As ABMPage, id As String) As String
	Try
		id = id.tolowercase
		Dim jqe As JQueryElement = page.ws.GetElementById(id)
		Return jqe.GetText.value
	Catch
		Return ""
	End Try
End Sub
public Sub SetText(page As ABMPage, id As String, value As String)
	Try
		id = id.tolowercase
		Dim jqe As JQueryElement = page.ws.GetElementById(id)
		jqe.SetText(value)
	Catch
	End Try
End Sub
public Sub GetHTML(page As ABMPage, id As String) As String
	Try
		id = id.tolowercase
		Dim jqe As JQueryElement = page.ws.GetElementById(id)
		Return jqe.GetHtml.value
	Catch
		Return ""
	End Try
End Sub
public Sub SetHTML(page As ABMPage, id As String, value As String)
	Try
		id = id.tolowercase
		Dim jqe As JQueryElement = page.ws.GetElementById(id)
		jqe.SetHtml(value)
	Catch
	End Try
End Sub
Sub Inform(page As ABMPage, msg As String)
	toastCount = toastCount + 1
	page.ShowToast("toast" & toastCount, "toastgreen", $"${msg}"$, 3000,False)
End Sub
Sub Warn(page As ABMPage, msg As String)
	toastCount = toastCount + 1
	page.ShowToast("toast" & toastCount, "toastred", $"${msg}"$, 3000, False)
End Sub
'clear the intros for entry
Sub ClearIntros
	Intros.Initialize
End Sub
Sub ABMGetElements(page As ABMPage)
	Dim s As String = $"var elems = document.body.getElementsByTagName("*");
	ret=new Array();
	for (var i=0, max=elems.length; i < max; i++) {
		// Do something with the element here
		ret.push(elems[i]);
		}
		console.log(ret);"$
		page.ws.Eval(s,Null)
	End Sub
	'get the id of the uploader component for the intro
	Sub ABMUploaderID(uplid As ABMUpload, uplTheme As String) As String
	Dim sout As String = $"upload${uplid.id}${uplTheme}"$
	Return sout
End Sub
'get the id of the uploader component for the intro
Sub ABMNavItemID(navbarid As String, itmpos As String) As String
	Dim sout As String = $"${navbarid}TI${itmpos}icon"$
	Return sout
End Sub
Sub ShowHints(page As ABMPage)
	page.ws.Eval("introJs().showHints();",Null)
	page.ws.flush
End Sub
Sub AddHints(page As ABMPage)
	page.ws.Eval("introJs().addHints();",Null)
	page.ws.flush
End Sub
Sub StartIntro(page As ABMPage)
	Dim tour As String = $"function startTour() {
	var tour = introJs()
	tour.setOption('tooltipPosition', 'auto');
	tour.setOption('positionPrecedence', ['left', 'right', 'bottom', 'top'])
	tour.start()
	}
	startTour();"$
	page.ws.Eval(tour,Null)
	'page.ws.Eval("introJs().start();",Null)
	page.ws.flush
End Sub
Sub SetIntro(page As ABMPage, compID As String, stepNo As String, stepDescription As String)
	ABM.SetProperty(page,compID,"data-step",stepNo)
	ABM.SetProperty(page,compID,"data-intro",$"${stepDescription}"$)
	ABM.SetProperty(page,compID,"data-hint",$"${stepDescription}"$)
End Sub
Sub AddIntro(page As ABMPage, compID As String, stepDescription As String)
	Dim stepNo As Int = Intros.size + 1
	SetIntro(page,compID,stepNo,stepDescription)
	Intros.Add(compID)
End Sub
Sub GetFileIcon(Dir As String, FileName As String) As Image
	Try
		Dim jo As JavaObject
		Dim JavaFile As JavaObject
		JavaFile.InitializeNewInstance("java.io.File", Array(File.Combine(Dir, FileName)))
		Dim icon As JavaObject = jo.InitializeStatic("sun.awt.shell.ShellFolder").RunMethodJO("getShellFolder", Array(JavaFile)).RunMethod("getIcon",Array(True))
		Return AwtImageToImage(icon)
	Catch
		Return Null
	End Try
End Sub
Private Sub AwtImageToImage(img As JavaObject) As Image
	Dim jo As JavaObject
	Return jo.InitializeStatic("javafx.embed.swing.SwingFXUtils").RunMethod("toFXImage", Array(img, Null))
End Sub
Sub SaveSnapShot(img As Image, imgFile As String)
	Try
		If File.Exists("", imgFile) Then File.Delete("", imgFile)
		Dim Out As OutputStream = File.OpenOutput("", imgFile, False)
		img.WriteToStream(Out)
		Out.Close
	Catch
	End Try
End Sub
Sub InStrRev(value As String, search As String) As Long
	Return value.LastIndexOf(search) + 1
End Sub
Sub PrepareRecursiveSearch
	ffiles.Initialize
	ffolders.Initialize
	roots = ""
End Sub
Sub ReadDir(folder As String, recursive As Boolean)
	Try
		Dim lst As List = File.ListFiles(folder)
		For i = 0 To lst.Size - 1
			If File.IsDirectory(folder,lst.Get(i)) Then
				Dim v As String
				v = folder & "\" & lst.Get(i)
				ffolders.Add(v.SubString(roots.Length))
				If recursive Then
					ReadDir(v,recursive)
				End If
			Else
				ffiles.Add(folder & "\" & lst.Get(i))
			End If
		Next
	Catch
	End Try
End Sub
Sub FormatFileSize(Bytes As Float) As String
	Try
		Private Unit() As String = Array As String(" Byte", " KB", " MB", " GB", " TB", " PB", " EB", " ZB", " YB")
		If Bytes = 0 Then
			Return "0 Bytes"
		Else
			Private Po, Si As Double
			Private I As Int
			Bytes = Abs(Bytes)
			I = Floor(Logarithm(Bytes, 1024))
			Po = Power(1024, I)
			Si = Bytes / Po
			Return NumberFormat(Si, 1, 3) & Unit(I)
		End If
	Catch
		Return "0 Bytes"
	End Try
End Sub
Sub AddSideBarSubItem(pg As ABMPage,sidebarreturnName As String, returnname As String, text As String, iconName As String, url As String, divInfront As String, divAfter As String)
	If divInfront = "1" Then
		pg.NavigationBar.AddSideBarSubDivider(sidebarreturnName)
	End If
	pg.NavigationBar.AddSideBarSubItem(sidebarreturnName, returnname, text, iconName, url)
	If divAfter = "1" Then
		pg.NavigationBar.AddSideBarSubDivider(sidebarreturnName)
	End If
End Sub
Sub AddSideBarItem(pg As ABMPage,returnName As String, text As String, iconname As String, url As String, divInfront As String, divAfter As String)
	If divInfront = "1" Then
		pg.NavigationBar.AddSideBarDivider
	End If
	pg.NavigationBar.AddSideBarItem(returnName, text, iconname,url)
	If divAfter = "1" Then
		pg.NavigationBar.AddSideBarDivider
	End If
End Sub
Sub ProjectDays(sDays As String) As String
	Try
		sDays = sDays.trim
		If sDays = "" Then sDays = "0"
		sDays = sDays.Replace(",","")
		sDays = NumberFormat2(sDays,0,0,0,True)
		Return sDays & " Dys"
	Catch
		Return "0 Dys"
	End Try
End Sub
Sub ProjectDate(sDate As String) As String
	If sDate.Length = 0 Then Return ""
	Try
		DateTime.DateFormat = "yyyy-MM-dd"
		Dim dt As Long = DateTime.DateParse(sDate)
		DateTime.DateFormat = "dd-MMM-yyyy, EEE"
		Return DateTime.Date(dt)
	Catch
		Return ""
	End Try
End Sub
public Sub GetCheck(pg As ABMPage, id As String) As Boolean
	Dim inp As ABMCheckbox
	inp = pg.Component(id)
	Return inp.State
End Sub
Public Sub AddCheckProperty(pg As ABMPage,propid As String, propName As String,propValue As Boolean, row As Int, cell As Int) As ABMCheckbox
	Dim inp As ABMCheckbox
	inp.Initialize(pg, propid, propName, propValue, "")
	inp.Tag = propName
	pg.Cell(row,cell).AddComponent(inp)
	Return inp
End Sub
Public Sub ABMCreateCode(cMap As Map, strComponent As String) As String
	'get the initialize method being used
	Dim initProp As Map
	Dim strProp As StringBuilder
	Dim strPropO As StringBuilder
	strProp.Initialize
	strPropO.Initialize
	Dim propList As List
	Dim definition As String
	Dim SQL As SQL = SQLGet
	'get the initialization method being used.
	Dim initialized As String = cMap.Get("initialized")
	Dim wh As Map
	wh.Initialize
	wh.Put("component=", strComponent)
	wh.Put("initialized=", initialized)
	initProp = SQLSelectRecordWhereMap(SQL, "ABMInitialize", wh)
	'get the definition of this item
	If initProp.IsInitialized = True Then
		definition = initProp.GetDefault("definition","")
	Else
		definition = ""
	End If
	propList = SQLExecuteMaps(SQL, "select * from ABMProperties where component = ?", Array As String(strComponent))
	'Close the connection to the database
	SQLClose(SQL)
	definition = definition.tolowercase
	strProp.Append("Dim comp As ").append(strComponent).append(CRLF)
	For Each resMap As Map In propList
		'Log(resMap)
		Dim propname As String = resMap.getdefault("propname","")
		Dim oninit As String = resMap.getdefault("oninit","0")
		Dim hasquotes As String = resMap.GetDefault("hasquotes","0")
		Dim defvalue As String = cMap.getdefault(propname.tolowercase,"")
		If hasquotes = "1" Then defvalue = InQuotes(defvalue)
		Select Case propname
			Case "initialized"
			Case Else
				Select Case oninit
					Case "1"
						definition = definition.Replace(propname.tolowercase,defvalue)
					Case "0"
						strPropO.append("comp.").append(propname).append(" = ").append(defvalue).append(CRLF)
				End Select
		End Select
	Next
	strProp.Append("comp.").Append(definition).Append(CRLF)
	strProp.Append(strPropO.ToString).Append(CRLF)
	Return strProp
End Sub
Public Sub ABMCreateComponent(strComponent As String) As String
	Dim strProp As StringBuilder
	strProp.Initialize
	Dim initList As List
	Dim propList As List
	Dim SQL As SQL = SQLGet
	'select init methods
	initList = SQLExecuteMaps(SQL, "select * from ABMInitialize where component = ?", Array As String(strComponent))
	propList = SQLExecuteMaps(SQL, "select * from ABMProperties where component = ?", Array As String(strComponent))
	'Close the connection to the database
	SQLClose(SQL)
	'lets create the declarations
	strProp.append("'Code to Add the component to the page").append(CRLF)
	strProp.Append("Sub ").append(strComponent).append("_Add(page As ABMPage, pMap as Map) As ").append(strComponent).append(CRLF)
	strProp.Append("'Define the variables to hold the data").Append(CRLF)
	For Each resMap As Map In propList
		Dim propname As String = resMap.getdefault("propname","")
		Dim tempprop As String = propname.Replace(".","")
		strProp.append("Dim ").append(tempprop).append(" As String").append(CRLF)
	Next
	strProp.Append("'Get the records from the map").Append(CRLF)
	For Each resMap As Map In propList
		Dim propname As String = resMap.getdefault("propname","")
		Dim tempprop As String = propname.Replace(".","")
		Dim defaultvalue As String = resMap.getdefault("defaultvalue","")
		strProp.append(tempprop).append(" = pMap.getdefault(").append(QUOTE).append(propname.tolowercase)
		strProp.append(QUOTE).append(", ").append(QUOTE).append(defaultvalue).append(QUOTE).append(")").append(CRLF)
	Next
	strProp.Append("'Define the selects for constants").Append(CRLF)
	For Each resMap As Map In propList
		Dim propname As String = resMap.getdefault("propname","")
		Dim tempprop As String = propname.Replace(".","")
		Dim slist As String = resMap.getdefault("list","")
		If slist.length > 0 And propname <> "initialized" Then
			strProp.append("Select Case ").append(tempprop).append(CRLF)
			Dim spItems() As String = Regex.Split(";", slist)
			For Each strItem As String In spItems
				strProp.append("Case ").append(InQuotes(strItem)).append(CRLF)
				strProp.append(tempprop).append(" = ").append(strItem).append(CRLF)
			Next
			strProp.append("End Select").append(CRLF)
		End If
	Next
	strProp.Append("'Create the component").Append(CRLF)
	strProp.Append("Dim comp As ").append(strComponent).append(CRLF)
	For Each resMap As Map In propList
		Dim propname As String = resMap.getdefault("propname","")
		Dim tempprop As String = propname.Replace(".","")
		Dim oninit As String = resMap.getdefault("oninit","0")
		Select Case propname
			Case "initialized"
				strProp.Append("Select case ").Append(tempprop).Append(CRLF)
				For Each initMap As Map In initList
					Dim initialize1 As String = initMap.get("initialized")
					Dim definition As String = initMap.get("definition")
					strProp.Append("Case ").Append(InQuotes(initialize1)).Append(CRLF)
					strProp.append("comp.").append(definition).append(CRLF)
				Next
				strProp.Append("End Select").Append(CRLF)
			Case Else
				If oninit = "0" Then
					strProp.append("comp.").append(propname).append(" = ").append(tempprop).append(CRLF)
				End If
		End Select
	Next
	strProp.append("Return comp").append(CRLF)
	strProp.append("End Sub").append(CRLF)
	Return strProp
End Sub
Public Sub ABMCreateMap(coMap As Map, strComponent As String) As String
	'Get combo active item
	Dim strCode As StringBuilder
	strCode.Initialize
	strCode.Append("'Define the component property map to pass to Component_Add method").append(CRLF)
	strCode.append("Private Sub ").append(strComponent).append("_Map As Map").append(CRLF)
	strCode.append("Dim compMap As Map").append(CRLF)
	strCode.append("compMap.Initialize").append(CRLF)
	For Each strKey As String In coMap.Keys
		Dim strValue As String = coMap.Get(strKey)
		strCode.Append("compMap.put(").append(InQuotes(strKey)).append(",")
		strCode.Append(InQuotes(strValue)).append(")").append(CRLF)
	Next
	strCode.append("Return compMap").append(CRLF)
	strCode.append("End Sub").append(CRLF)
	Return strCode
End Sub
public Sub DateFromExcelDate(sValue As String) As String
	If IsNumber(sValue) = True Then
		Dim myperiod As Period
		myperiod.Days = sValue - 2
		Dim xlsDate As Long = DateUtils.SetDate(1900, 1, 1)
		Dim newDate As Long = DateUtils.AddPeriod(xlsDate,myperiod)
		DateTime.DateFormat = "yyyy-MM-dd"
		Return DateTime.Date(newDate)
	Else
		Return sValue
	End If
End Sub
Public Sub CDbl(value As String) As Double
	Try
		value = value.Trim
		If value = "" Then value = "0"
		value = value.Replace(",","")
		Dim out As Double = NumberFormat2(value,0,2,2,False)
		Return out
	Catch
		Return value
	End Try
End Sub
Sub IsImportValid(m As Map, fields As List) As Boolean
	Dim bIsValid As Boolean
	Dim vCnt As Int = 0
	bIsValid = True
	If (fields.Size - 1) = 0 Then Return True
	For Each strField As String In fields
		Dim strValue As String = m.GetDefault(strField.ToLowerCase,"")
		If strValue.Length = 0 Then
			vCnt = vCnt + 1
		End If
	Next
	If vCnt = 0 Then
		Return True
	Else
		Return False
	End If
End Sub
Sub GetPoiCellValue(row As PoiRow, colAlpha As String) As String
	Dim cell As PoiCell = GetPoiRowPoiCell(row,colAlpha)
	Return PoiCellReturn(cell)
End Sub
Sub GetPoiRow(ws As PoiSheet, rowPos As Int) As PoiRow
	Try
		Dim rowP As Int = rowPos - 1
		Dim row As PoiRow = ws.GetRow(rowP)
		row.IsInitialized
		Return row
	Catch
		Return Null
	End Try
End Sub
Sub GetPoiRowPoiCell(row As PoiRow, colAlpha As String) As PoiCell
	Try
		Dim colP As Int = 0
		If IsNumber(colAlpha) = False Then
			colP = GetColumnPos(colAlpha) - 1
		Else
			colP = colAlpha -1
		End If
		Dim cell As PoiCell = row.GetCell(colP)
		cell.IsInitialized
		Return cell
	Catch
		Return Null
	End Try
End Sub
Sub SQLNextTableSeq(jSQL As SQL, tblName As String, id As String) As String
	jSQL.BeginTransaction
	Try
		'get the last max on the table
		Dim lastmax As String = jSQL.ExecQuerySingleResult2($"SELECT MAX(${id}) FROM ${tblName}"$, Null)
		If lastmax = Null Then lastmax = 0
		lastmax = lastmax + 1
		jSQL.TransactionSuccessful
		Return lastmax
	Catch
		Log("SQLNextTableSeq: " & LastException)
		jSQL.rollback
	End Try
End Sub
Sub SQLClearTable(jSQL As SQL, tblName As String, id As String, bResetCounter As Boolean)
	jSQL.BeginTransaction
	Try
		jSQL.ExecNonQuery($"DELETE FROM ${tblName}"$)
		jSQL.TransactionSuccessful
		If bResetCounter = True Then
			SQLiteResetCounter(jSQL,tblName,id)
		End If
	Catch
		Log("SQLClearTable: " & LastException)
		jSQL.rollback
	End Try
End Sub
Sub SQLiteResetCounter(jSQL As SQL, tblName As String, id As String)
	jSQL.BeginTransaction
	Try
		'get the last max on the table
		Dim lastmax As String = jSQL.ExecQuerySingleResult2($"SELECT MAX(${id}) FROM ${tblName}"$, Null)
		If lastmax = Null Then lastmax = 0
		'reset the counter to lastmax
		jSQL.ExecNonQuery($"UPDATE SQLITE_SEQUENCE SET SEQ=${lastmax} WHERE NAME='${tblName}'"$)
		jSQL.TransactionSuccessful
	Catch
		Log("SQLiteResetCounter: " & LastException)
		jSQL.Rollback
	End Try
End Sub
Sub ProperCase(myStr As String) As String
	Try
		If myStr.trim.length = 0 Then Return ""
		Dim x As String
		Dim j, k As Int
		myStr = myStr.tolowercase
		x = myStr.ToUpperCase.CharAt(0)
		myStr = x & myStr.SubString2(1, myStr.Length)
		For j = 1 To myStr.Length
			k = myStr.IndexOf2(" ", j + 1)
			If k = -1 Then Exit
			x = myStr.ToUpperCase.CharAt(k + 1)
			myStr = myStr.SubString2(0, k + 1) & x & myStr.SubString2(k + 2, myStr.Length)
		Next
		Return myStr
	Catch
		Return myStr
	End Try
End Sub
Sub SQLRecordExistsWhere(jSQL As SQL, TableName As String, WhereFieldEquals As Map) As Boolean
	Dim mr As Map = SQLSelectRecordWhereMap(jSQL, TableName,WhereFieldEquals)
	If mr.IsInitialized = False Then
		Return False
	Else
		Return True
	End If
End Sub
Sub PoiCellReturn(cell As PoiCell) As String
	If cell.IsInitialized = True Then
		Select Case cell.CellType
			Case cell.TYPE_NUMERIC
				Return cell.ValueNumeric
			Case cell.TYPE_STRING
				Return cell.ValueString
			Case cell.TYPE_FORMULA
				Return cell.ValueFormula
			Case cell.TYPE_BLANK
				Return ""
			Case cell.TYPE_BOOLEAN
				Return cell.ValueBoolean
			Case cell.TYPE_ERROR
				Return ""
			Case Else
				Return cell.Value
		End Select
	Else
		Return ""
	End If
End Sub
'return the column position
Sub GetColumnPos(colAlpha As String) As Int
	Dim alphalist1 As List = CreateList(",","a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z")
	Dim alphalist2 As List = CreateList(",","a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z")
	Dim colmap As Map
	colmap.Initialize
	Dim l1Tot As Int = alphalist1.Size - 1
	Dim l2Tot As Int = alphalist2.Size - 1
	Dim l1cnt As Int
	Dim l2cnt As Int
	Dim colpos As Int = 0
	'first alphabets
	For l1cnt = 0 To l1Tot
		colpos = colpos + 1
		colmap.Put(alphalist1.Get(l1cnt),colpos)
	Next
	'rest of the alphabets
	For l1cnt = 0 To l1Tot
		For l2cnt = 0 To l2Tot
			colpos = colpos + 1
			Dim strKey As String = $"${alphalist1.Get(l1cnt)}${alphalist2.Get(l2cnt)}"$
			colmap.Put(strKey,colpos)
		Next
	Next
	Dim xpos As Int = colmap.getdefault(colAlpha.tolowercase,0)
	Return xpos
End Sub
Sub GetRowCellValue(ws As PoiSheet, rowpos As Int, colAlpha As String) As String
	Dim cell As PoiCell = GetPoiCell(ws,rowpos,colAlpha)
	Return PoiCellReturn(cell)
End Sub
Sub GetPoiCell(ws As PoiSheet, rowPos As Int, colAlpha As String) As PoiCell
	Try
		Dim rowP As Int = rowPos - 1
		Dim colP As Int = 0
		If IsNumber(colAlpha) = False Then
			colP = GetColumnPos(colAlpha) - 1
		Else
			colP = colAlpha -1
		End If
		Dim row As PoiRow = ws.GetRow(rowP)
		row.IsInitialized
		Dim cell As PoiCell = row.GetCell(colP)
		cell.IsInitialized
		Return cell
	Catch
		Return Null
	End Try
End Sub
Sub PreparePermission(sgrpID As String, spgName As String, spgTitle As String) As Map
	Dim nr As Map
	nr.Initialize
	nr.Put("groupid",sgrpID)
	nr.Put("pagename", spgName)
	nr.Put("pagetitle", spgTitle)
	nr.Put("cancreate","0")
	nr.Put("canread","0")
	nr.Put("canupdate","0")
	nr.Put("candelete","0")
	Return nr
End Sub
Sub RandomString(Length As Int, LowerCase As Boolean, UpperCase As Boolean, Numbers As Boolean, AdditionalChars As String) As String
	Dim source As String
	If LowerCase = True Then
		source = source &"abcdefghijklmnopqrstuvwxyz"
	End If
	If UpperCase = True Then
		source = source &"ABCDEFGHIJKLMNOPQRSTUVWXYZ"
	End If
	If Numbers = True Then
		source = source &"0123456789"
	End If
	If AdditionalChars.Length > 0 Then
		source = source&AdditionalChars
	End If
	Dim SB As StringBuilder
	SB.Initialize
	For i = 1 To Length
		Dim r As Int = Rnd(0,source.Length-1)
		SB.Append(source.SubString2(r,r+1))
	Next
	Return SB.ToString
End Sub
Sub GeneratePassword(IntNum As Int) As String
	Return RandomString(IntNum,True,True,True,"")
End Sub
Sub HasPermission(pgCheck As String, permit As String) As Boolean
	If HasAccessControl = 0 Then Return True
	pgCheck = pgCheck.tolowercase
	If Permissions.IsInitialized = False Then Permissions.Initialize
	If Permissions.ContainsKey(pgCheck) = True Then
		Dim permitm As Map = Permissions.Get(pgCheck)
		Dim spermit As String = permitm.getdefault(permit.tolowercase,"0")
		If spermit = "1" Then
			Return True
		Else
			Return False
		End If
	Else
		Return False
	End If
End Sub
Sub Save2Files(fil As String, sContent As String)
	Dim fPath As String = File.Combine(File.DirApp,"www/" & AppName.tolowercase & "/files")
	File.MakeDir("", fPath)
	File.WriteString(fPath,fil,sContent)
End Sub
Sub OpenFile(sPath As String)
	If File.Exists("",sPath) = True Then
		fx.ShowExternalDocument(File.GetUri("",sPath))
	End If
End Sub
Sub CodeFormatter(strCode As String) As String
	Try
		File.WriteString(File.DirApp,"code.txt",strCode)
		Dim clsCM As MashCodeModule
		clsCM.Initialize(File.DirApp,"code.txt")
		clsCM.Code_Beautify
		clsCM.save
		Return File.ReadString(File.DirApp,"code.txt")
	Catch
		Return strCode
	End Try
End Sub
'remove lines containing a string
Sub Code_RemoveLines(Lines As List, StrSearch As String, ExactMatch As Boolean) As List
	Dim totLines As Long
	Dim cntLines As Long
	Dim curLine As String
	Dim xLines As List
	xLines = Lines
	totLines = xLines.size - 1
	For cntLines = totLines To 0 Step -1
		curLine = xLines.Get(cntLines)
		curLine = Trim(curLine)
		If ExactMatch = True Then
			If LCase(StrSearch) = LCase(curLine) Then
				xLines.RemoveAt(cntLines)
			End If
		Else
			If InStr(LCase(curLine), LCase(StrSearch)) > 0 Then
				xLines.RemoveAt(cntLines)
			End If
		End If
	Next
	Return xLines
End Sub
private Sub Trim(strValue As String) As String
	Return strValue.trim
End Sub
Sub LCase(Text As String) As String
	Return Text.ToLowerCase
End Sub
Sub Space(HM As Int) As String
	Dim RS As String = ""
	Do While Len(RS) < HM
		RS = RS & " "
	Loop
	Return RS
End Sub
Public Sub InQuotes(sValue As String) As String
	Return QUOTE & sValue & QUOTE
End Sub
public Sub GetInput(pg As ABMPage, id As String) As String
	Dim inp As ABMInput
	inp = pg.Component(id)
	Return inp.text
End Sub
public Sub GetCombo(pg As ABMPage, id As String) As String
	Dim inp As ABMCombo
	inp = pg.Component(id)
	Return inp.GetActiveItemId
End Sub
Public Sub AddTextProperty(pg As ABMPage,propid As String, propName As String,propValue As String, row As Int, cell As Int) As ABMInput
	Dim inp As ABMInput
	inp.Initialize(pg,propid, ABM.INPUT_TEXT, propName, False, "")
	inp.Text = propValue
	inp.Tag = propName
	pg.Cell(row,cell).AddComponent(inp)
	Return inp
End Sub
Public Sub AddComboProperty(pg As ABMPage,propid As String, propName As String,propValue As String, row As Int, cell As Int,items As String) As ABMCombo
	Dim cbo As ABMCombo
	cbo.Initialize(pg,propid, propName, 650, "")
	cbo.Clear
	cbo.Tag = propName
	If items.Length > 0 Then
		Dim spItems() As String = Regex.Split(";", items)
		For Each strItem As String In spItems
			cbo.AddItem(strItem, strItem, ListItemIconTitle(pg, strItem, "", strItem, ""))
		Next
	End If
	If propValue.Length > 0 Then cbo.SetActiveItemId(propValue)
	pg.Cell(row,cell).AddComponent(cbo)
	Return cbo
End Sub
Public Sub GetSlideType(sSlide As String) As String
	select case sSlide
		case "ABM.IMAGESLIDER_CENTER"
			return ABM.IMAGESLIDER_CENTER
		case "ABM.IMAGESLIDER_LEFT"
			return ABM.IMAGESLIDER_LEFT
		case "ABM.IMAGESLIDER_RIGHT"
			return ABM.IMAGESLIDER_RIGHT
		case else
			return ABM.IMAGESLIDER_LEFT
	End select
End Sub
public Sub GetIntensity(sIntensity As String) As String
	Select Case sIntensity
		Case "ABM.INTENSITY_NORMAL"
			Return ABM.INTENSITY_NORMAL
		Case "ABM.INTENSITY_LIGHTEN5"
			Return ABM.INTENSITY_LIGHTEN5
		Case "ABM.INTENSITY_LIGHTEN4"
			Return ABM.INTENSITY_LIGHTEN4
		Case "ABM.INTENSITY_LIGHTEN3"
			Return ABM.INTENSITY_LIGHTEN3
		Case "ABM.INTENSITY_LIGHTEN2"
			Return ABM.INTENSITY_LIGHTEN2
		Case "ABM.INTENSITY_LIGHTEN1"
			Return ABM.INTENSITY_LIGHTEN1
		Case "ABM.INTENSITY_DARKEN1"
			Return ABM.INTENSITY_DARKEN1
		Case "ABM.INTENSITY_DARKEN2"
			Return ABM.INTENSITY_DARKEN2
		Case "ABM.INTENSITY_DARKEN3"
			Return ABM.INTENSITY_DARKEN3
		Case "ABM.INTENSITY_DARKEN4"
			Return ABM.INTENSITY_DARKEN4
		Case "ABM.INTENSITY_ACCENT1"
			Return ABM.INTENSITY_ACCENT1
		Case "ABM.INTENSITY_ACCENT2"
			Return ABM.INTENSITY_ACCENT2
		Case "ABM.INTENSITY_ACCENT3"
			Return ABM.INTENSITY_ACCENT3
		Case "ABM.INTENSITY_ACCENT4"
			Return ABM.INTENSITY_ACCENT4
		Case Else
			Return ABM.INTENSITY_NORMAL
	End Select
End Sub
public Sub GetColor(sColor As String) As String
	Select Case sColor
		Case "ABM.COLOR_AMBER"
			Return ABM.COLOR_AMBER
		Case "ABM.COLOR_BLACK"
			Return ABM.COLOR_BLACK
		Case "ABM.COLOR_BLUE"
			Return ABM.COLOR_BLUE
		Case "ABM.COLOR_BLUEGREY"
			Return ABM.COLOR_BLUEGREY
		Case "ABM.COLOR_BROWN"
			Return ABM.COLOR_BROWN
		Case "ABM.COLOR_CYAN"
			Return ABM.COLOR_CYAN
		Case "ABM.COLOR_DEEPORANGE"
			Return ABM.COLOR_DEEPORANGE
		Case "ABM.COLOR_DEEPPURPLE"
			Return ABM.COLOR_DEEPPURPLE
		Case "ABM.COLOR_GREEN"
			Return ABM.COLOR_GREEN
		Case "ABM.COLOR_GREY"
			Return ABM.COLOR_GREY
		Case "ABM.COLOR_INDIGO"
			Return ABM.COLOR_INDIGO
		Case "ABM.COLOR_LIGHTBLUE"
			Return ABM.COLOR_LIGHTBLUE
		Case "ABM.COLOR_LIGHTGREEN"
			Return ABM.COLOR_LIGHTGREEN
		Case "ABM.COLOR_LIME"
			Return ABM.COLOR_LIME
		Case "ABM.COLOR_ORANGE"
			Return ABM.COLOR_ORANGE
		Case "ABM.COLOR_PINK"
			Return ABM.COLOR_PINK
		Case "ABM.COLOR_PURPLE"
			Return ABM.COLOR_PURPLE
		Case "ABM.COLOR_RED"
			Return ABM.COLOR_RED
		Case "ABM.COLOR_TEAL"
			Return ABM.COLOR_TEAL
		Case "ABM.COLOR_TRANSPARENT"
			Return ABM.COLOR_TRANSPARENT
		Case "ABM.COLOR_WHITE"
			Return ABM.COLOR_WHITE
		Case "ABM.COLOR_YELLOW"
			Return ABM.COLOR_YELLOW
		Case Else
			Return ABM.COLOR_LIGHTBLUE
	End Select
End Sub
Sub InStr(Text As String, sFind As String) As Int
	Return Text.IndexOf(sFind)
End Sub
Public Sub Val(value As String) As String
	Try
		value = value.Trim
		If value = "" Then value = "0"
		Dim sout As String = ""
		Dim mout As String = ""
		Dim slen As Int = value.Length
		Dim i As Int = 0
		For i = 0 To slen - 1
			mout = value.CharAt(i)
			If InStr("0123456789.-", mout) <> -1 Then
				sout = sout & mout
			End If
		Next
		Return sout + 0
	Catch
		Return value
	End Try
End Sub
Public Sub FixImage(sPath As String, sExtension As String) As String
	sPath = sPath.replace("[","")
	sPath = sPath.replace("]","")
	sPath = sPath.replace(",","")
	sPath = sPath.replace("-","")
	sPath = sPath.replace(" ","")
	sPath = sPath.trim
	sPath = sPath & sExtension
	Return sPath.ToLowerCase
End Sub
Sub FixDelimiter(sValue As String) As String
	If sValue = "|" Then sValue = "\|"
	If sValue = "." Then sValue = "\."
	If sValue = "\" Then sValue = "\\"
	If sValue = "^" Then sValue = "\^"
	If sValue = "$" Then sValue = "\$"
	If sValue = "?" Then sValue = "\?"
	If sValue = "*" Then sValue = "\*"
	If sValue = "+" Then sValue = "\+"
	If sValue = "(" Then sValue = "\("
	If sValue = ")" Then sValue = "\)"
	If sValue = "[" Then sValue = "\["
	If sValue = "{" Then sValue = "\{"
	If sValue = ";" Then sValue = "\;"
	Return sValue
End Sub
Public Sub UpDownSame(variance As String) As String
	If variance < 0 Then Return "../images/up.png"
	If variance > 0 Then Return "../images/down.png"
	If variance = 0 Then Return "../images/same.png"
	Return ""
End Sub
Sub MvField(sValue As String, iPosition As Int, Delimiter As String) As String
	If sValue.Length = 0 Then Return ""
	Dim xPos As Int: xPos = sValue.IndexOf(Delimiter)
	If xPos = -1 Then Return sValue
	Dim mValues() As String
	Dim tValues As Int
	Delimiter = FixDelimiter(Delimiter)
	If sValue.EndsWith(Delimiter) Then sValue = sValue & " "
	mValues = Regex.split(Delimiter, sValue)
	tValues = mValues.Length -1
	Select Case iPosition
		Case -1
			Return mValues(tValues)
		Case -2
			Return mValues(tValues - 1)
		Case Else
			iPosition = iPosition - 1
			If iPosition <= -1 Then Return mValues(tValues)
			If iPosition > tValues Then Return ""
			Return mValues(iPosition)
	End Select
End Sub
Sub RenameFolder(OldName As String, NewName As String)
	Dim jo1, jo2 As JavaObject
	jo1.InitializeNewInstance("java.io.File", Array(OldName))
	jo2.InitializeNewInstance("java.io.File", Array(NewName))
	Return jo1.RunMethod("renameTo", Array(jo2))
End Sub
Public Sub DeleteFolder(Folder As String)
	Try
		For Each f As String In File.ListFiles(Folder)
			If File.Exists(Folder,f) = True Then File.Delete(Folder, f)
		Next
		File.Delete("",Folder)
	Catch
	End Try
End Sub
Sub DeleteFolderRecursive(Folder As String)
	Try
		For Each f As String In File.ListFiles(Folder)
			If File.IsDirectory(Folder, f) Then
				DeleteFolderRecursive (File.Combine(Folder, f))
			End If
			If File.Exists(Folder,f) = True Then File.Delete(Folder, f)
		Next
	Catch
	End Try
End Sub
Sub YesNo2ZeroOne(value As String) As String
	If value = "N" Or value = "" Then
		Return "0"
	Else
		Return "1"
	End If
End Sub
Sub ZeroOne2YN(value As String) As String
	If value = "0" Or value = "" Then
		Return "N"
	Else
		Return "Y"
	End If
End Sub
Sub Replace(Text As String, sFind As String, sReplaceWith As String) As String
	Return Text.Replace(sFind, sReplaceWith)
End Sub
Sub LongDate(sDate As String) As String
	If sDate.Length = 0 Then Return ""
	Try
		DateTime.DateFormat = "yyyy-MM-dd"
		Dim dt As Long = DateTime.DateParse(sDate)
		DateTime.DateFormat = "EEEE, dd MMMM yyyy"
		Return DateTime.Date(dt)
	Catch
		Return ""
	End Try
End Sub
Sub LongDateTime(sDate As String) As String
	If sDate.Length = 0 Then Return ""
	Try
		DateTime.DateFormat = "yyyy-MM-dd HH:mm"
		Dim dt As Long = DateTime.DateParse(sDate)
		DateTime.DateFormat = "EEEE, dd MMMM yyyy HH:mm"
		Return DateTime.Date(dt)
	Catch
		Return ""
	End Try
End Sub
Sub ListItemBadge(page As ABMPage, id As String, text As String, messages As String, isnew As Boolean, Theme As String) As ABMContainer
	Dim ItemCont As ABMContainer
	ItemCont.Initialize(page, id, "")
	ItemCont.AddRowsM(1,False,0,0, "").AddCellsOSMP(1,0,0,0,10,10,10,6,0,0,0,"").AddCellsOSMP(1,0,0,0,2,2,2,6,0,0,0,"")
	ItemCont.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
	Dim lbl As ABMLabel
	lbl.Initialize(page, id & "lbl", text, ABM.SIZE_PARAGRAPH, False, Theme)
	ItemCont.Cell(1,1).AddComponent(lbl)
	Dim badge As ABMBadge
	badge.Initialize(page, id & "badge", messages,  isnew, "")
	ItemCont.Cell(1,2).AddComponent(badge)
	Return ItemCont
End Sub
Sub Right(Text As String, Length As Long) As String
	If Length>Text.Length Then Length=Text.Length
	Return Text.SubString(Text.Length-Length)
End Sub
Sub Left(Text As String, Length As Long)As String
	If Length>Text.Length Then Length=Text.Length
	Return Text.SubString2(0, Length)
End Sub
Private Sub List2Array (a_lstArgs As List) As String()
	Dim arrArgs(a_lstArgs.Size) As String
	For i = 0 To arrArgs.Length - 1
		arrArgs(i) = a_lstArgs.Get(i)
	Next
	Return arrArgs
End Sub
Public Sub SQLSelectRecordWhereMap(jSQL As SQL, TableName As String, WhereFieldEquals As Map) As Map
	Dim lst As Map
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("SELECT * FROM ").Append(TableName).Append(" WHERE ")
	If WhereFieldEquals.Size = 0 Then
		Log("WhereFieldEquals map empty!")
		Return lst
	End If
	Dim args As List
	args.Initialize
	For i = 0 To WhereFieldEquals.Size - 1
		If i > 0 Then sb.Append(" AND ")
		sb.Append(WhereFieldEquals.GetKeyAt(i)).Append(" ?")
		args.Add(WhereFieldEquals.GetValueAt(i))
	Next
	Return SQLExecuteMap(jSQL,sb.ToString, List2Array(args))
End Sub
Public Sub SQLSelectRecordWhereMaps(jSQL As SQL, TableName As String, WhereFieldEquals As Map) As List
	Dim lst As List
	lst.Initialize
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("SELECT * FROM ").Append(TableName).Append(" WHERE ")
	If WhereFieldEquals.Size = 0 Then
		Log("WhereFieldEquals map empty!")
		Return lst
	End If
	Dim args As List
	args.Initialize
	For i = 0 To WhereFieldEquals.Size - 1
		If i > 0 Then sb.Append(" AND ")
		sb.Append(WhereFieldEquals.GetKeyAt(i)).Append(" ?")
		args.Add(WhereFieldEquals.GetValueAt(i))
	Next
	Return SQLExecuteMaps(jSQL,sb.ToString,List2Array(args))
End Sub
Sub MakeMoney(sValue As String) As String
	If sValue.Length = 0 Then Return "0.00"
	If sValue = "null" Then sValue = "0.00"
	sValue = sValue.Replace(",","")
	sValue = Val(sValue)
	If sValue = "0" Then sValue = "000"
	sValue = Round2(sValue,2)
	Return NumberFormat2(sValue, 1, 2, 2, True)
End Sub
Sub Percentage(sValue As String) As String
	If sValue = "" Then sValue = "0.00"
	If sValue.Length = 0 Then Return "0.00"
	If sValue = "null" Then sValue = "0.00"
	sValue = sValue.Replace(",","")
	sValue = Val(sValue)
	If sValue = "0" Then sValue = "0.00"
	sValue = Round2(sValue,2)
	sValue = sValue & "%"
	Return sValue
End Sub
Sub ListItemCard(page As ABMPage, id As String, image As String, title As String, description As String, Theme As String) As ABMCard
	' image card
	Dim card4 As ABMCard
	card4.InitializeAsCard(page, "card4", title, description, ABM.CARD_NOTSPECIFIED, Theme)
	card4.Image = image
	Return card4
End Sub
Sub ListItemIconTitle(page As ABMPage, id As String, icon As String, Title As String, Theme As String) As ABMLabel
	Dim lbl As ABMLabel
	If icon <> "" Then
		lbl.Initialize(page, id, "{NBSP}" & Title, ABM.SIZE_H6, False, Theme)
	Else
		lbl.Initialize(page, id, "{NBSP}" & Title, ABM.SIZE_H6, True, "")
	End If
	lbl.VerticalAlign = True
	lbl.IconName = icon
	Return lbl
End Sub
Sub ListItemIconTitleDescription(page As ABMPage, id As String, image As String, Title As String, Subtitle As String, TitleTheme As String, DescriptionTheme As String, bIsCircular As Boolean, ContainerTheme As String) As ABMContainer
	Dim ItemCont As ABMContainer
	ItemCont.Initialize(page, id, ContainerTheme)
	ItemCont.AddRowsM(1,False,6,0, "").AddCellsOSMP(1,0,0,0,3,2,2,0,0,16,0,"").AddCellsOS(1,0,0,0,9,10,10,"")
	ItemCont.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
	Dim SubItemCont As ABMContainer
	SubItemCont.Initialize(page, id & "SubItemCont", ContainerTheme)
	SubItemCont.AddRowsM(1,False, 0,0,"").AddCells12MP(1,-6,0,0,0,"").AddCells12(1,"")
	SubItemCont.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
	ItemCont.Cell(1,2).AddComponent(SubItemCont)
	Dim lbl1 As ABMLabel
	lbl1.Initialize(page, id & "lbl1", "{NBSP}" & Title, ABM.SIZE_H6, False, TitleTheme)
	lbl1.VerticalAlign = True
	lbl1.IconName = image
	SubItemCont.Cell(1,1).AddComponent(lbl1)
	Dim lbl2 As ABMLabel
	lbl2.Initialize(page, id & "lbl2", "{NBSP}" & Subtitle, ABM.SIZE_H6, False, DescriptionTheme)
	lbl2.VerticalAlign = True
	SubItemCont.Cell(1,2).AddComponent(lbl2)
	Return ItemCont
End Sub
Sub ListItemImageTitle(page As ABMPage, id As String, icon As String, Title As String, Theme As String) As ABMLabel
	Return ListItemIconTitle(page, id, icon, "{NBSP}" & Title, Theme)
End Sub
Sub ListItemTitle(page As ABMPage, id As String, Title As String) As ABMLabel
	Dim lbl As ABMLabel
	lbl.Initialize(page, id, "{NBSP}" & Title, ABM.SIZE_H6, False, "header")
	lbl.VerticalAlign = True
	Return lbl
End Sub
Sub ListItemTitleTheme(page As ABMPage, id As String, Title As String, Theme As String) As ABMLabel
	Dim lbl As ABMLabel
	lbl.Initialize(page, id, "{NBSP}" & Title, ABM.SIZE_H6, True, Theme)
	lbl.VerticalAlign = True
	Return lbl
End Sub
Sub ListItemImageTitleDescription(page As ABMPage, id As String, image As String, Title As String, Subtitle As String, TitleTheme As String, DescriptionTheme As String, bIsCircular As Boolean, ContainerTheme As String) As ABMContainer
	Dim ItemCont As ABMContainer
	ItemCont.Initialize(page, id, ContainerTheme)
	ItemCont.AddRowsM(1,False,6,0, "").AddCellsOSMP(1,0,0,0,3,2,2,0,0,16,0,"").AddCellsOS(1,0,0,0,9,10,10,"")
	ItemCont.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
	Dim SubItemCont As ABMContainer
	SubItemCont.Initialize(page, id & "SubItemCont", ContainerTheme)
	SubItemCont.AddRowsM(1,False, 0,0,"").AddCells12MP(1,-6,0,0,0,"").AddCells12(1,"")
	SubItemCont.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
	ItemCont.Cell(1,2).AddComponent(SubItemCont)
	Dim img As ABMImage
	img.Initialize(page, id & "img", image, 1)
	img.SetFixedSize(48,48)
	img.IsCircular = bIsCircular
	img.IsResponsive = True
	ItemCont.Cell(1,1).AddComponent(img)
	Dim lbl1 As ABMLabel
	lbl1.Initialize(page, id & "lbl1", Title, ABM.SIZE_H6, False, TitleTheme)
	lbl1.VerticalAlign = True
	SubItemCont.Cell(1,1).AddComponent(lbl1)
	Dim lbl2 As ABMLabel
	lbl2.Initialize(page, id & "lbl2", Subtitle, ABM.SIZE_H6, False, DescriptionTheme)
	lbl2.VerticalAlign = True
	SubItemCont.Cell(1,2).AddComponent(lbl2)
	Return ItemCont
End Sub
Sub SideBarComponent(page As ABMPage, id As String, image As String, Title As String, Subtitle As String, TitleTheme As String, DescriptionTheme As String, bIsCircular As Boolean, ContainerTheme As String) As ABMContainer
	Dim ItemCont As ABMContainer
	ItemCont.Initialize(page, id, ContainerTheme)
	ItemCont.AddRowsM(1,False,0,0, "").AddCellsOSMP(1,0,0,0,3,3,3,4,0,0,0,"").AddCellsOSMP(1,0,0,0,9,9,9,4,0,0,0,"")
	ItemCont.AddRowsM(1,False,0,0, "").AddCells12(1, "")
	ItemCont.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
	Dim SubItemCont As ABMContainer
	SubItemCont.Initialize(page, id & "SubItemCont", ContainerTheme)
	SubItemCont.AddRowsM(1,False, 0,0,"").AddCells12MP(1,-6,0,0,0,"").AddCells12(1,"")
	SubItemCont.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
	ItemCont.Cell(1,2).AddComponent(SubItemCont)
	Dim img As ABMImage
	img.Initialize(page, id & "img", image, 1)
	img.SetFixedSize(48,48)
	img.IsCircular = bIsCircular
	img.IsResponsive = True
	ItemCont.Cell(1,1).AddComponent(img)
	Dim lbl1 As ABMLabel
	lbl1.Initialize(page, id & "lbl1", Title, ABM.SIZE_H6, False, TitleTheme)
	lbl1.VerticalAlign = True
	SubItemCont.Cell(1,1).AddComponent(lbl1)
	Dim lbl2 As ABMLabel
	lbl2.Initialize(page, id & "lbl2", Subtitle, ABM.SIZE_H6, False, DescriptionTheme)
	lbl2.VerticalAlign = True
	SubItemCont.Cell(1,2).AddComponent(lbl2)
	Return ItemCont
End Sub
Sub SessionStorageSave(page As ABMPage, key As String, value As String)
	key = key.tolowercase
	page.ws.Session.SetAttribute(key, value)
End Sub
Sub SessionStorageRead(page As ABMPage, key As String) As String
	key = key.tolowercase
	Return page.ws.Session.GetAttribute2(key, "")
End Sub
Sub LocalStorageSave(page As ABMPage, key As String, value As String)
	key = key.tolowercase
	ABM.SaveInLocalStorage(page, key, value)
End Sub
Sub LocalStorageDelete(page As ABMPage, key As String)
	key = key.tolowercase
	ABM.DeleteFromLocalStorage(page, key)
End Sub
Sub LocalStorageRead(page As ABMPage, key As String) As String
	key = key.tolowercase
	Return ABM.LoadFromLocalStorage(page, key)
End Sub
Sub GetImageFromServer(page As Object, iLink As String, JobName As String, phpTag As String)
	Dim job As HttpJob
	job.Initialize(JobName, page)
	job.Tag = phpTag
	Log(iLink)
	job.Download(iLink)
End Sub
' convert a json string to a map
Sub Json2Map(jsonText As String) As Map
	Dim json As JSONParser
	Dim Map1 As Map
	Map1.Initialize
	If Len(jsonText) > 0 Then
		json.Initialize(jsonText)
		Map1 = json.NextObject
	End If
	Return Map1
End Sub
'convert a map to a json string
Sub Map2Json(m As Map) As String
	Dim gen As JSONGenerator
	Dim outJSON As String
	gen.Initialize(m)
	outJSON = gen.ToString
	Return outJSON
End Sub
Sub Json2List(jsonTxt As String) As List
	Dim root As List
	root.Initialize
	Try
		Dim parser As JSONParser
		parser.Initialize(jsonTxt)
		root = parser.NextArray
		Return root
	Catch
		Return root
	End Try
End Sub
Sub ExecutePHP(page As Object, pQuery As Map, JobName As String, phpFile As String, phpTag As String)
	Dim job As HttpJob
	Dim scommand As String
	Dim json As String
	job.Initialize(JobName, page)
	job.Tag = phpTag
	json = Map2QueryString(pQuery)
	If Len(json) = 0 Then
		scommand = PhpPath & phpFile
	Else
		scommand = PhpPath & phpFile & "?" & json
	End If
	Log(scommand)
	job.Download(scommand)
End Sub
Sub Map2QueryString(sm As Map) As String
	' convert a map to a querystring string
	Dim SU As StringUtils
	Dim iCnt As Int
	Dim iTot As Int
	Dim sb As StringBuilder
	Dim mValue As String
	sb.Initialize
	' get size of map
	iTot = sm.Size - 1
	iCnt = 0
	For Each mKey As String In sm.Keys
		mValue = sm.Get(mKey)
		mValue = SU.EncodeUrl(mValue, "UTF8")
		mKey = mKey.Trim
		If mKey.EndsWith("=") = False Then mKey = mKey & "="
		sb.Append(mKey).Append(mValue)
		If iCnt < iTot Then sb.Append("&")
		iCnt = iCnt + 1
	Next
	Return sb.ToString
End Sub
Public Sub Speak(page As ABMPage, Text As String)
	Dim sb As StringBuilder
	sb.Initialize
	sb.append("window.speechSynthesis.speak(SpeechSynthesisUtterance('")
	sb.append(Text)
	sb.append("'));")
	page.ws.Eval(sb.ToString, Null)
	page.ws.Flush
End Sub
Public Sub NavigateToPage(ws As WebSocket, PageId As String, TargetUrl As String) 'ignore
	Dim testTargetUrl As String = TargetUrl
	If Not(testTargetUrl.EndsWith(".htm") Or testTargetUrl.EndsWith(".html") Or testTargetUrl.EndsWith("/")) Then
		TargetUrl = TargetUrl & "/"
	End If
	If PageId.Length > 0 Then ABM.RemoveMeFromCache(CachedPages, PageId)
	If ws.Open Then
		ws.Eval("window.location = arguments[0]", Array As Object(TargetUrl))
		ws.Flush
		ws.Close
	End If
End Sub
Public Sub NavigateToPageNewTab(ws As WebSocket, PageId As String, TargetUrl As String, OpenInNewTab As Boolean)
	If AppVersion.Length > 0 Then TargetUrl = $"${TargetUrl}?${AppVersion}"$
	If PageId.Length > 0 Then ABM.RemoveMeFromCache(CachedPages, PageId)
	If ws.Open Then
		If OpenInNewTab Then
			Dim s As String
			' check if a mobile phone only
			'			s = $"var check = false;
			'  			(function(a){if(/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino/i.test(a)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(a.substr(0,4))) check = true;})(navigator.userAgent||navigator.vendor||window.opera);
			'  			if (check) {
			'  				window.location = arguments[0];
			'  			} else {
			'  				window.open(arguments[0],'_blank');
			'  			}"$
			' check if a mobile phone or a tablet
			s = $"var check = false;
			(function(a){if(/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino|android|ipad|playbook|silk/i.test(a)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(a.substr(0,4))) check = true;})(navigator.userAgent||navigator.vendor||window.opera);
			if (check) {
			window.location = arguments[0];
			} else {
			window.open(arguments[0],'_blank');
			}"$
			ws.Eval(s, Array As Object(TargetUrl))
		Else
			ws.Eval("window.location = arguments[0]", Array As Object(TargetUrl))
		End If
		ws.Flush
	End If
End Sub
Sub RedirectOutput (Dir As String, FileName As String)
	#if RELEASE
		Dim out As OutputStream = File.OpenOutput(Dir, FileName, False) 'Set to True to append the logs
		Dim ps As JavaObject
		ps.InitializeNewInstance("java.io.PrintStream", Array(out, True, "utf8"))
		Dim jo As JavaObject
		jo.InitializeStatic("java.lang.System")
		jo.RunMethod("setOut", Array(ps))
		jo.RunMethod("setErr", Array(ps))
	#end if
End Sub
' build methods for ABM objects
Sub BuildTheme(themeName As String)
	MyTheme.Initialize(themeName)
	' the page theme
	'MyTheme.Page.BackColor = ABM.COLOR_WHITE
	'MyTheme.Page.BackColorIntensity = ABM.INTENSITY_NORMAL
	'MyTheme.Page.ConnectedIndicatorColor = ABM.COLOR_GREEN
	'MyTheme.Page.ConnectedIndicatorColorIntensity = ABM.INTENSITY_NORMAL
	'MyTheme.Page.DisconnectedIndicatorColor = ABM.COLOR_RED
	'MyTheme.Page.DisconnectedIndicatorColorIntensity = ABM.INTENSITY_NORMAL
	'MyTheme.Page.PlaceHolderColor = ABM.COLOR_GREY
	'MyTheme.Page.PlaceHolderColorIntensity = ABM.INTENSITY_NORMAL
	' add any shared themes
	MyTheme.Page.AddColorDefinition("askteencoach", ABM.INTENSITY_ACCENT1, "#993333", 1 )
	MyTheme.Page.AddColorDefinition("askteencoach", ABM.INTENSITY_ACCENT2, "#993333", 1 )
	MyTheme.Page.AddColorDefinition("askteencoach", ABM.INTENSITY_ACCENT3, "#993333", 1 )
	MyTheme.Page.AddColorDefinition("askteencoach", ABM.INTENSITY_ACCENT4, "#993333", 1 )
	MyTheme.Page.AddColorDefinition("askteencoach", ABM.INTENSITY_DARKEN1, "#993333", 1 )
	MyTheme.Page.AddColorDefinition("askteencoach", ABM.INTENSITY_DARKEN2, "#993333", 1 )
	MyTheme.Page.AddColorDefinition("askteencoach", ABM.INTENSITY_DARKEN3, "#993333", 1 )
	MyTheme.Page.AddColorDefinition("askteencoach", ABM.INTENSITY_DARKEN4, "#993333", 1 )
	MyTheme.Page.AddColorDefinition("askteencoach", ABM.INTENSITY_LIGHTEN1, "#993333", 1 )
	MyTheme.Page.AddColorDefinition("askteencoach", ABM.INTENSITY_LIGHTEN2, "#993333", 1 )
	MyTheme.Page.AddColorDefinition("askteencoach", ABM.INTENSITY_LIGHTEN3, "#993333", 1 )
	MyTheme.Page.AddColorDefinition("askteencoach", ABM.INTENSITY_LIGHTEN4, "#993333", 1 )
	MyTheme.Page.AddColorDefinition("askteencoach", ABM.INTENSITY_LIGHTEN5, "#993333", 1 )
	MyTheme.Page.AddColorDefinition("askteencoach", ABM.INTENSITY_NORMAL, "#993333", 1 )
	MyTheme.AddButtonTheme("fb")
	MyTheme.Button("fb").menuhoverbackcolor = ABM.COLOR_GREY
	MyTheme.Button("fb").menuhoverbackcolorintensity = ABM.INTENSITY_LIGHTEN3
	MyTheme.Button("fb").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Button("fb").forecolor = ABM.COLOR_WHITE
	MyTheme.Button("fb").menudividercolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("fb").menuforecolor = ABM.COLOR_BLACK
	MyTheme.Button("fb").backcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("fb").menuforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("fb").waveseffect = ABM.WAVESEFFECT_DEFAULT
	MyTheme.Button("fb").wavescircle = False
	MyTheme.Button("fb").backcolor = "askteencoach"
	MyTheme.Button("fb").forecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("fb").menudividercolor = "askteencoach"
	MyTheme.Button("fb").menubackcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("fb").menubackcolor = ABM.COLOR_WHITE
	MyTheme.AddButtonTheme("limedarkbutton")
	MyTheme.Button("limedarkbutton").menuhoverbackcolor = ABM.COLOR_GREY
	MyTheme.Button("limedarkbutton").menuhoverbackcolorintensity = ABM.INTENSITY_LIGHTEN3
	MyTheme.Button("limedarkbutton").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Button("limedarkbutton").forecolor = ABM.COLOR_WHITE
	MyTheme.Button("limedarkbutton").menudividercolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("limedarkbutton").menuforecolor = ABM.COLOR_BLACK
	MyTheme.Button("limedarkbutton").backcolorintensity = ABM.INTENSITY_DARKEN1
	MyTheme.Button("limedarkbutton").menuforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("limedarkbutton").waveseffect = ABM.WAVESEFFECT_DEFAULT
	MyTheme.Button("limedarkbutton").wavescircle = False
	MyTheme.Button("limedarkbutton").backcolor = ABM.COLOR_LIME
	MyTheme.Button("limedarkbutton").forecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("limedarkbutton").menudividercolor = ABM.COLOR_LIGHTBLUE
	MyTheme.Button("limedarkbutton").menubackcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("limedarkbutton").menubackcolor = ABM.COLOR_WHITE
	MyTheme.AddButtonTheme("transparent")
	MyTheme.Button("transparent").waveseffect = ABM.WAVESEFFECT_DEFAULT
	MyTheme.Button("transparent").wavescircle = False
	MyTheme.Button("transparent").backcolor = ABM.COLOR_TRANSPARENT
	MyTheme.Button("transparent").forecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("transparent").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Button("transparent").forecolor = ABM.COLOR_WHITE
	MyTheme.Button("transparent").backcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.AddButtonTheme("brownbutton")
	MyTheme.Button("brownbutton").menuhoverbackcolor = ABM.COLOR_GREY
	MyTheme.Button("brownbutton").menuhoverbackcolorintensity = ABM.INTENSITY_LIGHTEN3
	MyTheme.Button("brownbutton").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Button("brownbutton").forecolor = ABM.COLOR_WHITE
	MyTheme.Button("brownbutton").menudividercolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("brownbutton").menuforecolor = ABM.COLOR_BLACK
	MyTheme.Button("brownbutton").backcolorintensity = ABM.INTENSITY_LIGHTEN2
	MyTheme.Button("brownbutton").menuforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("brownbutton").waveseffect = ABM.WAVESEFFECT_DEFAULT
	MyTheme.Button("brownbutton").wavescircle = False
	MyTheme.Button("brownbutton").backcolor = ABM.COLOR_BROWN
	MyTheme.Button("brownbutton").forecolorintensity = ABM.INTENSITY_LIGHTEN2
	MyTheme.Button("brownbutton").menudividercolor = ABM.COLOR_LIGHTBLUE
	MyTheme.Button("brownbutton").menubackcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("brownbutton").menubackcolor = ABM.COLOR_WHITE
	MyTheme.AddButtonTheme("greenbutton")
	MyTheme.Button("greenbutton").menuhoverbackcolor = ABM.COLOR_GREY
	MyTheme.Button("greenbutton").menuhoverbackcolorintensity = ABM.INTENSITY_LIGHTEN3
	MyTheme.Button("greenbutton").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Button("greenbutton").forecolor = ABM.COLOR_WHITE
	MyTheme.Button("greenbutton").menudividercolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("greenbutton").menuforecolor = ABM.COLOR_BLACK
	MyTheme.Button("greenbutton").backcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("greenbutton").menuforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("greenbutton").waveseffect = ABM.WAVESEFFECT_DEFAULT
	MyTheme.Button("greenbutton").wavescircle = False
	MyTheme.Button("greenbutton").backcolor = ABM.COLOR_GREEN
	MyTheme.Button("greenbutton").forecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("greenbutton").menudividercolor = ABM.COLOR_LIGHTBLUE
	MyTheme.Button("greenbutton").menubackcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("greenbutton").menubackcolor = ABM.COLOR_WHITE
	MyTheme.AddButtonTheme("orangeaccent4button")
	MyTheme.Button("orangeaccent4button").menuhoverbackcolor = ABM.COLOR_GREY
	MyTheme.Button("orangeaccent4button").menuhoverbackcolorintensity = ABM.INTENSITY_LIGHTEN3
	MyTheme.Button("orangeaccent4button").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Button("orangeaccent4button").forecolor = ABM.COLOR_WHITE
	MyTheme.Button("orangeaccent4button").menudividercolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("orangeaccent4button").menuforecolor = ABM.COLOR_BLACK
	MyTheme.Button("orangeaccent4button").backcolorintensity = ABM.INTENSITY_ACCENT4
	MyTheme.Button("orangeaccent4button").menuforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("orangeaccent4button").waveseffect = ABM.WAVESEFFECT_DEFAULT
	MyTheme.Button("orangeaccent4button").wavescircle = False
	MyTheme.Button("orangeaccent4button").backcolor = ABM.COLOR_ORANGE
	MyTheme.Button("orangeaccent4button").forecolorintensity = ABM.INTENSITY_ACCENT4
	MyTheme.Button("orangeaccent4button").menudividercolor = ABM.COLOR_LIGHTBLUE
	MyTheme.Button("orangeaccent4button").menubackcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("orangeaccent4button").menubackcolor = ABM.COLOR_WHITE
	MyTheme.AddButtonTheme("orangebutton")
	MyTheme.Button("orangebutton").menuhoverbackcolor = ABM.COLOR_GREY
	MyTheme.Button("orangebutton").menuhoverbackcolorintensity = ABM.INTENSITY_LIGHTEN3
	MyTheme.Button("orangebutton").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Button("orangebutton").forecolor = ABM.COLOR_WHITE
	MyTheme.Button("orangebutton").menudividercolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("orangebutton").menuforecolor = ABM.COLOR_BLACK
	MyTheme.Button("orangebutton").backcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("orangebutton").menuforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("orangebutton").waveseffect = ABM.WAVESEFFECT_DEFAULT
	MyTheme.Button("orangebutton").wavescircle = False
	MyTheme.Button("orangebutton").backcolor = ABM.COLOR_ORANGE
	MyTheme.Button("orangebutton").forecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("orangebutton").menudividercolor = ABM.COLOR_LIGHTBLUE
	MyTheme.Button("orangebutton").menubackcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("orangebutton").menubackcolor = ABM.COLOR_WHITE
	MyTheme.AddButtonTheme("redbutton")
	MyTheme.Button("redbutton").menuhoverbackcolor = ABM.COLOR_GREY
	MyTheme.Button("redbutton").menuhoverbackcolorintensity = ABM.INTENSITY_LIGHTEN3
	MyTheme.Button("redbutton").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Button("redbutton").forecolor = ABM.COLOR_WHITE
	MyTheme.Button("redbutton").menudividercolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("redbutton").menuforecolor = ABM.COLOR_BLACK
	MyTheme.Button("redbutton").backcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("redbutton").menuforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("redbutton").waveseffect = ABM.WAVESEFFECT_DEFAULT
	MyTheme.Button("redbutton").wavescircle = False
	MyTheme.Button("redbutton").backcolor = ABM.COLOR_RED
	MyTheme.Button("redbutton").forecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("redbutton").menudividercolor = ABM.COLOR_LIGHTBLUE
	MyTheme.Button("redbutton").menubackcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("redbutton").menubackcolor = ABM.COLOR_WHITE
	MyTheme.AddButtonTheme("tealbutton")
	MyTheme.Button("tealbutton").menuhoverbackcolor = ABM.COLOR_GREY
	MyTheme.Button("tealbutton").menuhoverbackcolorintensity = ABM.INTENSITY_LIGHTEN3
	MyTheme.Button("tealbutton").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Button("tealbutton").forecolor = ABM.COLOR_WHITE
	MyTheme.Button("tealbutton").menudividercolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("tealbutton").menuforecolor = ABM.COLOR_BLACK
	MyTheme.Button("tealbutton").backcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("tealbutton").menuforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("tealbutton").waveseffect = ABM.WAVESEFFECT_DEFAULT
	MyTheme.Button("tealbutton").wavescircle = False
	MyTheme.Button("tealbutton").backcolor = ABM.COLOR_TEAL
	MyTheme.Button("tealbutton").forecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("tealbutton").menudividercolor = ABM.COLOR_LIGHTBLUE
	MyTheme.Button("tealbutton").menubackcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("tealbutton").menubackcolor = ABM.COLOR_WHITE
	MyTheme.AddButtonTheme("yellowbutton")
	MyTheme.Button("yellowbutton").menuhoverbackcolor = ABM.COLOR_GREY
	MyTheme.Button("yellowbutton").menuhoverbackcolorintensity = ABM.INTENSITY_LIGHTEN3
	MyTheme.Button("yellowbutton").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Button("yellowbutton").forecolor = ABM.COLOR_WHITE
	MyTheme.Button("yellowbutton").menudividercolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("yellowbutton").menuforecolor = ABM.COLOR_BLACK
	MyTheme.Button("yellowbutton").backcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("yellowbutton").menuforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("yellowbutton").waveseffect = ABM.WAVESEFFECT_DEFAULT
	MyTheme.Button("yellowbutton").wavescircle = False
	MyTheme.Button("yellowbutton").backcolor = ABM.COLOR_YELLOW
	MyTheme.Button("yellowbutton").forecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("yellowbutton").menudividercolor = ABM.COLOR_LIGHTBLUE
	MyTheme.Button("yellowbutton").menubackcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Button("yellowbutton").menubackcolor = ABM.COLOR_WHITE
	MyTheme.AddCellTheme("centercontent")
	MyTheme.Cell("centercontent").clickable = False
	MyTheme.Cell("centercontent").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Cell("centercontent").backcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Cell("centercontent").align = ABM.CELL_ALIGN_CENTER
	MyTheme.Cell("centercontent").bordercolor = ABM.COLOR_TRANSPARENT
	MyTheme.Cell("centercontent").bordercolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Cell("centercontent").clickablewavescircle = False
	MyTheme.Cell("centercontent").borderwidth = 0
	MyTheme.Cell("centercontent").backcolor = ABM.COLOR_TRANSPARENT
	MyTheme.Cell("centercontent").clickablewaveseffect = ABM.WAVESEFFECT_DEFAULT
	MyTheme.Cell("centercontent").verticalalign = False
	MyTheme.AddCellTheme("zdepthcell")
	MyTheme.Cell("zdepthcell").borderradiustopleftpx = 0
	MyTheme.Cell("zdepthcell").borderradiusbottomrightpx = 0
	MyTheme.Cell("zdepthcell").clickable = False
	MyTheme.Cell("zdepthcell").borderradiuspx = 0
	MyTheme.Cell("zdepthcell").zdepth = ABM.ZDEPTH_1
	MyTheme.Cell("zdepthcell").backcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Cell("zdepthcell").align = ABM.CELL_ALIGN_LEFT
	MyTheme.Cell("zdepthcell").bordercolor = ABM.COLOR_TRANSPARENT
	MyTheme.Cell("zdepthcell").borderradiustoprightpx = 0
	MyTheme.Cell("zdepthcell").bordercolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Cell("zdepthcell").clickablewavescircle = False
	MyTheme.Cell("zdepthcell").borderwidth = 0
	MyTheme.Cell("zdepthcell").backcolor = ABM.COLOR_TRANSPARENT
	MyTheme.Cell("zdepthcell").borderradiusbottomleftpx = 0
	MyTheme.Cell("zdepthcell").clickablewaveseffect = ABM.WAVESEFFECT_DEFAULT
	MyTheme.Cell("zdepthcell").verticalalign = False
	MyTheme.AddCellTheme("rightcontent")
	MyTheme.Cell("rightcontent").borderradiustopleftpx = 0
	MyTheme.Cell("rightcontent").borderradiusbottomrightpx = 0
	MyTheme.Cell("rightcontent").clickable = False
	MyTheme.Cell("rightcontent").borderradiuspx = 0
	MyTheme.Cell("rightcontent").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Cell("rightcontent").backcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Cell("rightcontent").align = ABM.CELL_ALIGN_RIGHT
	MyTheme.Cell("rightcontent").bordercolor = ABM.COLOR_TRANSPARENT
	MyTheme.Cell("rightcontent").borderradiustoprightpx = 0
	MyTheme.Cell("rightcontent").bordercolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Cell("rightcontent").clickablewavescircle = False
	MyTheme.Cell("rightcontent").borderwidth = 0
	MyTheme.Cell("rightcontent").backcolor = ABM.COLOR_TRANSPARENT
	MyTheme.Cell("rightcontent").borderradiusbottomleftpx = 0
	MyTheme.Cell("rightcontent").borderstyle = ABM.BORDER_DEFAULT
	MyTheme.Cell("rightcontent").clickablewaveseffect = ABM.WAVESEFFECT_DEFAULT
	MyTheme.Cell("rightcontent").verticalalign = False
	MyTheme.AddCheckboxTheme("cb")
	MyTheme.Checkbox("cb").checkedcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Checkbox("cb").labelcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Checkbox("cb").checkedcolor = "askteencoach"
	MyTheme.Checkbox("cb").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Checkbox("cb").labelcolor = ABM.COLOR_BLACK
	MyTheme.AddComboTheme("cbo")
	MyTheme.Combo("cbo").inputcolor = ABM.COLOR_BLACK
	MyTheme.Combo("cbo").contentbackcolorintensity = ABM.INTENSITY_LIGHTEN3
	MyTheme.Combo("cbo").validcolor = ABM.COLOR_GREEN
	MyTheme.Combo("cbo").validcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Combo("cbo").contentbackcolor = ABM.COLOR_GREY
	MyTheme.Combo("cbo").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Combo("cbo").forecolor = ABM.COLOR_GREY
	MyTheme.Combo("cbo").backcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Combo("cbo").invalidcolor = ABM.COLOR_RED
	MyTheme.Combo("cbo").invalidcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Combo("cbo").backcolor = ABM.COLOR_TRANSPARENT
	MyTheme.Combo("cbo").placeholdercolor = ABM.COLOR_GREY
	MyTheme.Combo("cbo").placeholdercolorintensity = ABM.INTENSITY_LIGHTEN1
	MyTheme.Combo("cbo").forecolorintensity = ABM.INTENSITY_DARKEN2
	MyTheme.Combo("cbo").inputcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Combo("cbo").focusforecolor = "askteencoach"
	MyTheme.Combo("cbo").focusforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Combo("cbo").itemdividercolor = ABM.COLOR_GREY
	MyTheme.Combo("cbo").itemdividercolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.AddContainerTheme("footertheme")
	MyTheme.Container("footertheme").backcolor = "askteencoach"
	MyTheme.Container("footertheme").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Container("footertheme").backcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.AddContainerTheme("headertheme")
	MyTheme.Container("headertheme").backcolor = "askteencoach"
	MyTheme.Container("headertheme").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Container("headertheme").backcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.AddContainerTheme("login")
	MyTheme.Container("login").zdepth = ABM.ZDEPTH_2
	MyTheme.AddDateTimePickerTheme("dp")
	MyTheme.DateTimePicker("dp").pickercalendarclockbackcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.DateTimePicker("dp").pickerheaderdateyearforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.DateTimePicker("dp").pickercalendardaynamesforecolor = ABM.COLOR_GREY
	MyTheme.DateTimePicker("dp").inputcolor = ABM.COLOR_BLACK
	MyTheme.DateTimePicker("dp").pickercalendarclockbackcolor = ABM.COLOR_WHITE
	MyTheme.DateTimePicker("dp").pickerclockinactivehandcolorintensity = ABM.INTENSITY_DARKEN1
	MyTheme.DateTimePicker("dp").pickerheaderdatemonthforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.DateTimePicker("dp").pickercalendardayforecolor = ABM.COLOR_BLACK
	MyTheme.DateTimePicker("dp").pickerclockactivehandcolor = "askteencoach"
	MyTheme.DateTimePicker("dp").pickerheaderdatearrowscolor = ABM.COLOR_WHITE
	MyTheme.DateTimePicker("dp").pickerclockactivehandcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.DateTimePicker("dp").inputinvalidcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.DateTimePicker("dp").pickercalendardayactiveforecolor = ABM.COLOR_WHITE
	MyTheme.DateTimePicker("dp").inputinvalidcolor = ABM.COLOR_RED
	MyTheme.DateTimePicker("dp").pickerheaderdaynamebackcolor = "askteencoach"
	MyTheme.DateTimePicker("dp").pickerclockhourminactivebackcolor = "askteencoach"
	MyTheme.DateTimePicker("dp").pickerclockhourminforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.DateTimePicker("dp").pickerheaderdatebackcolor = "askteencoach"
	MyTheme.DateTimePicker("dp").pickerclockinactivehandcolor = ABM.COLOR_GREY
	MyTheme.DateTimePicker("dp").inputforecolor = ABM.COLOR_GREY
	MyTheme.DateTimePicker("dp").pickerheaderdatemonthforecolor = ABM.COLOR_WHITE
	MyTheme.DateTimePicker("dp").pickercalendardayactivebackcolor = "askteencoach"
	MyTheme.DateTimePicker("dp").pickerheaderdatearrowscolorintensity = ABM.INTENSITY_DARKEN3
	MyTheme.DateTimePicker("dp").pickercalendarclockbuttonbackcolor = ABM.COLOR_TRANSPARENT
	MyTheme.DateTimePicker("dp").pickerheaderdatedayforecolor = ABM.COLOR_WHITE
	MyTheme.DateTimePicker("dp").pickercalendardayactivebackcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.DateTimePicker("dp").pickercalendardaynamesforecolorintensity = ABM.INTENSITY_DARKEN2
	MyTheme.DateTimePicker("dp").inputzdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.DateTimePicker("dp").pickerclockcenterbackcolor = ABM.COLOR_GREY
	MyTheme.DateTimePicker("dp").pickercalendarclockforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.DateTimePicker("dp").pickerclockbackcolor = ABM.COLOR_GREY
	MyTheme.DateTimePicker("dp").pickercalendardayforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.DateTimePicker("dp").inputbackcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.DateTimePicker("dp").inputvalidcolor = ABM.COLOR_GREEN
	MyTheme.DateTimePicker("dp").pickerheaderdaynameforecolor = ABM.COLOR_WHITE
	MyTheme.DateTimePicker("dp").pickerclockhourminactiveforecolor = ABM.COLOR_WHITE
	MyTheme.DateTimePicker("dp").pickerclockbackcolorintensity = ABM.INTENSITY_LIGHTEN1
	MyTheme.DateTimePicker("dp").inputbackcolor = ABM.COLOR_TRANSPARENT
	MyTheme.DateTimePicker("dp").pickerheaderdaynameforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.DateTimePicker("dp").pickercalendarclockforecolor = ABM.COLOR_BLACK
	MyTheme.DateTimePicker("dp").pickercalendardayactiveforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.DateTimePicker("dp").inputfocusforecolor = "askteencoach"
	MyTheme.DateTimePicker("dp").pickercalendarclockbuttonforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.DateTimePicker("dp").pickerheaderdaynamebackcolorintensity = ABM.INTENSITY_DARKEN2
	MyTheme.DateTimePicker("dp").pickercalendarclockbuttonforecolor = "askteencoach"
	MyTheme.DateTimePicker("dp").inputcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.DateTimePicker("dp").pickerheaderdateyearforecolor = ABM.COLOR_WHITE
	MyTheme.DateTimePicker("dp").pickerclockcenterbackcolorintensity = ABM.INTENSITY_DARKEN1
	MyTheme.DateTimePicker("dp").pickerclockhourminactivebackcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.DateTimePicker("dp").inputforecolorintensity = ABM.INTENSITY_DARKEN2
	MyTheme.DateTimePicker("dp").pickercalendarclockbuttonbackcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.DateTimePicker("dp").pickerheaderdatedayforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.DateTimePicker("dp").inputfocusforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.DateTimePicker("dp").pickerclockhourminforecolor = ABM.COLOR_BLACK
	MyTheme.DateTimePicker("dp").pickerheaderdatebackcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.DateTimePicker("dp").pickerclockhourminactiveforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.DateTimePicker("dp").inputvalidcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.AddDateTimeScrollerTheme("ds")
	MyTheme.DateTimeScroller("ds").scrollerforecolor = "askteencoach"
	MyTheme.DateTimeScroller("ds").inputfocusforecolor = "askteencoach"
	MyTheme.AddEditorTheme("edt")
	MyTheme.AddFileManagerTheme("fm")
	MyTheme.FileManager("fm").fileactiveforecolor = "askteencoach"
	MyTheme.FileManager("fm").headerfooterbackgroundcolor = "askteencoach"
	MyTheme.FileManager("fm").sidebaractiveforecolor = "askteencoach"
	MyTheme.FileManager("fm").listheaderforecolor = "askteencoach"
	MyTheme.AddImageSliderTheme("slidertheme")
	MyTheme.ImageSlider("slidertheme").subtitleforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.ImageSlider("slidertheme").inactivebulletcolor = ABM.COLOR_GREY
	MyTheme.ImageSlider("slidertheme").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.ImageSlider("slidertheme").backcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.ImageSlider("slidertheme").indicators = True
	MyTheme.ImageSlider("slidertheme").transition = 500
	MyTheme.ImageSlider("slidertheme").activebulletcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.ImageSlider("slidertheme").fullwidth = True
	MyTheme.ImageSlider("slidertheme").titleforecolor = ABM.COLOR_WHITE
	MyTheme.ImageSlider("slidertheme").titleforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.ImageSlider("slidertheme").activebulletcolor = ABM.COLOR_LIGHTBLUE
	MyTheme.ImageSlider("slidertheme").inactivebulletcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.ImageSlider("slidertheme").backcolor = ABM.COLOR_TRANSPARENT
	MyTheme.ImageSlider("slidertheme").subtitleforecolor = ABM.COLOR_WHITE
	MyTheme.ImageSlider("slidertheme").interval = 6000
	MyTheme.ImageSlider("slidertheme").height = 400
	MyTheme.AddImageSliderTheme("imgsld")
	MyTheme.ImageSlider("imgsld").titleforecolor = "askteencoach"
	MyTheme.ImageSlider("imgsld").activebulletcolor = "askteencoach"
	MyTheme.AddInputTheme("bold")
	MyTheme.Input("bold").inputcolor = ABM.COLOR_BLACK
	MyTheme.Input("bold").validcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Input("bold").forecolor = ABM.COLOR_GREY
	MyTheme.Input("bold").autocompletebackcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Input("bold").italic = False
	MyTheme.Input("bold").autocompletehoverforecolor = ABM.COLOR_WHITE
	MyTheme.Input("bold").autocompleteforecolor = ABM.COLOR_BLACK
	MyTheme.Input("bold").autocompletehoverbackcolor = ABM.COLOR_LIGHTBLUE
	MyTheme.Input("bold").invalidcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Input("bold").backcolor = ABM.COLOR_TRANSPARENT
	MyTheme.Input("bold").forecolorintensity = ABM.INTENSITY_DARKEN2
	MyTheme.Input("bold").inputcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Input("bold").focusforecolor = ABM.COLOR_LIGHTBLUE
	MyTheme.Input("bold").autocompletehoverbackcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Input("bold").focusforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Input("bold").validcolor = ABM.COLOR_GREEN
	MyTheme.Input("bold").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Input("bold").bold = True
	MyTheme.Input("bold").backcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Input("bold").invalidcolor = ABM.COLOR_RED
	MyTheme.Input("bold").autocompletehoverforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Input("bold").underlined = False
	MyTheme.Input("bold").autocompleteforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Input("bold").autocompletebackcolor = ABM.COLOR_WHITE
	MyTheme.AddInputTheme("inp")
	MyTheme.Input("inp").inputcolor = ABM.COLOR_BLACK
	MyTheme.Input("inp").validcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Input("inp").forecolor = ABM.COLOR_GREY
	MyTheme.Input("inp").autocompletebackcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Input("inp").italic = False
	MyTheme.Input("inp").autocompletehoverforecolor = ABM.COLOR_WHITE
	MyTheme.Input("inp").autocompleteforecolor = ABM.COLOR_BLACK
	MyTheme.Input("inp").autocompletehoverbackcolor = "askteencoach"
	MyTheme.Input("inp").autocompletezdepth = ABM.ZDEPTH_1
	MyTheme.Input("inp").invalidcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Input("inp").backcolor = ABM.COLOR_TRANSPARENT
	MyTheme.Input("inp").placeholdercolor = ABM.COLOR_WHITE
	MyTheme.Input("inp").forecolorintensity = ABM.INTENSITY_DARKEN2
	MyTheme.Input("inp").inputcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Input("inp").focusforecolor = "askteencoach"
	MyTheme.Input("inp").autocompletehoverbackcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Input("inp").focusforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Input("inp").validcolor = ABM.COLOR_GREEN
	MyTheme.Input("inp").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Input("inp").bold = False
	MyTheme.Input("inp").backcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Input("inp").invalidcolor = ABM.COLOR_RED
	MyTheme.Input("inp").autocompletehoverforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Input("inp").underlined = False
	MyTheme.Input("inp").autocompleteforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Input("inp").autocompletebackcolor = ABM.COLOR_WHITE
	MyTheme.AddLabelTheme("centerlabel")
	MyTheme.Label("centerlabel").blockquotecolor = ABM.COLOR_LIGHTBLUE
	MyTheme.Label("centerlabel").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Label("centerlabel").forecolor = ABM.COLOR_BLACK
	MyTheme.Label("centerlabel").backcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Label("centerlabel").align = ABM.INPUT_TEXTALIGN_CENTER
	MyTheme.Label("centerlabel").backcolor = ABM.COLOR_TRANSPARENT
	MyTheme.Label("centerlabel").strikethroughcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Label("centerlabel").forecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Label("centerlabel").blockquotecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Label("centerlabel").iconcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Label("centerlabel").iconcolor = ABM.COLOR_BLACK
	MyTheme.AddLabelTheme("rightlabel")
	MyTheme.Label("rightlabel").blockquotecolor = ABM.COLOR_LIGHTBLUE
	MyTheme.Label("rightlabel").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Label("rightlabel").forecolor = ABM.COLOR_BLACK
	MyTheme.Label("rightlabel").backcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Label("rightlabel").align = ABM.INPUT_TEXTALIGN_RIGHT
	MyTheme.Label("rightlabel").backcolor = ABM.COLOR_TRANSPARENT
	MyTheme.Label("rightlabel").strikethroughcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Label("rightlabel").forecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Label("rightlabel").blockquotecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Label("rightlabel").iconcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Label("rightlabel").iconcolor = ABM.COLOR_BLACK
	MyTheme.AddLabelTheme("lbl")
	MyTheme.Label("lbl").blockquotecolor = "askteencoach"
	MyTheme.Label("lbl").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Label("lbl").forecolor = ABM.COLOR_BLACK
	MyTheme.Label("lbl").backcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Label("lbl").align = ABM.TEXTALIGN_LEFT
	MyTheme.Label("lbl").backcolor = ABM.COLOR_TRANSPARENT
	MyTheme.Label("lbl").strikethroughcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Label("lbl").forecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Label("lbl").blockquotecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Label("lbl").iconcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Label("lbl").iconcolor = ABM.COLOR_BLACK
	MyTheme.AddLabelTheme("whitefc")
	MyTheme.Label("whitefc").blockquotecolor = ABM.COLOR_LIGHTBLUE
	MyTheme.Label("whitefc").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Label("whitefc").forecolor = ABM.COLOR_WHITE
	MyTheme.Label("whitefc").backcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Label("whitefc").align = ABM.INPUT_TEXTALIGN_START
	MyTheme.Label("whitefc").backcolor = ABM.COLOR_TRANSPARENT
	MyTheme.Label("whitefc").strikethroughcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Label("whitefc").forecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Label("whitefc").blockquotecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Label("whitefc").iconcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Label("whitefc").iconcolor = ABM.COLOR_BLACK
	MyTheme.AddLabelTheme("green")
	MyTheme.Label("green").blockquotecolor = ABM.COLOR_LIGHTBLUE
	MyTheme.Label("green").forecolor = ABM.COLOR_GREEN
	MyTheme.Label("green").align = ABM.TEXTALIGN_CENTER
	MyTheme.Label("green").iconcolor = ABM.COLOR_GREEN
	MyTheme.AddLabelTheme("yellow")
	MyTheme.Label("yellow").blockquotecolor = ABM.COLOR_LIGHTBLUE
	MyTheme.Label("yellow").forecolor = ABM.COLOR_YELLOW
	MyTheme.Label("yellow").align = ABM.TEXTALIGN_CENTER
	MyTheme.Label("yellow").iconcolor = ABM.COLOR_YELLOW
	MyTheme.AddLabelTheme("red")
	MyTheme.Label("red").blockquotecolor = ABM.COLOR_LIGHTBLUE
	MyTheme.Label("red").forecolor = ABM.COLOR_RED
	MyTheme.Label("red").align = ABM.TEXTALIGN_CENTER
	MyTheme.Label("red").iconcolor = ABM.COLOR_RED
	MyTheme.AddLabelTheme("white")
	MyTheme.Label("white").blockquotecolor = ABM.COLOR_LIGHTBLUE
	MyTheme.Label("white").forecolor = ABM.COLOR_WHITE
	MyTheme.Label("white").align = ABM.TEXTALIGN_CENTER
	MyTheme.Label("white").iconcolor = ABM.COLOR_WHITE
	MyTheme.AddLabelTheme("lightblue")
	MyTheme.Label("lightblue").blockquotecolor = ABM.COLOR_LIGHTBLUE
	MyTheme.Label("lightblue").forecolor = "askteencoach"
	MyTheme.Label("lightblue").forecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Label("lightblue").iconcolor = ABM.COLOR_BLACK
	MyTheme.AddLabelTheme("justify")
	MyTheme.Label("justify").blockquotecolor = ABM.COLOR_LIGHTBLUE
	MyTheme.Label("justify").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Label("justify").backcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Label("justify").align = ABM.TEXTALIGN_JUSTIFY
	MyTheme.Label("justify").backcolor = ABM.COLOR_TRANSPARENT
	MyTheme.Label("justify").strikethroughcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Label("justify").forecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Label("justify").blockquotecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Label("justify").iconcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Label("justify").iconcolor = ABM.COLOR_BLACK
	MyTheme.AddLabelTheme("whiteheading")
	MyTheme.Label("whiteheading").forecolor = ABM.COLOR_WHITE
	MyTheme.AddModalSheetTheme("drpw")
	MyTheme.ModalSheet("drpw").footerbackcolorintensity = ABM.INTENSITY_LIGHTEN2
	MyTheme.ModalSheet("drpw").contentbackcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.ModalSheet("drpw").contentbackcolor = ABM.COLOR_TRANSPARENT
	MyTheme.ModalSheet("drpw").headerbackcolorintensity = ABM.INTENSITY_LIGHTEN2
	MyTheme.ModalSheet("drpw").headerbackcolor = ABM.COLOR_BROWN
	MyTheme.ModalSheet("drpw").footerbackcolor = ABM.COLOR_BROWN
	MyTheme.AddModalSheetTheme("ModalSheetTheme")
	MyTheme.ModalSheet("ModalSheetTheme").contentbackcolor = ABM.COLOR_WHITE
	MyTheme.AddModalSheetTheme("ms")
	MyTheme.ModalSheet("ms").contentbackcolor = ABM.COLOR_WHITE
	MyTheme.ModalSheet("ms").headerbackcolor = "askteencoach"
	MyTheme.ModalSheet("ms").footerbackcolor = "askteencoach"
	MyTheme.AddNavigationBarTheme("drpw")
	MyTheme.NavigationBar("drpw").sidebarbackcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.NavigationBar("drpw").sidebarbackcolor = ABM.COLOR_WHITE
	MyTheme.NavigationBar("drpw").sidebardividercolor = ABM.COLOR_BROWN
	MyTheme.NavigationBar("drpw").topbarbackcolorintensity = ABM.INTENSITY_LIGHTEN2
	MyTheme.NavigationBar("drpw").topbaractiveforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.NavigationBar("drpw").topbarsubdividercolor = ABM.COLOR_LIGHTBLUE
	MyTheme.NavigationBar("drpw").topbartitlecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.NavigationBar("drpw").topbarsubbackcolor = ABM.COLOR_WHITE
	MyTheme.NavigationBar("drpw").sidebarsubwaveseffect = ABM.WAVESEFFECT_DEFAULT
	MyTheme.NavigationBar("drpw").sidebarsubbackcolor = ABM.COLOR_WHITE
	MyTheme.NavigationBar("drpw").sidebaractiveforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.NavigationBar("drpw").sidebarsubhoverbackcolor = ABM.COLOR_GREY
	MyTheme.NavigationBar("drpw").sidebarsubwavescircle = False
	MyTheme.NavigationBar("drpw").sidebarsubbold = False
	MyTheme.NavigationBar("drpw").sidebarsubiconsize = "1.6rem"
	MyTheme.NavigationBar("drpw").topbaractiveforecolor = ABM.COLOR_WHITE
	MyTheme.NavigationBar("drpw").topbarsubforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.NavigationBar("drpw").topbarsubhoverbackcolorintensity = ABM.INTENSITY_LIGHTEN3
	MyTheme.NavigationBar("drpw").topbarwavescircle = False
	MyTheme.NavigationBar("drpw").sidebarsubforecolorintensity = ABM.INTENSITY_DARKEN2
	MyTheme.NavigationBar("drpw").topbarbold = False
	MyTheme.NavigationBar("drpw").sidebarhoverbackcolorintensity = ABM.INTENSITY_LIGHTEN3
	MyTheme.NavigationBar("drpw").topbarwaveseffect = ABM.WAVESEFFECT_DEFAULT
	MyTheme.NavigationBar("drpw").topbartitlecolor = ABM.COLOR_WHITE
	MyTheme.NavigationBar("drpw").sidebarsubforecolor = ABM.COLOR_BROWN
	MyTheme.NavigationBar("drpw").sidebarhoverbackcolor = ABM.COLOR_GREY
	MyTheme.NavigationBar("drpw").sidebarwavescircle = False
	MyTheme.NavigationBar("drpw").sidebarsubactiveforecolor = ABM.COLOR_BLACK
	MyTheme.NavigationBar("drpw").sidebarwaveseffect = ABM.WAVESEFFECT_DEFAULT
	MyTheme.NavigationBar("drpw").topbarsubbackcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.NavigationBar("drpw").topbarsubforecolor = ABM.COLOR_BLACK
	MyTheme.NavigationBar("drpw").sidebarsubdividercolor = ABM.COLOR_BROWN
	MyTheme.NavigationBar("drpw").sidebarsubbackcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.NavigationBar("drpw").sidebarsubactiveforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.NavigationBar("drpw").topbarsubhoverbackcolor = ABM.COLOR_GREY
	MyTheme.NavigationBar("drpw").sidebardividercolorintensity = ABM.INTENSITY_LIGHTEN2
	MyTheme.NavigationBar("drpw").sidebarforecolorintensity = ABM.INTENSITY_DARKEN2
	MyTheme.NavigationBar("drpw").sidebaractiveforecolor = ABM.COLOR_BLACK
	MyTheme.NavigationBar("drpw").topbarforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.NavigationBar("drpw").sidebarsubhoverbackcolorintensity = ABM.INTENSITY_LIGHTEN3
	MyTheme.NavigationBar("drpw").sidebarbold = False
	MyTheme.NavigationBar("drpw").topbariconsize = "1.6rem"
	MyTheme.NavigationBar("drpw").topbarsubdividercolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.NavigationBar("drpw").sidebarsubdividercolorintensity = ABM.INTENSITY_LIGHTEN2
	MyTheme.NavigationBar("drpw").topbarbackcolor = ABM.COLOR_BROWN
	MyTheme.NavigationBar("drpw").sidebarforecolor = ABM.COLOR_BROWN
	MyTheme.NavigationBar("drpw").sidebariconsize = "1.6rem"
	MyTheme.NavigationBar("drpw").topbarforecolor = ABM.COLOR_WHITE
	MyTheme.AddNavigationBarTheme("nb")
	MyTheme.NavigationBar("nb").sidebarbackcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.NavigationBar("nb").logozdepth = ABM.ZDEPTH_REMOVE
	MyTheme.NavigationBar("nb").sidebarbackcolor = ABM.COLOR_WHITE
	MyTheme.NavigationBar("nb").sidebardividercolor = "askteencoach"
	MyTheme.NavigationBar("nb").topbarbackcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.NavigationBar("nb").topbaractiveforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.NavigationBar("nb").topbarsubdividercolor = "askteencoach"
	MyTheme.NavigationBar("nb").topbarzdepth = ABM.ZDEPTH_REMOVE
	MyTheme.NavigationBar("nb").topbartitlecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.NavigationBar("nb").topbarsubbackcolor = ABM.COLOR_WHITE
	MyTheme.NavigationBar("nb").sidebarsubwaveseffect = ABM.WAVESEFFECT_DEFAULT
	MyTheme.NavigationBar("nb").sidebarzdepth = ABM.ZDEPTH_REMOVE
	MyTheme.NavigationBar("nb").sidebarsubbackcolor = ABM.COLOR_WHITE
	MyTheme.NavigationBar("nb").sidebaractiveforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.NavigationBar("nb").sidebarsubhoverbackcolor = ABM.COLOR_GREY
	MyTheme.NavigationBar("nb").sidebarsubwavescircle = False
	MyTheme.NavigationBar("nb").sidebarsubbold = False
	MyTheme.NavigationBar("nb").sidebarsubiconsize = "1.6rem"
	MyTheme.NavigationBar("nb").topbaractiveforecolor = ABM.COLOR_WHITE
	MyTheme.NavigationBar("nb").topbarsubforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.NavigationBar("nb").topbarsubhoverbackcolorintensity = ABM.INTENSITY_LIGHTEN3
	MyTheme.NavigationBar("nb").topbarwavescircle = False
	MyTheme.NavigationBar("nb").sidebarsubforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.NavigationBar("nb").topbarbold = False
	MyTheme.NavigationBar("nb").sidebarhoverbackcolorintensity = ABM.INTENSITY_LIGHTEN3
	MyTheme.NavigationBar("nb").topbarwaveseffect = ABM.WAVESEFFECT_DEFAULT
	MyTheme.NavigationBar("nb").topbartitlecolor = ABM.COLOR_WHITE
	MyTheme.NavigationBar("nb").sidebarsubforecolor = "askteencoach"
	MyTheme.NavigationBar("nb").sidebarhoverbackcolor = ABM.COLOR_GREY
	MyTheme.NavigationBar("nb").sidebarwavescircle = False
	MyTheme.NavigationBar("nb").sidebarsubactiveforecolor = ABM.COLOR_BLACK
	MyTheme.NavigationBar("nb").sidebarwaveseffect = ABM.WAVESEFFECT_DEFAULT
	MyTheme.NavigationBar("nb").topbarsubbackcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.NavigationBar("nb").topbarsubforecolor = "askteencoach"
	MyTheme.NavigationBar("nb").sidebarsubdividercolor = "askteencoach"
	MyTheme.NavigationBar("nb").sidebarsubbackcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.NavigationBar("nb").sidebarsubactiveforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.NavigationBar("nb").topbarsubhoverbackcolor = ABM.COLOR_GREY
	MyTheme.NavigationBar("nb").sidebardividercolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.NavigationBar("nb").sidebarforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.NavigationBar("nb").sidebaractiveforecolor = ABM.COLOR_BLACK
	MyTheme.NavigationBar("nb").topbarforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.NavigationBar("nb").sidebarsubhoverbackcolorintensity = ABM.INTENSITY_LIGHTEN3
	MyTheme.NavigationBar("nb").sidebarbold = False
	MyTheme.NavigationBar("nb").topbariconsize = "1.6rem"
	MyTheme.NavigationBar("nb").topbarsubdividercolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.NavigationBar("nb").sidebarsubdividercolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.NavigationBar("nb").topbarbackcolor = "askteencoach"
	MyTheme.NavigationBar("nb").sidebarforecolor = "askteencoach"
	MyTheme.NavigationBar("nb").sidebariconsize = "1.6rem"
	MyTheme.NavigationBar("nb").topbarforecolor = ABM.COLOR_WHITE
	MyTheme.AddPaginationTheme("pt")
	MyTheme.Pagination("pt").activepageforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Pagination("pt").inactivepageforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Pagination("pt").activepageforecolor = "askteencoach"
	MyTheme.Pagination("pt").navigationbuttonsbackcolor = "askteencoach"
	MyTheme.Pagination("pt").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Pagination("pt").activepagebackcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Pagination("pt").navigationbuttonsforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Pagination("pt").navigationbuttonsforecolor = ABM.COLOR_WHITE
	MyTheme.Pagination("pt").activepagebackcolor = ABM.COLOR_WHITE
	MyTheme.Pagination("pt").inactivepageforecolor = ABM.COLOR_BLACK
	MyTheme.Pagination("pt").inactivepagebackcolor = ABM.COLOR_TRANSPARENT
	MyTheme.Pagination("pt").navigationbuttonsbackcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Pagination("pt").inactivepagebackcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.AddRadioGroupTheme("rg")
	MyTheme.RadioGroup("rg").radiooncolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.RadioGroup("rg").labelcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.RadioGroup("rg").titlecolor = ABM.COLOR_BLACK
	MyTheme.RadioGroup("rg").labelcolor = ABM.COLOR_BLACK
	MyTheme.RadioGroup("rg").titlecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.RadioGroup("rg").radiooncolor = "askteencoach"
	MyTheme.AddRangeTheme("rng")
	MyTheme.AddSliderTheme("sld")
	MyTheme.AddSwitchTheme("st")
	MyTheme.Switch("st").switchoffcolor = ABM.COLOR_GREY
	MyTheme.Switch("st").titlecolor = ABM.COLOR_GREY
	MyTheme.Switch("st").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Switch("st").baroffcolor = ABM.COLOR_GREY
	MyTheme.Switch("st").labelcolor = ABM.COLOR_BLACK
	MyTheme.Switch("st").titlecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Switch("st").switchoffcolorintensity = ABM.INTENSITY_LIGHTEN2
	MyTheme.Switch("st").labelfontsize = "0.8rem"
	MyTheme.Switch("st").baroncolor = "askteencoach"
	MyTheme.Switch("st").baroncolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Switch("st").switchoncolor = "askteencoach"
	MyTheme.Switch("st").labelcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Switch("st").switchoncolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Switch("st").baroffcolorintensity = ABM.INTENSITY_LIGHTEN2
	MyTheme.AddTableTheme("tblTheme")
	MyTheme.Table("tblTheme").zdepth = ABM.ZDEPTH_1
	MyTheme.AddToastTheme("toastgreen")
	MyTheme.Toast("toastgreen").actionforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Toast("toastgreen").backcolor = ABM.COLOR_GREEN
	MyTheme.Toast("toastgreen").forecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Toast("toastgreen").actionforecolor = ABM.COLOR_BLACK
	MyTheme.Toast("toastgreen").rounded = True
	MyTheme.Toast("toastgreen").forecolor = ABM.COLOR_WHITE
	MyTheme.Toast("toastgreen").backcolorintensity = ABM.INTENSITY_DARKEN2
	MyTheme.AddToastTheme("toastred")
	MyTheme.Toast("toastred").actionforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Toast("toastred").backcolor = ABM.COLOR_RED
	MyTheme.Toast("toastred").forecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Toast("toastred").actionforecolor = ABM.COLOR_BLACK
	MyTheme.Toast("toastred").rounded = True
	MyTheme.Toast("toastred").forecolor = ABM.COLOR_WHITE
	MyTheme.Toast("toastred").backcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.AddUploadTheme("upl")
	MyTheme.Upload("upl").buttonbackcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Upload("upl").uploadbordercolorintensity = ABM.INTENSITY_DARKEN3
	MyTheme.Upload("upl").uploadbordercolor = "askteencoach"
	MyTheme.Upload("upl").errorcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Upload("upl").forecolor = "askteencoach"
	MyTheme.Upload("upl").uploadprogresscolor = "askteencoach"
	MyTheme.Upload("upl").buttonbackcolor = "askteencoach"
	MyTheme.Upload("upl").backcolor = "askteencoach"
	MyTheme.Upload("upl").forecolorintensity = ABM.INTENSITY_DARKEN1
	MyTheme.Upload("upl").uploadbackcolorintensity = ABM.INTENSITY_DARKEN2
	MyTheme.Upload("upl").buttonforecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Upload("upl").uploadfilesizecolor = ABM.COLOR_WHITE
	MyTheme.Upload("upl").dropzonebackcolor = "askteencoach"
	MyTheme.Upload("upl").dropzonebackcolorintensity = ABM.INTENSITY_DARKEN3
	MyTheme.Upload("upl").buttonhoverbackcolor = "askteencoach"
	MyTheme.Upload("upl").uploadfilesizecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Upload("upl").buttonhoverbackcolorintensity = ABM.INTENSITY_LIGHTEN1
	MyTheme.Upload("upl").errorcolor = ABM.COLOR_WHITE
	MyTheme.Upload("upl").zdepth = ABM.ZDEPTH_1
	MyTheme.Upload("upl").buttonforecolor = ABM.COLOR_WHITE
	MyTheme.Upload("upl").backcolorintensity = ABM.INTENSITY_DARKEN2
	MyTheme.Upload("upl").uploadfilecolor = ABM.COLOR_WHITE
	MyTheme.Upload("upl").uploadprogresscolorintensity = ABM.INTENSITY_LIGHTEN1
	MyTheme.Upload("upl").uploadfilecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Upload("upl").uploadbackcolor = "askteencoach"
	MyTheme.Table("tblTheme").AddCellTheme("negative")
	MyTheme.Table("tblTheme").Cell("negative").activebackcolor = ABM.COLOR_RED
	MyTheme.Table("tblTheme").Cell("negative").forecolor = ABM.COLOR_BLACK
	MyTheme.Table("tblTheme").Cell("negative").align = ABM.TABLECELL_HORIZONTALALIGN_LEFT
	MyTheme.Table("tblTheme").Cell("negative").bordercolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("negative").backcolor = ABM.COLOR_RED
	MyTheme.Table("tblTheme").Cell("negative").strikethroughcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("negative").forecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("negative").verticalalign = False
	MyTheme.Table("tblTheme").Cell("negative").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Table("tblTheme").Cell("negative").backcolorintensity = ABM.INTENSITY_LIGHTEN3
	MyTheme.Table("tblTheme").Cell("negative").bordercolor = ABM.COLOR_TRANSPARENT
	MyTheme.Table("tblTheme").Cell("negative").borderwidth = 0
	MyTheme.Table("tblTheme").Cell("negative").activebackcolorintensity = ABM.INTENSITY_LIGHTEN1
	MyTheme.Table("tblTheme").AddCellTheme("yellow")
	MyTheme.Table("tblTheme").Cell("yellow").activebackcolor = ABM.COLOR_YELLOW
	MyTheme.Table("tblTheme").Cell("yellow").forecolor = ABM.COLOR_BLACK
	MyTheme.Table("tblTheme").Cell("yellow").align = ABM.TABLECELL_HORIZONTALALIGN_LEFT
	MyTheme.Table("tblTheme").Cell("yellow").bordercolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("yellow").backcolor = ABM.COLOR_YELLOW
	MyTheme.Table("tblTheme").Cell("yellow").strikethroughcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("yellow").forecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("yellow").verticalalign = False
	MyTheme.Table("tblTheme").Cell("yellow").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Table("tblTheme").Cell("yellow").backcolorintensity = ABM.INTENSITY_LIGHTEN3
	MyTheme.Table("tblTheme").Cell("yellow").bordercolor = ABM.COLOR_TRANSPARENT
	MyTheme.Table("tblTheme").Cell("yellow").borderwidth = 0
	MyTheme.Table("tblTheme").Cell("yellow").activebackcolorintensity = ABM.INTENSITY_LIGHTEN1
	MyTheme.Table("tblTheme").AddCellTheme("gray")
	MyTheme.Table("tblTheme").Cell("gray").activebackcolor = ABM.COLOR_GREY
	MyTheme.Table("tblTheme").Cell("gray").forecolor = ABM.COLOR_BLACK
	MyTheme.Table("tblTheme").Cell("gray").align = ABM.TABLECELL_HORIZONTALALIGN_LEFT
	MyTheme.Table("tblTheme").Cell("gray").bordercolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("gray").backcolor = ABM.COLOR_GREY
	MyTheme.Table("tblTheme").Cell("gray").strikethroughcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("gray").forecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("gray").verticalalign = False
	MyTheme.Table("tblTheme").Cell("gray").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Table("tblTheme").Cell("gray").backcolorintensity = ABM.INTENSITY_LIGHTEN3
	MyTheme.Table("tblTheme").Cell("gray").bordercolor = ABM.COLOR_TRANSPARENT
	MyTheme.Table("tblTheme").Cell("gray").borderwidth = 0
	MyTheme.Table("tblTheme").Cell("gray").activebackcolorintensity = ABM.INTENSITY_LIGHTEN1
	MyTheme.Table("tblTheme").AddCellTheme("orange")
	MyTheme.Table("tblTheme").Cell("orange").activebackcolor = ABM.COLOR_ORANGE
	MyTheme.Table("tblTheme").Cell("orange").forecolor = ABM.COLOR_BLACK
	MyTheme.Table("tblTheme").Cell("orange").align = ABM.TABLECELL_HORIZONTALALIGN_LEFT
	MyTheme.Table("tblTheme").Cell("orange").bordercolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("orange").backcolor = ABM.COLOR_ORANGE
	MyTheme.Table("tblTheme").Cell("orange").strikethroughcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("orange").forecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("orange").verticalalign = False
	MyTheme.Table("tblTheme").Cell("orange").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Table("tblTheme").Cell("orange").backcolorintensity = ABM.INTENSITY_LIGHTEN3
	MyTheme.Table("tblTheme").Cell("orange").bordercolor = ABM.COLOR_TRANSPARENT
	MyTheme.Table("tblTheme").Cell("orange").borderwidth = 0
	MyTheme.Table("tblTheme").Cell("orange").activebackcolorintensity = ABM.INTENSITY_LIGHTEN1
	MyTheme.Table("tblTheme").AddCellTheme("positive")
	MyTheme.Table("tblTheme").Cell("positive").activebackcolor = ABM.COLOR_GREEN
	MyTheme.Table("tblTheme").Cell("positive").forecolor = ABM.COLOR_BLACK
	MyTheme.Table("tblTheme").Cell("positive").align = ABM.TABLECELL_HORIZONTALALIGN_LEFT
	MyTheme.Table("tblTheme").Cell("positive").bordercolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("positive").backcolor = ABM.COLOR_GREEN
	MyTheme.Table("tblTheme").Cell("positive").strikethroughcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("positive").forecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("positive").verticalalign = False
	MyTheme.Table("tblTheme").Cell("positive").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Table("tblTheme").Cell("positive").backcolorintensity = ABM.INTENSITY_LIGHTEN3
	MyTheme.Table("tblTheme").Cell("positive").bordercolor = ABM.COLOR_TRANSPARENT
	MyTheme.Table("tblTheme").Cell("positive").borderwidth = 0
	MyTheme.Table("tblTheme").Cell("positive").activebackcolorintensity = ABM.INTENSITY_LIGHTEN1
	MyTheme.Table("tblTheme").AddCellTheme("nocolor")
	MyTheme.Table("tblTheme").Cell("nocolor").activebackcolor = ABM.COLOR_BLUEGREY
	MyTheme.Table("tblTheme").Cell("nocolor").forecolor = ABM.COLOR_BLACK
	MyTheme.Table("tblTheme").Cell("nocolor").align = ABM.TABLECELL_HORIZONTALALIGN_LEFT
	MyTheme.Table("tblTheme").Cell("nocolor").bordercolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("nocolor").backcolor = ABM.COLOR_TRANSPARENT
	MyTheme.Table("tblTheme").Cell("nocolor").strikethroughcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("nocolor").forecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("nocolor").verticalalign = False
	MyTheme.Table("tblTheme").Cell("nocolor").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Table("tblTheme").Cell("nocolor").backcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("nocolor").bordercolor = ABM.COLOR_TRANSPARENT
	MyTheme.Table("tblTheme").Cell("nocolor").borderwidth = 0
	MyTheme.Table("tblTheme").Cell("nocolor").activebackcolorintensity = ABM.INTENSITY_LIGHTEN2
	MyTheme.Table("tblTheme").AddCellTheme("bgc")
	MyTheme.Table("tblTheme").Cell("bgc").activebackcolor = ABM.COLOR_LIGHTBLUE
	MyTheme.Table("tblTheme").Cell("bgc").forecolor = ABM.COLOR_WHITE
	MyTheme.Table("tblTheme").Cell("bgc").align = ABM.TABLECELL_HORIZONTALALIGN_CENTER
	MyTheme.Table("tblTheme").Cell("bgc").bordercolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("bgc").backcolor = "askteencoach"
	MyTheme.Table("tblTheme").Cell("bgc").strikethroughcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("bgc").forecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("bgc").verticalalign = False
	MyTheme.Table("tblTheme").Cell("bgc").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Table("tblTheme").Cell("bgc").backcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("bgc").bordercolor = ABM.COLOR_TRANSPARENT
	MyTheme.Table("tblTheme").Cell("bgc").borderwidth = 0
	MyTheme.Table("tblTheme").Cell("bgc").activebackcolorintensity = ABM.INTENSITY_LIGHTEN3
	MyTheme.Table("tblTheme").AddCellTheme("openedit")
	MyTheme.Table("tblTheme").Cell("openedit").activebackcolor = ABM.COLOR_BLUEGREY
	MyTheme.Table("tblTheme").Cell("openedit").forecolor = ABM.COLOR_BLACK
	MyTheme.Table("tblTheme").Cell("openedit").align = ABM.TABLECELL_HORIZONTALALIGN_CENTER
	MyTheme.Table("tblTheme").Cell("openedit").bordercolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("openedit").backcolor = ABM.COLOR_TRANSPARENT
	MyTheme.Table("tblTheme").Cell("openedit").strikethroughcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("openedit").forecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("openedit").verticalalign = False
	MyTheme.Table("tblTheme").Cell("openedit").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Table("tblTheme").Cell("openedit").backcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("openedit").bordercolor = ABM.COLOR_TRANSPARENT
	MyTheme.Table("tblTheme").Cell("openedit").borderwidth = 0
	MyTheme.Table("tblTheme").Cell("openedit").activebackcolorintensity = ABM.INTENSITY_LIGHTEN2
	MyTheme.Table("tblTheme").AddCellTheme("bgr")
	MyTheme.Table("tblTheme").Cell("bgr").activebackcolor = ABM.COLOR_LIGHTBLUE
	MyTheme.Table("tblTheme").Cell("bgr").forecolor = ABM.COLOR_WHITE
	MyTheme.Table("tblTheme").Cell("bgr").align = ABM.TABLECELL_HORIZONTALALIGN_RIGHT
	MyTheme.Table("tblTheme").Cell("bgr").bordercolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("bgr").backcolor = "askteencoach"
	MyTheme.Table("tblTheme").Cell("bgr").strikethroughcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("bgr").forecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("bgr").verticalalign = False
	MyTheme.Table("tblTheme").Cell("bgr").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Table("tblTheme").Cell("bgr").backcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("bgr").bordercolor = ABM.COLOR_TRANSPARENT
	MyTheme.Table("tblTheme").Cell("bgr").borderwidth = 0
	MyTheme.Table("tblTheme").Cell("bgr").activebackcolorintensity = ABM.INTENSITY_LIGHTEN3
	MyTheme.Table("tblTheme").AddCellTheme("bg")
	MyTheme.Table("tblTheme").Cell("bg").activebackcolor = ABM.COLOR_LIGHTBLUE
	MyTheme.Table("tblTheme").Cell("bg").forecolor = ABM.COLOR_WHITE
	MyTheme.Table("tblTheme").Cell("bg").align = ABM.TABLECELL_HORIZONTALALIGN_LEFT
	MyTheme.Table("tblTheme").Cell("bg").bordercolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("bg").backcolor = "askteencoach"
	MyTheme.Table("tblTheme").Cell("bg").strikethroughcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("bg").forecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("bg").verticalalign = False
	MyTheme.Table("tblTheme").Cell("bg").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Table("tblTheme").Cell("bg").backcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("bg").bordercolor = ABM.COLOR_TRANSPARENT
	MyTheme.Table("tblTheme").Cell("bg").borderwidth = 0
	MyTheme.Table("tblTheme").Cell("bg").activebackcolorintensity = ABM.INTENSITY_LIGHTEN3
	MyTheme.Table("tblTheme").AddCellTheme("nocolorr")
	MyTheme.Table("tblTheme").Cell("nocolorr").activebackcolor = ABM.COLOR_BLUEGREY
	MyTheme.Table("tblTheme").Cell("nocolorr").forecolor = ABM.COLOR_BLACK
	MyTheme.Table("tblTheme").Cell("nocolorr").align = ABM.TABLECELL_HORIZONTALALIGN_RIGHT
	MyTheme.Table("tblTheme").Cell("nocolorr").bordercolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("nocolorr").backcolor = ABM.COLOR_TRANSPARENT
	MyTheme.Table("tblTheme").Cell("nocolorr").strikethroughcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("nocolorr").forecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("nocolorr").verticalalign = False
	MyTheme.Table("tblTheme").Cell("nocolorr").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Table("tblTheme").Cell("nocolorr").backcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("nocolorr").bordercolor = ABM.COLOR_TRANSPARENT
	MyTheme.Table("tblTheme").Cell("nocolorr").borderwidth = 0
	MyTheme.Table("tblTheme").Cell("nocolorr").activebackcolorintensity = ABM.INTENSITY_LIGHTEN2
	MyTheme.Table("tblTheme").AddCellTheme("nocolorc")
	MyTheme.Table("tblTheme").Cell("nocolorc").activebackcolor = ABM.COLOR_BLUEGREY
	MyTheme.Table("tblTheme").Cell("nocolorc").forecolor = ABM.COLOR_BLACK
	MyTheme.Table("tblTheme").Cell("nocolorc").align = ABM.TABLECELL_HORIZONTALALIGN_CENTER
	MyTheme.Table("tblTheme").Cell("nocolorc").bordercolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("nocolorc").backcolor = ABM.COLOR_TRANSPARENT
	MyTheme.Table("tblTheme").Cell("nocolorc").strikethroughcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("nocolorc").forecolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("nocolorc").verticalalign = False
	MyTheme.Table("tblTheme").Cell("nocolorc").zdepth = ABM.ZDEPTH_DEFAULT
	MyTheme.Table("tblTheme").Cell("nocolorc").backcolorintensity = ABM.INTENSITY_NORMAL
	MyTheme.Table("tblTheme").Cell("nocolorc").bordercolor = ABM.COLOR_TRANSPARENT
	MyTheme.Table("tblTheme").Cell("nocolorc").borderwidth = 0
	MyTheme.Table("tblTheme").Cell("nocolorc").activebackcolorintensity = ABM.INTENSITY_LIGHTEN2
End Sub
Sub Len(Text As String) As Int
	Return Text.Length
End Sub
Sub LogOff(page As ABMPage)
	Dim Network As String = page.ws.Session.GetAttribute("authType")
	Dim Name As String = page.ws.Session.GetAttribute("authName")
	Select Case Network
		Case "local","network"
			' do whatever you have to do to log off your user
			page.ws.Session.SetAttribute("UserID", "")
			page.ws.Session.SetAttribute("UserEmail", "")
			page.ws.Session.SetAttribute("authType", "")
			page.ws.Session.SetAttribute("authName", "")
			page.ws.Session.SetAttribute("IsAuthorized", "")
			ABM.DeleteLogin(page, AppName)
			NavigateToPage(page.ws, page.GetPageID, "../")
		Case ABM.SOCIALOAUTH_FACEBOOK
			' the event SignedOffSocialNetwork will be raised on the page, do the rest there
			page.SignOffSocialNetwork(Network, "", Name)
	End Select
End Sub
Sub Date2String(date As Long, withTime As Boolean) As String
	Dim OrigFormat As String=DateTime.DateFormat
	If withTime Then
		DateTime.DateFormat="yyyy-MM-dd'T'HH:mm:ss"
	Else
		DateTime.DateFormat="yyyy-MM-dd"
	End If
	Dim MyDate As String =DateTime.Date(date)
	DateTime.DateFormat=OrigFormat
	Return MyDate
End Sub
Sub String2Date(date As String) As Long
	Dim lng As Long
	Dim OrigFormat As String=DateTime.DateFormat
	If date.Length > 10 Then
		DateTime.DateFormat = "yyyy-MM-dd"
		DateTime.DateFormat = "HH:mm:ss"
		Dim d As String = date.SubString2(0,11)
		Dim t As String = date.SubString(12)
		lng = DateTime.DateTimeParse(d,t)
	Else
		DateTime.DateFormat = "yyyy-MM-dd"
		lng = DateTime.Dateparse(date)
	End If
	DateTime.DateFormat=OrigFormat
	Return lng
End Sub
Sub Mid(Text As String, Start As Int, Length As Int) As String
	Return Text.SubString2(Start-1,Start+Length-1)
End Sub
Sub ReplaceAll(Text As String, Pattern As String, Replacement As String) As String
	Dim jo As JavaObject = Regex.Matcher(Pattern, Text)
	Return jo.RunMethod("replaceAll", Array(Replacement))
End Sub
Sub Mid2(Text As String, Start As Int) As String
	Return Text.SubString(Start-1)
End Sub
Public Sub BuildImage(page As ABMPage, id As String, image As String, opacity As Double, Caption As String) As ABMImage
	Dim img As ABMImage
	img.Initialize(page, id, image,opacity)
	img.IsMaterialBoxed = True
	img.IsResponsive = True
	img.Caption = Caption
	Return img
End Sub
public Sub BuildHeader(page As ABMPage, id As String, Text As String) As ABMLabel
	Dim hdr As ABMLabel
	hdr.Initialize(page, id, Text, ABM.SIZE_H5, False, "lightblue")
	Return hdr
End Sub
public Sub BuildSubHeader(page As ABMPage, id As String, Text As String) As ABMLabel
	Dim shdr As ABMLabel
	shdr.Initialize(page, id, Text, ABM.SIZE_H5, False, "")
	Return shdr
End Sub
public Sub BuildLink(page As ABMPage, id As String, Text As String, http As String) As ABMLabel
	Dim sLink As String = $"{AL}${http}{AT}${Text}{/AL}"$
	Dim lbl As ABMLabel
	lbl.Initialize(page, id, sLink , ABM.SIZE_PARAGRAPH, False, "justify")
	lbl.tag = http
	Return lbl
End Sub
public Sub BuildParagraph(page As ABMPage, id As String, Text As String, sClickable As String, sTag As String) As ABMLabel
	Dim lbl As ABMLabel
	lbl.Initialize(page, id, Text , ABM.SIZE_PARAGRAPH, False, "justify")
	If sClickable = "1" Then
		lbl.SetCursor(ABM.CURSOR_POINTING)
		lbl.Clickable = True
	End If
	lbl.tag = sTag
	Return lbl
End Sub
public Sub BuildParagraphBQ(page As ABMPage, id As String, Text As String) As ABMLabel
	Dim lbl As ABMLabel
	lbl.Initialize(page, id, Text , ABM.SIZE_PARAGRAPH, False, "")
	lbl.IsBlockQuote = True
	Return lbl
End Sub
public Sub BuildSpan(page As ABMPage, id As String, Text As String) As ABMLabel
	Dim lbl As ABMLabel
	lbl.Initialize(page, id, Text , ABM.SIZE_SPAN, False, "")
	Return lbl
End Sub
public Sub BuildCodeBlock(page As ABMPage, id As String, code As StringBuilder) As ABMCodeLabel
	Dim codelab As ABMCodeLabel
	codelab.Initialize(page, id, code.ToString, "vb")
	Return codelab
End Sub
public Sub BuildCodeBlockFromSmartString(page As ABMPage, id As String, code As String) As ABMCodeLabel
	Dim codelab As ABMCodeLabel
	codelab.Initialize(page, id, code, "vb")
	Return codelab
End Sub
public Sub BuildIconBlock(page As ABMPage, id As String, iconName As String) As ABMContainer
	Dim cont As ABMContainer
	cont.Initialize(page, id, "lightblue")
	cont.AddRows(2,False, "").AddCells12(1,"")
	cont.BuildGrid ' IMPORTANT
	' to help see how the grids looks like in the log
	' cont.DebugPrintGrid
	Dim lblicon As ABMLabel
	lblicon.Initialize(page, id & "icon", "", ABM.SIZE_H5, False, "whitefc")
	lblicon.IconName = iconName
	lblicon.IconSize = ABM.ICONSIZE_MEDIUM
	cont.Cell(1,1).AddComponent(lblicon)
	Dim lbliconName As ABMLabel
	lbliconName.Initialize(page, id & "lbl", iconName, ABM.SIZE_SPAN, False, "whitefc")
	cont.Cell(2,1).AddComponent(lbliconName)
	Return cont
End Sub
Sub BuildFooter(page As ABMPage, Visibility As String)
	page.Footer.AddRows(1, True, "").AddCellsOS(2,0,0,0,6,6,6, "")
	page.Footer.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
	page.Footer.UseTheme("footertheme")
	page.Footer.Visibility = Visibility
End Sub
Sub ConnectFooter(page As ABMPage, leftContent As String, rightContent As String)
	Dim lbl1 As ABMLabel
	lbl1.Initialize(page, "footlbl1", leftContent,ABM.SIZE_PARAGRAPH, False, "whitefc")
	page.Footer.Cell(1,1).AddComponent(lbl1)
	Dim lbl2 As ABMLabel
	lbl2.Initialize(page, "footlbl2", rightContent,ABM.SIZE_PARAGRAPH, False, "whitefc")
	page.Footer.Cell(1,2).AddComponent(lbl2)
End Sub
Sub BuildFooterFixed(page As ABMPage, PaddingBottom As Int, Visibility As String)
	page.isFixedFooter= True
	' because we have a fixed footer at the bottom, we have to adjust the padding of the body in pixels
	page.PaddingBottom = PaddingBottom
	page.Footer.AddRows(1, True, "").AddCellsOS(2,0,0,0,6,6,6, "")
	page.Footer.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
	page.Footer.UseTheme("footertheme")
	page.Footer.Visibility = Visibility
End Sub
public Sub BuildParamTable(page As ABMPage, id As String, Headers As List, Names As List, Descriptions As List) As ABMTable
	Dim tbl As ABMTable
	tbl.Initialize(page, id, False, False, False, "Params")
	tbl.IgnoreFormattingCodes = True ' build in to ignore formatting tags
	Dim themesx As List
	themesx.Initialize2(Array As String("header","header"))
	tbl.SetHeaders(Headers)
	tbl.SetHeaderThemes(themesx)
	themesx.Initialize2(Array As String("name","description"))
	For i = 0 To Names.Size - 1
		Dim Values As List
		Values.Initialize
		Values.Add( Names.Get(i))
		Values.Add( Descriptions.Get(i))
		tbl.AddRow("uid" & i, Values)
		tbl.SetRowThemes(themesx)
	Next
	Return tbl
End Sub
public Sub BuildParamTable2(page As ABMPage, id As String, Headers As List, Names As List, Descriptions As List) As ABMTable
	Dim tbl As ABMTable
	tbl.Initialize(page, id, False, False, False, "Params")
	Dim Themesx As List
	Themesx.Initialize2(Array As String("header","header"))
	tbl.SetHeaders(Headers)
	tbl.SetHeaderThemes(Themesx)
	Themesx.Initialize2(Array As String("name","description"))
	For i = 0 To Names.Size - 1
		Dim Values As List
		Values.Initialize
		Values.Add( Names.Get(i))
		Values.Add( Descriptions.Get(i))
		tbl.AddRow("uid" & i, Values)
		tbl.SetRowThemes(Themesx)
	Next
	Return tbl
End Sub
'Define a connection to MySQL server
Sub MySQLConnectionString(serverIP As String,  serverPort As String, serverDB As String) As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("jdbc:mysql://").Append(serverIP).Append(":").Append(serverPort).Append("/").Append(serverDB)
	Return sb.tostring
End Sub
'Define a connection string to Microsoft SQL server
Sub MSSQLConnectionString(serverIP As String,  serverPort As String, serverDB As String) As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("jdbc:jtds:sqlserver://").Append(serverIP).Append(":").Append(serverPort).Append("/").Append(serverDB)
	Return sb.tostring
End Sub
'Initialize a connection to SQLite database
Sub InitializeSQLite(Dir As String, fileName As String, createIfNeeded As Boolean) 'ignore
	SQLite.InitializeSQLite(Dir, fileName, createIfNeeded)
	SQLite.ExecNonQuery("PRAGMA journal_mode = wal")
	DatabaseType = 0
End Sub
'Initialize a connection to MySQL server and returns True if successful
Sub InitializeMySQL(serverIP As String,  serverPort As String, serverDB As String, login As String, password As String, poolSize As Int) As Boolean
	Log("init mysql")
	DatabaseType = 1
	UsePool = True
	Try
		Dim jdbcUrl As String
		jdbcUrl = MySQLConnectionString(serverIP,serverPort,serverDB)
		pool.Initialize("com.mysql.jdbc.Driver", jdbcUrl, login, password)
		' change pool size...
		Dim jo As JavaObject = pool
		jo.RunMethod("setMaxPoolSize", Array(poolSize))
		Return True
	Catch
		Log("Last Pool Init Except: "&LastException.Message)
		Return False
	End Try
End Sub
'Initialize a connection to Microsoft SQL server
Sub InitializeMSSQL(serverIP As String,  serverPort As String, serverDB As String ,login As String, password As String, poolSize As Int) As Boolean
	DatabaseType = 2
	Try
		Dim jdbcUrl As String
		jdbcUrl = MSSQLConnectionString(serverIP,serverPort,serverDB)
		pool.Initialize("net.sourceforge.jtds.jdbc.Driver", jdbcUrl, login, password)
		' change pool size...
		Dim jo As JavaObject = pool
		jo.RunMethod("setMaxPoolSize", Array(poolSize))
		Return True
	Catch
		Log("Last Pool Init Except: " & LastException.Message)
		Return False
	End Try
End Sub
'Update a single mapped record and return true if successful
Sub SQLRecordUpdate(jSQL As SQL, TableName As String, Fields As Map, PrimaryKey As String, PrimaryValue As String) As Boolean
	Dim w As Map
	w.Initialize
	w.Put(PrimaryKey, PrimaryValue)
	Return SQLRecordUpdateWhere(jSQL,TableName,Fields,w)
End Sub
'Update a mapped record and return true if successful
Sub SQLRecordUpdateWhere(jSQL As SQL, TableName As String, Fields As Map, WhereFieldEquals As Map) As Boolean
	If WhereFieldEquals.Size = 0 Then
		Log("WhereFieldEquals map empty!")
		Return False
	End If
	If Fields.Size = 0 Then
		Log("Fields empty")
		Return False
	End If
	Dim sb As StringBuilder
	jSQL.BeginTransaction
	Try
		sb.Initialize
		sb.Append("UPDATE ").Append(TableName).Append(" SET ")
		Dim args As List
		args.Initialize
		For i=0 To Fields.Size-1
			If i<>Fields.Size-1 Then
				sb.Append(Fields.GetKeyAt(i)).Append("=?,")
			Else
				sb.Append(Fields.GetKeyAt(i)).Append("=?")
			End If
			args.Add(Fields.GetValueAt(i))
		Next
		sb.Append(" WHERE ")
		For i = 0 To WhereFieldEquals.Size - 1
			If i > 0 Then
				sb.Append(" AND ")
			End If
			sb.Append(WhereFieldEquals.GetKeyAt(i)).Append(" = ?")
			args.Add(WhereFieldEquals.GetValueAt(i))
		Next
		Log("UpdateRecord: " & sb.ToString)
		jSQL.ExecNonQuery2(sb.ToString, args)
		jSQL.TransactionSuccessful
		Return True
	Catch
		Log("UpdateRecord2 Error: " & LastException)
		jSQL.Rollback
		Return False
	End Try
End Sub
'Insert a single map record and return true if successful
Sub SQLRecordInsert(jSQL As SQL, TableName As String, nRecord As Map) As Int
	Dim nList As List
	nList.Initialize
	nList.Add(nRecord)
	Return SQLRecordInsertMaps(jSQL, TableName, nList)
End Sub
'Insert Mapped Records to database and return true if successful
Sub SQLRecordInsertMaps(jSQL As SQL, TableName As String, ListOfMaps As List) As Int
	Dim res As Int
	Dim sb, columns, values As StringBuilder
	'Small check for a common error where the same map is used in a loop
	If ListOfMaps.Size > 1 And ListOfMaps.Get(0) = ListOfMaps.Get(1) Then
		Log("Same Map found twice in list. Each item in the list should include a different map object.")
		Return DBERROR
	End If
	jSQL.BeginTransaction
	Try
		For i1 = 0 To ListOfMaps.Size - 1
			sb.Initialize
			columns.Initialize
			values.Initialize
			Dim listOfValues As List
			listOfValues.Initialize
			sb.Append("INSERT INTO " & TableName & " (")
			Dim m As Map
			m = ListOfMaps.Get(i1)
			For i2 = 0 To m.Size - 1
				Dim col As String
				Dim value As Object
				col = m.GetKeyAt(i2)
				value = m.GetValueAt(i2)
				If i2 > 0 Then
					columns.Append(", ")
					values.Append(", ")
				End If
				columns.Append(col)
				values.Append("?")
				listOfValues.Add(value)
			Next
			sb.Append(columns.ToString)
			sb.Append(") VALUES (")
			sb.Append(values.ToString)
			sb.Append(")")
			If i1 = 0 Then Log("InsertMaps (first query out of " & ListOfMaps.Size & "): " & sb.ToString)
			Log("InsertMaps: " & sb.ToString)
			jSQL.ExecNonQuery2(sb.ToString, listOfValues)
		Next
		jSQL.TransactionSuccessful
		If UsePool Then
			res = SQLSelectSingleResult(jSQL, "SELECT LAST_INSERT_ID()",Null)
		Else
			res = SQLSelectSingleResult(jSQL, "SELECT last_insert_rowid()",Null)
		End If
		Return res
	Catch
		Log("InsertMaps Error: " & LastException)
		jSQL.Rollback
		Return DBERROR
	End Try
End Sub
'Get a connection to SQL server
Sub SQLGet() As SQL
	If DatabaseType = 0 Then
		Return SQLite
	Else
		Return pool.GetConnection
	End If
End Sub
'Close the database connection
Sub SQLClose(mySQL As SQL)
	If DatabaseType <> 0 Then
		mySQL.Close
	End If
End Sub
'Determines if a record exists and returns true
Sub SQLRecordExists(jSQL As SQL, TableName As String, PrimField As String, PrimValue As String) As Boolean
	Dim mr As Map = SQLExecuteMap(jSQL, "SELECT " & PrimField & " From " & TableName & " WHERE " & PrimField & " = ?", Array As String(PrimValue))
	If mr.IsInitialized = False Then
		Return False
	Else
		Return True
	End If
End Sub
'Execute a select query and returns a single record
Sub SQLExecuteMap(jSQL As SQL, Query As String, StringArgs() As String) As Map
	Log("SQLExecuteMap: " & Query)
	Dim res As Map
	res.initialize
	Dim cur As ResultSet
	If StringArgs <> Null Then
		cur = jSQL.ExecQuery2(Query, StringArgs)
	Else
		cur = jSQL.ExecQuery(Query)
	End If
	If cur.NextRow = False Then
		Dim res As Map
		Log("No records found.")
		Return res
	End If
	For i = 0 To cur.ColumnCount - 1
		res.Put(cur.GetColumnName(i).ToLowerCase, cur.GetString2(i))
	Next
	cur.Close
	Return res
End Sub
'Execute a query and return a list of Mapped records
Sub SQLExecuteMaps(jSQL As SQL, Query As String, args As List) As List
	Log("SQLExecuteMaps: " & Query)
	Dim l As List
	l.Initialize
	Dim cur As ResultSet
	Try
		cur = jSQL.ExecQuery2(Query, args)
	Catch
		Log(LastException)
		Return l
	End Try
	Do While cur.NextRow
		Dim res As Map
		res.Initialize
		For i = 0 To cur.ColumnCount - 1
			res.Put(cur.GetColumnName(i).ToLowerCase, cur.GetString2(i))
		Next
		l.Add(res)
	Loop
	cur.Close
	Return l
End Sub
'Read a record from the database and return it as a map
Sub SQLRecordRead(jSQL As SQL, TableName As String, PrimaryKey As String, PrimaryValue As String) As Map
	Return SQLExecuteMap(jSQL, "SELECT * FROM " & TableName & " WHERE " & PrimaryKey & " = ?",Array As String(PrimaryValue))
End Sub
'Delete single/multiple records specifying a primary key
Sub SQLRecordDelete(jSQL As SQL, TableName As String, KeyField As String, KeyValue As String) As Boolean
	Dim w As Map
	w.Initialize
	w.Put(KeyField,KeyValue)
	Return SQLRecordDeleteWhere(jSQL,TableName,w)
End Sub
Sub SQLRecordDeleteWhere(jSQL As SQL, TableName As String, WhereFieldEquals As Map) As Boolean
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("DELETE FROM ").Append(TableName).Append(" WHERE ")
	If WhereFieldEquals.Size = 0 Then
		Log("WhereFieldEquals map empty!")
		Return False
	End If
	Dim args As List
	args.Initialize
	For i = 0 To WhereFieldEquals.Size - 1
		If i > 0 Then sb.Append(" AND ")
		sb.Append(WhereFieldEquals.GetKeyAt(i)).Append(" = ?")
		args.Add(WhereFieldEquals.GetValueAt(i))
	Next
	Log("DeleteRecord: " & sb.ToString)
	jSQL.BeginTransaction
	Try
		jSQL.ExecNonQuery2(sb.ToString, args)
		jSQL.TransactionSuccessful
		Return True
	Catch
		jSQL.Rollback
		Return False
	End Try
End Sub
Sub SQLSelectSingleResult(jSQL As SQL, Query As String, Args As List) As String
	Dim res As String
	Try
		res = jSQL.ExecQuerySingleResult2(Query, Args)
	Catch
		Log(LastException)
		res = DBERROR
	End Try
	If res = Null Then
		res = DBNORESULTS
	End If
	Return res
End Sub
Public Sub BuildSideBarComponent(page As ABMPage, id As String, image As String, Title As String, Subtitle As String, IsCircular As Boolean) As ABMContainer
	Dim ItemCont As ABMContainer
	ItemCont.Initialize(page, id, "")
	ItemCont.AddRowsM(1,False,0,0, "").AddCellsOSMP(1,0,0,0,3,3,3,4,0,0,0,"").AddCellsOSMP(1,0,0,0,9,9,9,4,0,0,0,"")
	ItemCont.AddRowsM(1,False,0,0, "").AddCells12(1, "")
	ItemCont.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
	Dim SubItemCont As ABMContainer
	SubItemCont.Initialize(page, id & "SubItemCont", "")
	SubItemCont.AddRowsM(1,False, 0,0,"").AddCells12MP(1,-6,0,0,0,"").AddCells12(1,"")
	SubItemCont.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
	ItemCont.Cell(1,2).AddComponent(SubItemCont)
	Dim img As ABMImage
	img.Initialize(page, id & "img", image, 1)
	img.SetFixedSize(48,48)
	img.IsCircular = IsCircular
	img.IsResponsive = True
	ItemCont.Cell(1,1).AddComponent(img)
	Dim lbl1 As ABMLabel
	lbl1.Initialize(page, id & "lbl1", Title, ABM.SIZE_H6, False, "lightblue")
	lbl1.VerticalAlign = True
	SubItemCont.Cell(1,1).AddComponent(lbl1)
	Dim lbl2 As ABMLabel
	lbl2.Initialize(page, id & "lbl2", Subtitle, ABM.SIZE_H6, False, "")
	lbl2.VerticalAlign = True
	SubItemCont.Cell(1,2).AddComponent(lbl2)
	Return ItemCont
End Sub
Public Sub BuildSideBarTopComponent(page As ABMPage, id As String, image As String, Title As String, Subtitle As String, IsCircular As Boolean) As ABMContainer
	' important!
	'page.NeedsChart = true
	Dim ItemCont As ABMContainer
	ItemCont.Initialize(page, id, "")
	ItemCont.AddRowsM(1,False,0,0, "").AddCellsOSMP(1,0,0,0,3,3,3,4,0,0,0,"").AddCellsOSMP(1,0,0,0,9,9,9,4,0,0,0,"")
	ItemCont.AddRowsM(1,False,0,0, "").AddCellsOSMP(1,0,0,0,12,12,12,0,0,0,0,"")
	ItemCont.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
	Dim SubItemCont As ABMContainer
	SubItemCont.Initialize(page, id & "SubItemCont", "")
	SubItemCont.AddRowsM(1,False, 0,0,"").AddCells12MP(1,-6,0,0,0,"").AddCells12(1,"")
	SubItemCont.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
	ItemCont.Cell(1,2).AddComponent(SubItemCont)
	Dim img As ABMImage
	img.Initialize(page, id & "img", image, 1)
	img.SetFixedSize(48,48)
	img.IsCircular = IsCircular
	img.IsResponsive = True
	ItemCont.Cell(1,1).AddComponent(img)
	Dim lbl1 As ABMLabel
	lbl1.Initialize(page, id & "lbl1", Title, ABM.SIZE_H6, False, "whitefc")
	lbl1.VerticalAlign = True
	SubItemCont.Cell(1,1).AddComponent(lbl1)
	Dim lbl2 As ABMLabel
	lbl2.Initialize(page, id & "lbl2", Subtitle, ABM.SIZE_H6, False, "whitefc")
	lbl2.VerticalAlign = True
	SubItemCont.Cell(1,2).AddComponent(lbl2)
	Return ItemCont
End Sub
Sub BuildFiche(page As ABMPage, id As String, Title As String, SubTitle As String, Body As String, pic As String, picCaption As String, themeName As String) As ABMContainer
	Dim Fiche As ABMContainer
	Fiche.Initialize(page, "fiche" & id, "")
	Fiche.AddRowsM(1, False,0,0, themeName).AddCellsOSMP(1,0,0,0,12,12,12,0,12,10,10,"")
	Fiche.AddRowsM(1, True,0,0, "").AddCellsOSMP(1,0,0,0,12,12,12,0,0,0,0,"")
	Fiche.BuildGrid
	Fiche.Row(1).MarginLeft = "0"
	Fiche.Row(1).MarginRight = "0"
	Dim titLabel As ABMLabel
	titLabel.Initialize(page, "titlabel" & id, Title, ABM.SIZE_H5,False, "white")
	Fiche.Cell(1,1).AddComponent(titLabel)
	Dim titLabel2 As ABMLabel
	titLabel2.Initialize(page, "titlabel2_" & id, SubTitle, ABM.SIZE_H6,False, "white")
	Fiche.Cell(1,1).AddComponent(titLabel2)
	If pic <> "" Then
		Fiche.Cell(2,1).AddComponent(BuildImage(page, "ficheimg" & id, pic,1, picCaption))
	End If
	Dim lbody As ABMLabel
	lbody.Initialize(page, "body" & id, Body, ABM.SIZE_PARAGRAPH, True, "")
	Fiche.Cell(2,1).AddComponent(lbody)
	Return Fiche
End Sub
Sub BuildMsgBox(page As ABMPage) As ABMModalSheet
	Dim msgbox As ABMModalSheet
	msgbox.Initialize(page, "msgbox", False, False, "ms")
	msgbox.IsDismissible = False
	msgbox.Header.AddRowsM(1, True, 0, 0, "").AddCellsOS(1, 0, 0, 0, 12, 12, 12, "")
	msgbox.Header.BuildGrid
	msgbox.Content.AddRowsM(1, True,0,0, "").AddCells12(1, "")
	msgbox.Content.BuildGrid
	' add paragraph
	msgbox.Content.CellR(0,1).AddComponent(BuildParagraph(page,"par1","message","0","") )
	msgbox.Footer.AddRowsM(1,True,0,0, "").AddCellsOS(1,0,0,0,12,12,12,"")
	msgbox.Footer.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
	Dim lblHeader As ABMLabel
	lblHeader.Initialize(page, "lblHeader", "{NBSP}Inform", ABM.SIZE_H5, False, "whitefc")
	msgbox.Header.Cell(1,1).AddComponent(lblHeader)
	' create the buttons for the footer
	Dim msgok As ABMButton
	msgok.InitializeFlat(page, "msgok", "", "", "CLOSE", "transparent")
	msgbox.Footer.Cell(1,1).AddComponent(msgok)
	Return msgbox
End Sub
Sub BuildMsgBoxYesNo(page As ABMPage) As ABMModalSheet
	Dim msg As ABMModalSheet
	msg.Initialize(page, "confirm", False, False, "ms")
	msg.IsDismissible = False
	msg.Header.AddRowsM(1, True, 0, 0, "").AddCellsOS(1, 0, 0, 0, 12, 12, 12, "")
	msg.Header.BuildGrid
	msg.Content.AddRowsM(1, True,0,0, "").AddCells12(1, "")
	msg.Content.BuildGrid
	' add paragraph
	msg.Content.CellR(0,1).AddComponent(BuildParagraph(page,"par1","Are you sure you want to delete this user?","0","") )
	msg.Footer.AddRowsM(1,True,0,0, "").AddCellsOS(1,0,0,0,12,12,12,"")
	msg.Footer.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
	' create the buttons for the footer
	Dim msgyes As ABMButton
	msgyes.InitializeFlat(page, "msgyes", "", "", "YES", "transparent")
	msg.Footer.Cell(1,1).AddComponent(msgyes)
	Dim msgno As ABMButton
	msgno.InitializeFlat(page, "msgno", "", "", "NO", "transparent")
	msg.Footer.Cell(1,1).AddComponent(msgno)
	Dim lblHeader As ABMLabel
	lblHeader.Initialize(page, "lblHeader", "{NBSP}Confirm", ABM.SIZE_H5, False, "whitefc")
	msg.Header.Cell(1,1).AddComponent(lblHeader)
	Return msg
End Sub
Sub BuildWrongInputModalSheet(page As ABMPage) As ABMModalSheet
	Dim myModalError As ABMModalSheet
	myModalError.Initialize(page, "wronginput", False, False, "ms")
	myModalError.Content.UseTheme("modalcontent")
	myModalError.Footer.UseTheme("modalcontent")
	myModalError.Header.UseTheme("modalcontent")
	myModalError.IsDismissible = True
	' create the grid for the content
	myModalError.Content.AddRows(1,True, "").AddCells12(1,"")
	myModalError.Content.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
	myModalError.Header.AddRowsM(1, True, 0, 0, "").AddCellsOS(1, 0, 0, 0, 12, 12, 12, "")
	myModalError.Header.BuildGrid
	Dim lbl1 As ABMLabel
	lbl1.Initialize(page, "errormsg", "The login or password are incorrect!",ABM.SIZE_PARAGRAPH, False, "")
	myModalError.Content.Cell(1,1).AddComponent(lbl1)
	Dim lblHeader As ABMLabel
	lblHeader.Initialize(page, "lblHeader", "{NBSP}Input", ABM.SIZE_H5, False, "whitefc")
	myModalError.Header.Cell(1,1).AddComponent(lblHeader)
	Return myModalError
End Sub
Sub ShowMsgBox(page As ABMPage, strMessage As String)
	Dim msgbox As ABMModalSheet = page.ModalSheet("msgbox")
	Dim lbl As ABMLabel = msgbox.Content.Component("par1")
	lbl.Text = strMessage
	page.ShowModalSheet("msgbox")
End Sub
Sub ShowYesNo(page As ABMPage, strMessage As String, strYes As String, strNo As String)
	Dim msg As ABMModalSheet = page.ModalSheet("confirm")
	Dim lbl As ABMLabel = msg.Content.Component("par1")
	Dim msgyes As ABMButton = msg.Footer.Component("msgyes")
	Dim msgno As ABMButton = msg.Footer.Component("msgno")
	lbl.Text = strMessage & "?"
	msgyes.Tag = strYes
	msgno.Tag = strNo
	page.ShowModalSheet("confirm")
End Sub
Sub ShowInputError(page As ABMPage, strMessage As String)
	Dim mymodalError As ABMModalSheet = page.ModalSheet("wronginput")
	Dim myModalLbl As ABMLabel= mymodalError.Content.Component("errormsg")
	myModalLbl.Text = strMessage
	page.ShowModalsheet("wronginput")
End Sub
Sub BuildNavigationBar(page As ABMPage, Title As String, logo As String, ActiveTopReturnName As String, ActiveSideReturnName As String, ActiveSideSubReturnName As String) 	'ignore
	' we have to make an ABMImage from our logo url
	Dim sbtopimg As ABMImage
	sbtopimg.Initialize(page, "sbtopimg", logo, 1)
	sbtopimg.SetFixedSize(236, 49)
	page.NavigationBar.Initialize(page, "nav1", ABM.SIDEBAR_MANUAL_HIDEMEDIUMSMALL, Title, True, True, 330, 48, sbtopimg, ABM.COLLAPSE_ACCORDION, "nav1theme")
	page.NavigationBar.TopBarDropDownConstrainWidth = False
	page.NavigationBar.ActiveTopReturnName = ActiveTopReturnName
	page.NavigationBar.ActiveSideReturnName = ActiveSideReturnName
	page.NavigationBar.ActiveSideSubReturnName = ActiveSideSubReturnName
	' you must add at least ONE dummy item if you want to add items to the topbar	in ConnectNaviagationBar
	page.NavigationBar.AddTopItem("DUMMY", "{NBSP}", "", "", False)
	' you must add at least ONE dummy item if you want to add items to the sidebar
	page.NavigationBar.AddSideBarItem("DUMMY", "{NBSP}", "", "")
End Sub
Sub ConnectNavigationBar(page As ABMPage) 'ignore
	' Clear the dummies we created in BuildNavigationBar
	page.NavigationBar.Clear
	'page.NavigationBar.AddSideBarItem("ret1", "Page 1", "", "../Page1/")
	'page.NavigationBar.AddSideBarItem("ret2", "Page 2", "", "../Page2/")
	'page.NavigationBar.AddSideBarItem("ret3", "Page 3", "", "../Page3")
	'page.NavigationBar.AddTopItemWithSideBar("sidebar", "sidebar", "", "", ABM.VISIBILITY_ALL, sb)
	' add your navigationbar items
	page.NavigationBar.Refresh ' IMPORTANT
	'myMenu.Open
End Sub
